//
package genetic;

import java.util.*;
import java.io.*;

import kbm2l.*;
import tables.*;

class EstadisticaAev {

  // Datos miembro

   // Para indicar el numero de muestras recogidas

   int muestras;

   // Para recoger los valores de fitness de los individuos considerados

   Vector objetivos;

  // Metodos miembro

   // Constructor

   EstadisticaAev() {
   
      // Creacion del vector objetivos

      objetivos=new Vector();

      // Inicializacio del numero de muestras

      muestras=0;
   }

   // Metodo para agregar valores de fitness e incrementar el numero
   // de muestras

   public void agregar_muestras(double objetivo) {
      objetivos.addElement(new Double(objetivo));
      muestras++;
   }

   // Metodo para escribir todos estos valores en un archivo

   public void mostrar_muestras() throws IOException{
    FileWriter f;
    PrintWriter p;
    int i;

      f=new FileWriter(dato30.workspace + File.separatorChar + "medidas.txt");
      p=new PrintWriter(f);

      p.println("Objetivo");
      for(i=0; i < muestras; i++) {
        p.print(((Double)objetivos.get(i)).doubleValue());
        p.println("");
      }

      f.close();
   }
}
