//
package genetic;

import java.util.*;

abstract class Seleccion {

  // Datos miembro

  Poblacion poblacion;

  // Se incluye tambien una indicacion del sentido de la busqueda
  // (MAXIMIZACION o MINIMIZACION) en el cual se usara este mecanismo
  // de seleccion
 
  boolean sentido;

  // Dato miembro para almacenar la probabilidad de seleccion,
  // parametro usado para hacer la seleccion de individuos de
  // la poblacion

  double probabilidad_seleccion;

  // Metodos miembro

   // Para la seleccion de un individuo

   abstract Individuo seleccionar();

   // Para asignar la poblacion sobre la que se trabaja

   void asignar_poblacion(Poblacion pob) {
     poblacion=pob;
   }
}
