//SYSTEM30//
package kbm2l;

//
import java.util.*;
import java.lang.*;
import java.io.*;
import java.math.*;
import java.awt.*;
//import javax.swing.JDialog;

//
import menu.*;
import tables.*;

/**
*
**/
public  class  system30  {

  private static final String ERROR = "Error(system30): ";
  protected static final int buffer = 64000;
  private static int logs = 0;
  public frame30 f30 = null;

  public TextArea taSys = null;
  private TextField tfSys = null;

/**
* Ventana de sistema.
**/
  public Frame frame = null;
/**
* Menu el sistema.
**/
  public menuBarSystem30 kbm2lMenu = null;

/**
* Constructor por defecto
**/
public system30( ) {

  return;  
}//system30

/**
* Constructor por defecto
* @param f30 frame30 
* @param TITULO String
**/
public system30( frame30 f30, String TITULO) {

  this.f30 = f30;
  frame = new Frame( "KBM2L30 - SYSTEM - " + TITULO);
  logs = 0;
  system();

  return;  
}//system30

/**
* Inicia la ventana del sistema
**/
public void system() {

//MenuApp
  kbm2lMenu = new menuBarSystem30( f30);
  frame.setMenuBar( kbm2lMenu.mainMenu);

//Layout
  GridBagConstraints C = new GridBagConstraints();
  GridBagLayout gbl = new GridBagLayout();
  frame.setLayout( gbl); 

  C.gridx = 0; C.gridy = 0;
  C.gridwidth = 1; C.gridheight = 1;
  C.fill = GridBagConstraints.BOTH;
  C.ipadx = 0; C.ipady = 0;
  C.insets = new Insets(5,5,5,5);
  C.anchor = GridBagConstraints.CENTER;
  C.weightx = 2; C.weighty = 2;
  taSys = new TextArea();
  gbl.setConstraints( taSys, C);
  frame.add( taSys);//+++

  C.gridx = 0; C.gridy = 1;
  C.gridwidth = 1; C.gridheight = 1;
  C.fill = GridBagConstraints.SOUTH;
  C.ipadx = 0; C.ipady = 0;
  C.insets = new Insets(5,5,5,5);
  C.anchor = GridBagConstraints.CENTER;
  C.weightx = 1; C.weighty = 1;
  tfSys = new TextField(80);
  gbl.setConstraints( tfSys, C);
  frame.add( tfSys);//+++
  estatus("Status bar kbm2l.");

  frame.setLocation( 0, 0);
  frame.setSize( 600, 270);
  frame.setVisible(true);
  frame.toFront();  

  setText( about());

  return;
}//system

/**
* Set texto del sistema
**/
public void setText( String str) {
  
  taSys.setText( str); 
  return;
}//setText

/**
* Get texto del sistema
**/
public String getText( ) {
     
  return taSys.getText( );
}//getText

/**
* Append texto del sistema
**/
public void append( String str) {
  
  String t = taSys.getText();
  if ( t.length() > buffer) {
	 saveText( taSys, "system-", logs++); 
    taSys.setText( str);
    } else { 
	     taSys.append( str); 
    }

  return;
}//append

/**
* Save texto del area de texto
**/
protected void saveText( TextArea ta, String prefFileName, int logs) {
     
  BufferedWriter out_t = null;// sys.txt

  try {
    out_t = new BufferedWriter( new FileWriter( dato30.workspace + (prefFileName + logs) + ".txt"));
  }//try
  catch (Exception e) {
    System.out.println( ERROR + "saveText.1");
    e.printStackTrace(); 
    System.exit( 0);
  }//catch

  int tLength = -1;
  
  try {
    String t = ta.getText( );
    tLength = t.length();
    System.out.println( "t dump: " + tLength);
    out_t.write( t, 0, tLength); 
    //out_sys.newLine();
    out_t.close();
    }//try
  catch (IOException e) {
    System.out.println( ERROR + "saveText.2" + tLength + ".");
    e.printStackTrace(); 
    System.exit( 0);
  }//catch

  return; 
}//saveText

/**
* Set Linea del mensaje de estado de la ventana de sistema
**/
public void estatus( String strEstatus) {
  
  tfSys.setText( strEstatus); 
  return;
}//estatus

/**
* Append Linea del mensaje de estado de la ventana de sistema
**/
public void Xestatus( String strEstatus) {
  
  tfSys.setText( tfSys.getText() + strEstatus); 
  return;
}//Xestatus

/**
*
**/
public String about() {

  return "KBM2L 30.0   System 30.0\n";
}//about

}//class System30
