//checkItem30//
package kernel;

//
import java.util.*;
import java.lang.*;
import java.io.*;
import java.math.*;

//
import control.*;
import kbm2l.*;

/**
* Test de validez de items de las listas kbm2l
* @author Juan A. Fdez del Pozo de Salamanca
* @version 3.0
**/
public  class  checkItem30  {

  private static final String ERROR = "Error(checkItem30): ";

/**
* Constructor por defecto
**/
public checkItem30( ) {
//

}//checkItem30

/**
* Control-Test de items
**/
protected static void checkItems( kbm2l30 l30, int i, String msg) {

  if (( i < 0) || (i >= l30.size())) {
    frame30.kbm2lSystem.append( ERROR + "OVF-ITEMS-1: " + "\n");      
    frame30.kbm2lSystem.append( "msg: " + msg + "\n");      
    frame30.kbm2lSystem.append( "listName: " + l30.Name() + "\n");      
    frame30.kbm2lSystem.append( "i: " + i + "  size(): " + l30.size() + "\n");      
    frame30.exit( -1); 
    }
  
  item30 ITEM1 = l30.Get( i);
  Vector MEDIDA1 = ITEM1.GetMedida();
  Vector RESPUESTA1 = ITEM1.GetRespuesta();
  Vector INDICE1 = ITEM1.GetIndice();

  if ( i < l30.size()-1) {
    Vector ULTIMO = index30.ultimoT( l30.Base.Dom());
    if ( index30.eqT( INDICE1, ULTIMO)) {
      if ( i == 0) {
        frame30.kbm2lSystem.append( ERROR + 
        "CHK. length-1, (item30.eqT( ITEM0.GetIndice(), LAST)) ? "  +  msg + "\n" +
        "Item (0) " + ITEM1.GetIndice().toString() + "\n" +
        "Last     " + ULTIMO.toString()+"\n" +
        "Base     " + l30.Base.toString( ) + "\n");	    
        frame30.kbm2lSystem.append( "Firts&Last Item: \n");
       }
      frame30.kbm2lSystem.append( ERROR + "CHK final  !item30.eqT( INDICE1, LAST) ? " + msg  + "\n");
      frame30.kbm2lSystem.append( "INDICE1: " + INDICE1.toString() + "\n");
      frame30.kbm2lSystem.append( "LAST:     " + ULTIMO.toString() + "\n");
      frame30.kbm2lSystem.append( "Base:    "  + l30.Base.toString( ) + "\n");
      frame30.kbm2lSystem.append( "Rules:  " + l30.reglas.toString() + "\n");
      frame30.kbm2lSystem.append( "Last item: \n");
      frame30.kbm2lSystem.append( systemVer30.verItem( l30, l30.size()-1) + "\n");
      frame30.exit( -1); 
      }//if final
	 }
  
  item30 ITEM2 = l30.Get( i+1);
  Vector MEDIDA2 = ITEM2.GetMedida();
  Vector RESPUESTA2 = ITEM2.GetRespuesta();
  Vector INDICE2 = ITEM2.GetIndice();

//chk orden estricto del indice
  if ( index30.myeqT( INDICE1, INDICE2)) {// INDICE1 >= INDICE2
    frame30.kbm2lSystem.append( ERROR + "CHK.  Index Order.  l30.size(): " + l30.size()+"\n");
    frame30.kbm2lSystem.append( systemVer30.verItem( l30, i)+"\n");
    frame30.kbm2lSystem.append( systemVer30.verItem( l30, i+1)+"\n");
    frame30.kbm2lSystem.append( "CHK  order  "  + msg + "  i:" + i +"\n");
    frame30.kbm2lSystem.append( "Rules: " + l30.reglas.toString()+"\n");
    frame30.kbm2lSystem.append( "LAST RULE: " + l30.lastRULE+"\n");      
    frame30.exit( -1); 
    }

//chk respuesta adyacente distinta
  if ( index30.eqS( RESPUESTA1, RESPUESTA2)) {// RESPUESTA1 == RESPUESTA2
    frame30.kbm2lSystem.append( ERROR + "CHK.  Ady Response.  l30.size(): " + l30.size() + "\n");
    frame30.kbm2lSystem.append( systemVer30.verItem( l30, i) + "\n");
    frame30.kbm2lSystem.append( systemVer30.verItem( l30, i+1) + "\n");
    frame30.kbm2lSystem.append( "CHK  response  " + msg + "  i:" + i + "\n");
    frame30.kbm2lSystem.append( "Rules: " + l30.reglas.toString() + "\n");
    frame30.kbm2lSystem.append( "LAST RULE: " + l30.lastRULE + "\n");      
    frame30.exit( 0); 
    }
  
  return;
}//checkIems

}//class checkItem30