//checkLikst30//
package kernel;

//
import java.util.*;
import java.lang.*;
import java.io.*;
import java.math.*;

//
import kernel.*;
import kbm2l.*;
import control.*;
import target.*;

/**
* Test de correccion y consistencia de las listas kbm2l
* @author Juan A. Fdez del Pozo de Salamanca
* @version 3.0
**/
public  class  checkList30  extends  checkIndex30  {

  private static final String ERROR = "Error(checkList30): ";
  private static long warningLength = 10000;// cases pe item

/**
* Constructor por defecto
**/
public checkList30( ) {
//

}//checkList30

/**
* Implementacion de las pruebas de las condiciones de consistencia de la lista kbm2l.
* Indices validos.
* Lista unidad, lista generica.
* test: orden estricto del indice.
* test: respuesta adyacente distinta.
* test final.
* @return boolean or exit 
**/
public  static  boolean CHK( lista30 l30, String msg) {

  frame30.kbm2lTime.append("CHK List - Init.\n");
  base30.check( l30.Base);
  l30.Esqu.check( l30.Base);

  listStat30.calc( l30);

  if ( l30 == null) {
    frame30.kbm2lSystem.append( ERROR + "CHK l30 ==  null? "  +  msg + "\n");
    frame30.exit( 0); 
    }

  if ( l30.size() <= 0) {
    frame30.kbm2lSystem.append( ERROR + "CHK l30.size() <= 0 ? "  +  msg + "\n");
    frame30.exit( 0); 
    }

  try {
    for( int i = 0; i < l30.size(); i++) {
      checkIndex30.INDX( l30, l30.Get( i).GetIndice());//chk indice valido
    }//for
  }//try
  catch (Exception e) {
    frame30.kbm2lSystem.append( ERROR + "CHK( i) - INDX." + msg + "   " + l30.size() + "\n");
    frame30.exit( 0, e);
  }//catch

  try {
    for( int i = 0; i < l30.size()-1; i++) {
      checkItems( l30, i, msg);
      if ( !l30.esUNKB(l30.Get(i)))
        if ( l30.Get(i).getLongitud().doubleValue() > warningLength)
          frame30.kbm2lSystem.append( 
            "checkList30  CHK  Item i: " + i + "  length: " + l30.Get(i).getLongitud().toString()+ "\n");
    }//for
  }//try
  catch (Exception e) {
    frame30.kbm2lTime.append( ERROR + "CHK( i) - Items." + msg + "   " + l30.size() + "\n");
    frame30.exit( 0, e);
  }//catch

  frame30.kbm2lTime.append( "CHK List - End.  KB-size: " + listStat30.KB( l30)+"\n");
  frame30.kbm2lSystem.estatus( "Check KBM2L.");
  return true;//OK
}//CHK


/**
* Lock CHK. 
* @see controlPrefs30#checkMode()
**/
public  static  boolean chk( lista30 aux30, String MSG) {
//axiomas, consistente

  if ( !frame30.chk) return true;//no-chk
  
  return CHK( aux30, MSG);
}//chk

}//class checkList30