//core30//
package kernel;

//
import java.util.*;
import java.lang.*;
import java.io.*;
import java.math.*;

//
import control.*;
import kbm2l.*;
import tables.*;

/**
* Clase core30
* @author Juan A. Fdez del Pozo de Salamanca
* @version 3.0
**/
public class core30  {

  private static final String ERROR = "Error(core30): ";

/**
* Constructor por defecto
**/
public core30( ) {

}//core30

/**
* Volcado de la lista tras una excepcion o error de gestion.
**/
public  static  void core( lista30 l30, item30 item, int ix, Vector CERO, Vector ULTIMO, 
  item30 ITEM0, item30 ITEM1, item30 ITEM2, item30 ITEM3, item30 ITEM4) {

  listStat30.calc( l30);
  new outputList30( ).escribeKBM2L( l30, dato30.workspace+File.separator+"core");

  BufferedWriter out_core = null;//kbm2l
  try {//
    out_core = new BufferedWriter( new FileWriter( dato30.workspace + "core.txt"));
    
  String cr = new String(
    "Core:: No hay ninguna regla para gestionar la informacion o la gestion fue incorrecta.");
  out_core.write( cr, 0, cr.length());    out_core.newLine();

  cr = new String( "indice: "+ item.GetIndice().toString());
  out_core.write( cr, 0, cr.length());    out_core.newLine();

  cr = new String( "  respuesta: "+ item.GetRespuesta().toString());
  out_core.write( cr, 0, cr.length());    out_core.newLine();

  cr = new String( "  medida: "+ item.GetMedida().toString());
  out_core.write( cr, 0, cr.length());    out_core.newLine();

  if ( CERO != null) {
    cr = new String( "CERO:" + CERO.toString());
    out_core.write( cr, 0, cr.length());  out_core.newLine();
    }

  cr = new String( systemVer30.verItem( l30, ix));

  if ( ULTIMO != null) {
    cr = new String( "ULTIMO:" + ULTIMO.toString());
    out_core.write( cr, 0, cr.length());  out_core.newLine();
    }

  systemVer30.ver( out_core, l30);

  out_core.close();
  
  if ( l30.Base.Dom() != null)
    System.out.println( "D:" + l30.Base.Dom().toString());
  if ( l30.Base != null)
    System.out.println( "B:" + l30.Base.Bas().toString());
  
  if ( ITEM0 != null) {
    System.out.println( "INDICE0:" + ITEM0.GetIndice().toString());
    System.out.println( "RESPUESTA0:" + ITEM0.GetRespuesta().toString());
    System.out.println( "MEDIDA0:" + ITEM0.GetMedida().toString());
    }

  System.out.println( "lkbm: indice in INDICE3. ix:" + ix);

  if ( ITEM1 != null) {
    System.out.println( "INDICE1:" + ITEM1.GetIndice().toString());
    System.out.println( "RESPUESTA1:" + ITEM1.GetRespuesta().toString());
    System.out.println( "MEDIDA1:" + ITEM1.GetMedida().toString());
    } else System.out.println( "ITEM1 == null");
  if ( ITEM2 != null) {
    System.out.println( "INDICE2:" + ITEM2.GetIndice().toString());
    System.out.println( "RESPUESTA2:" + ITEM2.GetRespuesta().toString());
    System.out.println( "MEDIDA2:" + ITEM2.GetMedida().toString());
    } else System.out.println( "ITEM2 == null");
  if ( ITEM3 != null) {
    System.out.println( "INDICE3:" + ITEM3.GetIndice().toString());
    System.out.println( "RESPUESTA3:" + ITEM3.GetRespuesta().toString());
    System.out.println( "MEDIDA3:" + ITEM3.GetMedida().toString());
    } else System.out.println( "ITEM3 == null");
  if ( ITEM4 != null) {
    System.out.println( "INDICE4:" + ITEM4.GetIndice().toString());
    System.out.println( "RESPUESTA4:" + ITEM4.GetRespuesta().toString());
    System.out.println( "MEDIDA4:" + ITEM4.GetMedida().toString());
    } else System.out.println( "ITEM4 == null");

  }//try
  catch (Exception e) {
    System.out.println( ERROR + "core.kbm2l");
    e.printStackTrace();    
    try { out_core.close();}  catch (Exception f) { }
    frame30.exit(-1);
  }//catch

  frame30.exit( 0);
  return;
}//core

/**
* Volcado de la lista tras una excepcion o error de gestion.
**/
public  static  void core( lista30 l30, Vector indice, int ix, item30 ITEM2, item30 ITEM3) {

  listStat30.calc( l30);
  new outputList30( ).escribeKBM2L( l30, dato30.workspace+File.separator+"core");

  BufferedWriter out_core = null;//kbm2l
  try {//
    out_core = new BufferedWriter( new FileWriter( dato30.workspace + "core.txt"));
    
  String cr = new String(
    "Core:: No hay ningun item que contenga el indice.");
  out_core.write( cr, 0, cr.length());    out_core.newLine();

  cr = new String( "Index: " + indice.toString());
  out_core.write( cr, 0, cr.length());    out_core.newLine();

  cr = new String( systemVer30.verItem( l30, ix));
  out_core.write( cr, 0, cr.length());    out_core.newLine();

  systemVer30.ver( out_core, l30);

  out_core.close();
  
  if ( l30.Base.Dom() != null)
    System.out.println( "D:" + l30.Base.Dom().toString());
  if ( l30.Base != null)
    System.out.println( "B:" + l30.Base.Bas().toString());
  
  System.out.println( "lkbm: indice in INDICE3. ix:" + ix);

  if ( ITEM2 != null) {
    System.out.println( "INDICE2:" + ITEM2.GetIndice().toString());
    System.out.println( "RESPUESTA2:" + ITEM2.GetRespuesta().toString());
    System.out.println( "MEDIDA2:" + ITEM2.GetMedida().toString());
    } else System.out.println( "ITEM2 == null");
  if ( ITEM3 != null) {
    System.out.println( "INDICE3:" + ITEM3.GetIndice().toString());
    System.out.println( "RESPUESTA3:" + ITEM3.GetRespuesta().toString());
    System.out.println( "MEDIDA3:" + ITEM3.GetMedida().toString());
    } else System.out.println( "ITEM3 == null");

  }//try
  catch (Exception e) {
    System.out.println( ERROR + "core.kbm2l");
    e.printStackTrace();    
    try { out_core.close();}  catch (Exception f) { }
    frame30.exit(-1);
  }//catch

  frame30.exit( 0);
  return;
}//core

}//core30