//main30//
package lbnk2;

//
import java.util.*;
import java.lang.*;
import java.io.*;

/**
* LBNK230
* @author Juan A. Fdez del Pozo de Salamanca
* @version 3.0
**/
public  class  LBNK230  {

  private static final String ERROR = "Error(main30): ";

/**
* Entrada de la aplicacion
**/
public static void main(String[] args) {

  if(!(args.length==2)){
    System.out.println("Usage: Java LBN [inputfilename] [outputfilename] ...");
  }
  else {
    String inputfilename = args[0];
    String outputfilename = args[1];
    LearningInputDataManager indata = new LearningInputDataManager(inputfilename);
    indata.loadInputDataFile();
    K2 k2 = new K2(indata);
    LearningBBN bbn = k2.learnBBNFromData();
    bbn.writeToXML(outputfilename);
    }
  System.exit(0);
  return;
}//main

}//class LBNK230