//menuListenerBarControl//
package menu;

//
import java.util.*;
import java.awt.*;
import java.awt.event.*;
//import javax.swing.JDialog;

//
import kernel.*;
import kbm2l.*;
import tables.*;
import schema.*;

//
import analysis.*;
import synthesis.*;
import learning.*;
import query.*;
import tools.*;

//
import control.*;
import spectrum.*;
import cpt.*;

/**
* SERVIDOR DE ESCUCHA DEL MENU y CONTROLES DE frame
*
* @author Juan A. Fdez del Pozo de Salamanca
* @version 3.0
**/
class menuListenerBarControl  extends  menuControl30  {

  private static final String ERROR = "Error(menuListenerBarControl): ";

/**
* Constructor por defecto
**/
public menuListenerBarControl( ) {

}//menuListenerBarControl

/**
* @return true si se realiza una accin 
**/
public static boolean Control( ActionEvent e) {
//Control

  if (e.getActionCommand().equals( strMenuItemProcs)) {
      kbm2lTime.frame.toFront();
  
      kbm2lTime.append("Working process.\n");

      if ( sintesis30.working)      { 
        kbm2lTime.append("Working. " + "sintesis30.......\n"); }
      if ( proyectionParX30.working)      { 
        kbm2lTime.append("Working. " + "proyectionParX30.......\n"); }
      if ( aprendiz30.working)      { 
        kbm2lTime.append("Working. " + "aprendiz30.......\n"); }
      if ( spectrum30.working)      { 
        kbm2lTime.append("Working. " + "spectrum30.......\n"); }
      if ( consulta30.working)      { 
        kbm2lTime.append("Working. " + "consulta30.......\n"); }

      if ( extended30.working)      { 
        kbm2lTime.append("Working. " + "extended30.......\n"); }
      if ( randomBase30.working)    { 
        kbm2lTime.append("Working. " + "randomBase30.....\n"); }
      if ( simetricBase30.working)  { 
        kbm2lTime.append("Working. " + "simetricBase30...\n"); }
      if ( lshiftAtt30.working)     { 
        kbm2lTime.append("Working. " + "lshiftAtt30......\n"); }
      if ( onTopAtt30.working)      { 
        kbm2lTime.append("Working. " + "onTopAtt30.......\n"); }
      if ( breakAtt30.working)      { 
        kbm2lTime.append("Working. " + "breakAtt30.......\n"); }
      if ( contracted30.working)      { 
        kbm2lTime.append("Working. " + "contracted30.......\n"); }

      if ( cpt30.working)           { 
        kbm2lTime.append("Working. " + "cpt30............\n"); }

      if ( checkCPT30.working)      { 
        kbm2lTime.append("Working. " + "checkCPT30.\n"); }
      if ( constraintCPT30.working)      { 
        kbm2lTime.append("Working. " + "constraintCPT30.\n"); }
  
    return true;
    }//Procs

  if (e.getActionCommand().equals( strMenuItemStop)) {
    kbm2lTime.frame.toFront();

        int process = 0;

      do {

        process = 0;

      kbm2lTime.append("Stop process.\n");

      if ( sintesis30.working) {
        sintesis30.working = false;  process++;
        kbm2lTime.append("Stop. " + "sintesis30......\n"); }
      if ( aprendiz30.working) {
        aprendiz30.working = false; process++;
        kbm2lTime.append("Stop. " + "aprendiz30......\n"); }
      if ( spectrum30.working) {
        spectrum30.working = false; process++;
        kbm2lTime.append("Stop. " + "spectrum30......\n"); }
      if ( consulta30.working) {
        consulta30.working = false; process++;
        kbm2lTime.append("Stop. " + "consulta30......\n"); }

      if ( extended30.working) {
        extended30.working = false; process++;
        kbm2lTime.append("Stop. " + "extended30......\n"); }
      if ( randomBase30.working) {
        randomBase30.working = false; process++;
        kbm2lTime.append("Stop. " + "randomBase30....\n"); }
      if ( simetricBase30.working) {
        simetricBase30.working = false; process++;
        kbm2lTime.append("Stop. " + "simetricBase30..\n"); }
      if ( lshiftAtt30.working) {
        lshiftAtt30.working = false; process++;
        kbm2lTime.append("Stop. " + "lshiftAtt30.....\n"); }
      if ( onTopAtt30.working) {
        onTopAtt30.working = false;  process++;
        kbm2lTime.append("Stop. " + "onTopAtt30......\n"); }
      if ( breakAtt30.working) {
        breakAtt30.working = false; process++;
        kbm2lTime.append("Stop. " + "breakAtt30......\n"); }
      if ( contracted30.working) {
        contracted30.working = false; process++;
        kbm2lTime.append("Stop. " + "contracted30......\n"); }

      if ( cpt30.working) {
        cpt30.working = false;       process++;
        kbm2lTime.append("Stop. " + "cpt30...........\n"); }

      if ( checkCPT30.working) {
        checkCPT30.working = false;  process++;
        kbm2lTime.append("Stop. " + "checkCPT30......\n"); }
      if ( constraintCPT30.working) {
        constraintCPT30.working = false;  process++;
        kbm2lTime.append("Stop. " + "constraintCPT30......\n"); }

      } while (process > 0);

    return true;
    }//Stop

  if (e.getActionCommand().equals( strMenuItemBorrar)) {
      kbm2lSystem.setText( kbm2lSystem.about());
      kbm2lSystem.estatus("");
      kbm2lTime.setText( kbm2lTime.about());
      kbm2lBrowser.setText( kbm2lBrowser.about());
    return true;
    }

  return false;  
}//Control


/**
* @return true si se realiza una accin 
**/
public static boolean Preferences( ActionEvent e) {
//Preferences
  if (e.getActionCommand().equals( strMenuItemLoad)) {
    kbm2lControl.frame.toFront();
    new menuControl30().loadPrefs();  
    return true;
    }

  if (e.getActionCommand().equals( strMenuItemSave)) {
    kbm2lControl.frame.toFront();
    new menuControl30().savePrefs();  
    return true;
    }

  if (e.getActionCommand().equals( strMenuItemReset)) {
    kbm2lControl.frame.toFront();
    kbm2lControl.iniControl();
    return true;
    }

  if (e.getActionCommand().equals( strMenuItemRandomSeed)) {
    kbm2lControl.frame.toFront();
    long seed = new controlPrefs30().randomSeed();
    control30.gr.setSeed( seed);
    kbm2lTime.append("control30.gr.seed: " + seed + ".\n");
    return true;
    }

  return false;  
}//Preferences

/**
* @return true si se realiza una accin 
**/
public static boolean Ver( ActionEvent e) {
//Ver

  if ( f30.activel30 != null) {

    if (e.getActionCommand().equals( strMenuItemSynthesisTrace)) {
      kbm2lControl.frame.toFront();
      kbm2lBrowser.frame.toFront();
      kbm2lBrowser.traceView( f30.activel30);
      return true;
      }

    } else kbm2lSystem.estatus( "There is no active KBM2L");

  return false;  
}//Ver

}//class menuListenerBarControl