//EXTENDEDKBM2L30//
package schema;

//
import java.util.*;
import java.lang.*;
import java.io.*;
import java.math.*;

//
import kernel.*;
import kbm2l.*;
import control.*;

/**
* Class extended30 Extension de atributos del esquema.
**/
public class extended30  extends  frame30  implements  Runnable  {

  private static final String ERROR = "Error(extended30): ";
/**
* flag de ejecucion en curso
**/
  public static boolean working = false;//

/**
* Constructor por defecto.
**/
public extended30( ) {

}//extended30

/**
* Aade un atributo n-ario nuevo por la izq., en la posicion de mayor peso.
* El att se introduce por la izq. y se transpone a la posicion.
* Si es vacia solo afecta a la estructura y al indice ultimo.
* Primero se duplica la lista, segundo se extiende el indice de cada item por la izq.
**/
public lista30 extended( lista30 l30, int dominio, int posicion) {
  
  working = true;
//contenido
  item30 item = null;

  int sz = l30.size();

  for( int i = 0; i < sz*(dominio-1); i++) {// duplicado de la lista
    item = l30.Get( i);//
    l30.add( new item30( l30, item.GetMedida(), item.GetRespuesta(), item.GetIndice()));
    }// 

  if ( dominio * sz != l30.size()) {
    System.out.println( ERROR + "duplicando de lista.");
    f30.exit(0); 
  }
 
  for( int i = 0; i < l30.size(); i++) {// introduce la dimension y el valor 0000...0,1111...1
    l30.Get( i).GetIndice().add( 0, new Integer( (int)(i/sz)));//ext - i/sz
   }//for i

//reestructura la especificacion del esquema
  int codAtt = 1000;
  boolean fin = false;
  while ( !fin) {
    for ( int i = 0; i < l30.Esqu.numAtributos; i++) {
      if ( ((Integer)l30.Esqu.CodigosAtributos.get( i)).intValue() == codAtt) {
	      codAtt++;
	      break;
	      }
       else {
        if ( i == ( l30.Esqu.numAtributos - 1)) fin = true;
      }//if
      }//for
    }//while
  l30.Esqu.CodigosAtributos.add( 0, new Integer( codAtt));
  l30.Esqu.numAtributos++;
  l30.Esqu.Atributos.add( 0, new String( "Att-" + codAtt));
  l30.Esqu.CDAtributos.add( 0, new Integer( dominio));
  Vector Valores = new Vector();
  for( int i = 0; i < dominio; i++)
    Valores.add( new String( "Att-"+codAtt+"-"+i));
  l30.Esqu.ValoresAtributos.add( 0, Valores);    

//reestructura la especificacion de la dimension y la base
  l30.dimension( l30.dimension() + 1);
  l30.Base.add( 0, dominio, 0, -1);//t+1 //dominio //rol.
  for( int i = 1; i < l30.dimension(); i++)
    l30.Base.bas( i, l30.Base.bas( i)+1);
  
//fusion en las fronteras de los duplicados
  for( int i = 0; i < l30.size()-1; i++) {
    if ( index30.eqS( l30.Get( i).GetRespuesta(), l30.Get( i+1).GetRespuesta())) {
      l30.REMOVE( i);
      }//if
    }//for

  new controlPrefs30().onTopAttribute( 0);
  new controlPrefs30().onBotAttribute( l30.dimension()-1);

  l30 = new swapAtt30().swapAtt( l30);

  listStat30.KB( l30);//
  checkList30.CHK( l30, "extended30");
  f30.kbm2lSystem.estatus("extended: " + l30.size());

  working = false;
  return l30;
}//extended

/**
* run process
**/
public void run() {

  if ( !working) {
  try {
    long ts0 = (new Date()).getTime();
    f30.activel30 = extended( f30.activel30, new controlPrefs30( ).randomDomain(), 0);
    f30.kbm2lTime.append("extended:: " + (new Date().getTime() - ts0) + ".\n");      
  }//try
  catch (Exception e) {
    System.out.println( ERROR + "run().");
    e.printStackTrace();
  }//catch
  }

  return;
}//run

}//class extendedl30
