//ONTOPATT30//
package schema;

//
import java.util.*;
import java.lang.*;
import java.io.*;
import java.math.*;

//
import kernel.*;
import kbm2l.*;
import target.*;
import tables.*;
import control.*;

/**
* Clase onTopAtt30: lista en una base nueva permutando el att i y la posicion 0. 
**/
public class onTopAtt30  extends  frame30  implements  Runnable  {

//
  private static final String ERROR = "Error(onTopAtt30): ";
/**
* flag de ejecucion en curso
**/  
  public static boolean working = false;

/**
* Constructor por defecto
**/
public onTopAtt30( ) {

}//onTopAttl30

/**
* @return la lista con la base 0 <-> att
**/
public lista30 onTopAtt( lista30 l30) {

  working = true;

//Att-Control
  int att = new controlPrefs30().onTopAttribute( );

  if (( att <= 0) || ( att >= l30.dimension())) {
    f30.kbm2lSystem.estatus("onTopAtt. " + l30.size() + "  att: " + att);
    working = false;  
    return l30;//OK
    }

  f30.kbm2lTime.append("onTopAtt. " + l30.size() + "  att: " + att + "\n");

  lista30 lTarget = null;
  if ( att > 0)
    lTarget = targetStd30.Target2( l30, 0, att);//std    
    else {
      f30.kbm2lSystem.estatus("onTopAtt. " + l30.size() + "  att: " + att);
      working = false;
      return l30;    
      }//

  int pg = l30.Name().indexOf('-');
  if (pg == -1) pg = l30.Name().length();
  lTarget.Name( new String( l30.Name().substring( 0, pg) + "-" +  "onTopAtt-" + att));
    
  l30 = new listUnion30().union_lr( l30, lTarget); 
  if ( lTarget == null) {
    f30.kbm2lTime.append( ERROR + "onTopAtt.\n");
    }//if

  l30 = new lista30( lTarget, lTarget);//std
  listStat30.KB( l30);//
  f30.kbm2lTime.append( "onTopAtt. " + l30.size() + "  att: " + att + "\n");

  working = false;
  return l30;
}//onTopAtt

/**
* run()
**/
public void run() {

  if ( !working) {
  try {
    long ts0 = (new Date()).getTime();
    f30.activel30 = onTopAtt( f30.activel30);
    f30.kbm2lTime.append( "onTopAtt:: " + (new Date().getTime() - ts0) + ".\n");      
  }//try
  catch (Exception e) {
    f30.kbm2lTime.append( ERROR + "run().\n");
    frame30.exit( 0, e);
  }//catch
  }

  return;
}//run

}//class onTopAtt30
