//sintesisHamming2Opt30//
package synthesis;

//
import java.util.*;
import java.lang.*;
import java.io.*;
import java.math.*;
import java.awt.*;

//
import kbm2l.*;
import tables.*;
import control.*;
import kernel.*;
import tools.*;

/**
*
**/
public  class sintesisHamming2Opt30  extends  sintesisHamming30  {

  private static final String ERROR = "Error(sintesisHamming2Opt30): ";
  private static lista30 l30 = null;

/**
* Constructor por defecto, sintesis sobre la lista activa
**/
public sintesisHamming2Opt30( ) {

  this.l30 = f30.activel30;
}//sintesisHamming2Opt30

/**
* Contructor, sintesis sobre la lista argunmento
* @param l30 lista30 
**/
public sintesisHamming2Opt30( lista30 l30) {

  this.l30 = l30;
}//sintesisHamming2Opt30

public  lista30 Hamming2Opt( lista30 l30) {
//  permutaciones binarias o de distancia 2

  working = true;
  kbm2lSystem.setText("Sintesis Hamming2Opt.\n");
 
//  sistematico t*(t-1)/2
  if ( l30.dimension() > 1)//  factorial( 1) ---> 1.
  try {
  if ( inikbs( l30) == null) return l30;
  for( int i = attTop; i <= ( attBot - 1); i++) { // attBot = l30.dimension()
    for( int j = 1; j <= ( attBot - i); j++) {//  Hamming2Opt

      if (reset) {
        i = 0; j = 1;//reset H2Opt
        reset = false;
        pivotes++;
      }//if

      iteraciones++;
      if ( chk)
        System.out.print( 
          ("H2Opt - swap(i,i+j):  i:" + String.valueOf( i) + "   j:" + String.valueOf( i+j)));  

      kbm2lSystem.estatus( 
        ("H2Opt - swap(i,i+j):  i:" + String.valueOf( i) + "   j:" + String.valueOf( i+j)));
      aux1 = kbs2Opt( l30, i, i+j);//copia l30 en aux1 en nueva base
      kbm2lSystem.estatus(
        ("H2Opt - swapped(i,i+j):  i:" + String.valueOf( i) + "   j:" + String.valueOf( j)));

      if ( aux1 != null) { // ---> cp - completa
        if ( !metrica30.H( l30.Base, aux1.Base, 2)) {
          System.out.println( ERROR + "H2Opt.");
          System.exit( 0);
        }//if         

        if ( new controlPrefs30().verboseSystem()) { 
          kbm2lSystem.append("+BASE: " + aux1.Base.Bas().toString() + "\n");
          kbm2lSystem.append( "H2Opt:" + metrica30.H( l30.Base, aux1.Base) + "  ");
          kbm2lSystem.append( "G[2]: " + metrica30.G( l30.Base, aux1.Base) + "\n");
          }

        if (( minkbm > aux1.optSize())) {
          l30 = kbs( l30, aux1, "2Opt");
          if ( l30.lkbm.size() == listStat30.DS( l30).size()) working = false;//OPT
          reset = true;//reset H2Opt
          break;
          }//if opt
          
        }//if - cp - incompleta
        if ( l30.size() == listStat30.DS( l30).size()) break;//opt-completa
        if ( !working) break;
      }//for
      if ( l30.size() == listStat30.DS( l30).size()) break;//opt-completa
      if ( !working) break;
    }//for

  }//try
  catch (Exception e) {
    System.out.println( ERROR + "Hamming2Opt-4.\n");
    e.printStackTrace();
    System.exit( 0);
  }//catch

//  listStat30.importanceAtt( l30);//

  if ( minkbm < minKBM) {
    if ( chk) {
      listStat30.calc( l30);
      new outputList30( ).escribeKBM2L( l30, dato30.workspace + File.separator + "Hamming2Opt");
      }//if
    }//if
    else kbm2lSystem.append("sintesis: no hay base mejor.\n");

  kbm2lSystem.append("sintesis H2Opt: " + minKBM + "  ---> " + minkbm + ". OK.\n");
  kbm2lSystem.append("pivots: " + pivotes + "  iterations: " + iteraciones+ ".\n"); 

  working = false;
  return l30;
}//Hamming2

/**
* run process: f30.activel30 = Hamming2Opt( l30);
**/
public void run() {

  if ( l30.dimension() > 1)
  if ( !working) {
  try {
    long ts0 = (new Date()).getTime();
    f30.activel30 = Hamming2Opt( l30);
    f30.kbm2lTime.append("Sintesis 2Opt:: " + (new Date().getTime() - ts0) + ".\n");      
  }//try
  catch (Exception e) {
    System.out.println( ERROR + "run().");
    e.printStackTrace();
    System.exit( 0);
  }//catch
  }

  return;
}//run

}//class sintesisHamming2Opt30
