//SIMETRICBASE30//
package tools;

//
import java.util.*;
import java.lang.*;
import java.io.*;
import java.math.*;

//
import control.*;
import kernel.*;
import kbm2l.*;
import target.*;
import tables.*;

/**
* Clase simetricBase30: lista  simetrica de l30, en base palindroma.
**/
public class simetricBase30  implements  Runnable  {

  private static final String ERROR = "Error(simetricBase30): ";
/**
* flag de ejecucion en curso
**/
  public static boolean working = false;

/**
* Constructor por defecto
**/
public simetricBase30( ) {

}//simetricBase30

/**
* @return la lista con la base palindroma de l30
**/
public lista30 simetric( lista30 l30) {

  working = true;
  lista30 lTarget = null;
  BigInteger KBl30 = listStat30.KB( l30);
  BigInteger KBlTarget = null;
  
  lTarget = targetStd30.TargetS( l30);//std

  KBlTarget = listStat30.KB( lTarget);
  if ( KBlTarget.compareTo( BigInteger.ZERO) != 0) {
    System.out.println( ERROR + "simetric.0 " + KBlTarget);
    System.exit( 0);
    }//if

  lTarget.Name( new String( "S-" + l30.Name()));
    
//  l30.union( lTarget);  
  new listUnion30().union_lr( l30, lTarget);  
  if ( lTarget == null) {
    System.out.println( ERROR + "simetric.1");
    System.exit( 0);
    }//if

  KBlTarget = listStat30.KB( lTarget);
  if ( KBlTarget.compareTo( KBl30) != 0) {
    System.out.println( ERROR + "simetric.2 " + KBlTarget+ " = KBTarget!=KBl30 = " + KBl30);
    return l30;
    //System.exit( 0);
    }//if

  l30 = lTarget;
  checkList30.chk( l30, "simetric.");//checks
//  listStat30.importanceAtt( l30);//
  frame30.kbm2lSystem.estatus("simetricKBM2L: " + 
    listStat30.KB( l30).toString() + " | " + l30.size());
  working = false;
  return l30;
}//simetric

/**
* @return la lista con la base palindroma de l30
**/
public lista30 simetric2( lista30 l30) {

  working = true;
  lista30 lTarget = null;
  BigInteger KBl30 = listStat30.KB( l30);
  BigInteger KBlTarget = null;
  
  lTarget = targetStd30.Target2( l30, 0, 1);//std

  KBlTarget = listStat30.KB( lTarget);
  if ( KBlTarget.compareTo( BigInteger.ZERO) != 0) {
    System.out.println( ERROR + "simetric2.0 " + KBlTarget);
    System.exit( 0);
    }//if

  lTarget.Name( new String( "S-" + l30.Name()));
    
//  l30.union( lTarget);  
  new listUnion30().union_lr( l30, lTarget);  
  if ( lTarget == null) {
    System.out.println( ERROR + "simetric2.1");
    System.exit( 0);
    }//if

  KBlTarget = listStat30.KB( lTarget);
  if ( KBlTarget.compareTo( KBl30) != 0) {
    System.out.println( ERROR + "simetric.2 " + KBlTarget+ " = KBTarget!=KBl30 = " + KBl30);
    return l30;
    //System.exit( 0);
    }//if

  l30 = lTarget;
  checkList30.chk( l30, "simetric2.");//checks
//  listStat30.importanceAtt( l30);//
  frame30.kbm2lSystem.estatus("simetric2 -- KBM2L: " + 
    listStat30.KB( l30).toString() + " | " + l30.size());
  working = false;
  return l30;
}//simetric2

/**
* run process: frame30.activel30 = simetric( frame30.activel30);
**/
public void run() {

  if ( !working) {
  try {
    long ts0 = (new Date()).getTime();
    frame30.activel30 = simetric( frame30.activel30);
    frame30.kbm2lTime.append("simetric:: " + (new Date().getTime() - ts0) + ".\n");      
  }//try
  catch (Exception e) {
    System.out.println( ERROR + "run().");
    e.printStackTrace();
    System.exit( 0);
  }//catch
  }

  return;
}//run

}//class skbbm2l30
