//analisisSemantico30//
package analysis;

//
import java.util.*;
import java.lang.*;
import java.io.*;
import java.math.*;
import java.awt.*;

//
import kernel.*;
import kbm2l.*;
import tables.*;
import schema.*;

/**
* Clase analisisSemantico30.
* @author Juan A. Fdez del Pozo de Salamanca
* @version 3.0
**/
public class analisisSemantico30  extends analisis30  {

  private static final String ERROR = "Error(analisisSemantico30): ";

/**
* Constructor por defecto
**/
public analisisSemantico30( ) {

}//analisisSemantico30

/**
* Procedimiento de analisis semantico, con el esquema, de la lista l30. 
* @see analisis30#interpretacion(lista30)
**/
public void analisisSemantico(lista30 l30) {

  String pathKBM = null;

  frame30.kbm2lSystem.append( "Semantic Analysis: list interpretation.\n");
  if ( l30.Esqu.numDecisiones == 0) {
    frame30.kbm2lSystem.append( "Select Analysis Schema: *.eq  - .\n");
    pathKBM = new String( dato30.selectFile( frame30.kbm2lSystem.frame, FileDialog.LOAD, "*.eq"));
    if (( pathKBM == "")||( pathKBM == null)) {
      frame30.kbm2lSystem.append("Schema not selcted.\n");
      return;
      }

    pathKBM = dato30.nameFile( pathKBM);
  
    l30.Esqu = new esquema30( l30.Name(), l30.ParIndice(), l30.ParRespuesta());
    l30.Esqu.leerEq( dato30.extFile( pathKBM, "eq"));//nombre.eq

    frame30.kbm2lSystem.append( dato30.extFile( pathKBM, "eq") + ".\n");
    }// l30.Esqu == null
   
  interpretacion( l30);
  frame30.kbm2lSystem.append( "Sematic Analysis: list interpretation. OK\n");

  return;
}//analisisSemantico

}//analsisSemantico30