//analisisSetIndex30//
package analysis;

//
import java.util.*;
import java.lang.*;
import java.io.*;
import java.math.*;
import java.awt.*;

//
import kernel.*;
import kbm2l.*;
import target.*;
import tables.*;
import schema.*;
import tools.*;
import control.*;

/**
* Clase analisisSetIndex30.
* @author Juan A. Fdez del Pozo de Salamanca
* @version 3.0
**/
public class analisisSetIndex30  extends analisis30  {

  private static final String ERROR = "Error(analisisSetIndex30): ";

/**
* Constructor por defecto
**/
public analisisSetIndex30( ) {

  System.out.println( "analisisSetIndex30");
}//analisisSetIndex30

/**
* 
**/
public static Vector setRef( lista30 l30, Vector INDICE) {

  for( int j = 0; j <= l30.dimparam; j++)
     INDICE.set( j, new Integer(((Integer)l30.PARAMS.get( j)).intValue()));
  return INDICE;
}//setRef

private static Vector setMin( lista30 l30, Vector INDICE) {

  for( int j = 0; j <= l30.dimparam; j++)
     INDICE.set( j, new Integer( 0));
  return INDICE;
}//setMIn

private static Vector setMax( lista30 l30, Vector INDICE) {

  for( int j = 0; j <= l30.dimparam; j++)
     INDICE.set( j, new Integer( l30.Base.dom( j)-1));
  return INDICE;
}//setMax

private static Vector setInst( lista30 l30, Vector INDICE, int j) {

  try {//
    if ( j <= l30.dimparam) {
      setRef( l30, INDICE);
      INDICE.set( j, new Integer( control30.gr.nextInt( l30.Base.dom( j))));
      }
      else INDICE = new randomkbm2l30().randomINDICE( l30); //!!!
  }//try
  catch (Exception e) {
    System.out.println( ERROR + "setInst. j: " + j);
    frame30.exit( 0, e);
  }//catch

  return INDICE;    
}//setInst

/**
* Indices sesgados en la muestra de AS
**/
public static Vector set( int i, lista30 l30, Vector INDICE) {

  int j = -1;
  try {//    
    INDICE = new randomkbm2l30().randomINDICE( l30); //!!!
    if ( i == 0) {//    
      setRef( l30, INDICE);
      } else
    if ( i == 1) {//   
      setMin( l30, INDICE);
      } else
    if ( i == 2) {//  
      setMax( l30, INDICE); 
      } else {//
      setInst( l30, INDICE, ((int) i / 2)); 
       }

  }//try
  catch (Exception e) {
    System.out.println( ERROR + "set.");
    System.out.println( "I: " + INDICE.toString());
    frame30.exit( 0, e);
  }//catch

  return INDICE;
}//set

/**
* Center Index in gap XX
* @param k item gap XY
**/
public static Vector center( lista30 l30, int k) {

  BigInteger I = l30.Get( k).getOffsetInf();
  BigInteger S = l30.Get( k).getOffsetSup();
  Vector INDICE = index30.index( l30.Weights, I.add( S).shiftRight( 1));    
  checkIndex30.INDX( l30, INDICE);
  return INDICE;
}//center

/**
* Random Index in gap XY
* @param k item gap XY
* @param l sample.number
**/
public static Vector sample( lista30 l30, int k, int l) {

  BigInteger G = l30.Get( k).getOffsetSup().subtract( l30.Get( k).getOffsetInf());
  BigInteger C = l30.Get( k).getOffsetInf().add( G.divide( new BigInteger( new Integer( l).toString())));
  Vector INDICE = index30.index( l30.Weights, C);    
  checkIndex30.INDX( l30, INDICE);
  return index30.index( l30.Weights, C);
}//center

}//analisisSetIndex30