//FOCUSALTERNATIVEL30//
package analysis;

//
import java.util.*;
import java.lang.*;
import java.io.*;
import java.math.*;

//
import control.*;
import kernel.*;
import kbm2l.*;
import tables.*;

/**
* Clase focusAlternativel30, genrador de todos los focos de la lista
* @author Juan A. Fdez del Pozo de Salamanca
* @version 3.0
**/
public  class  focusAlternative30  {

  private static final String ERROR = "Error(focusAlternative30): ";
/**
* flag de ejecucion en curso
**/
  public static boolean working = false;
  private Vector MEDIDA = null;

/**
* Constructor por defecto
**/
public focusAlternative30( ) {

}//focusAlternative30

/**
* Borrado de todos los casos salvo de una alternativa en una kbm2l,
* para explicacion especializada.
**/
public lista30 focusAlternative( lista30 l30) {

  Vector DS = listStat30.DS( l30);
  Vector Alt0 = null;
  Vector Alt1 = l30.UNKB; 
//  Vector Alt1 = l30.COKB; 

  String prevWorkspace = new String( dato30.workspace);
  System.out.println( prevWorkspace); 
  dato30.workspace = new String( prevWorkspace + dato30.extFile( l30.Name(), "") + File.separatorChar);
  File F = new File( dato30.workspace);
  try {
  if ( F.mkdir()) {
    System.out.println( "focusAlternative workspace: !\n" + dato30.workspace);
    //System.out.println( F.list()[0].toString());
   }
    else { System.out.println( "focusAlternative workspace: ?\n" + dato30.workspace);
      //System.out.println( F.list()[0].toString());
    }
    }//try
    catch (SecurityException e) {
      System.out.println( ERROR + "focusAlternative workspace.");
      frame30.exit( 0, e);
    }//catch

  working = true;
  for( int k = 0; k < DS.size(); k++) {
	 lista30 xl30 = new lista30( l30, l30); //copia contenido
  try {
    Alt0 = ((Vector)DS.get( k));
    for( int i = 0; i < xl30.size(); i++) {
      item30 item = xl30.Get( i);
      if ( !index30.eqS( item.GetRespuesta(), Alt0)) {
        item.SetRespuesta( Alt1);
        }
      }//for
    boolean ady = false;
    do {  
    ady = false;
    for( int i = 0; i < xl30.size()-1; i++) {
      frame30.kbm2lSystem.estatus(" :: " + xl30.size());
      if ( index30.eqS( xl30.Get(i).GetRespuesta(), xl30.Get(i+1).GetRespuesta())) {
        xl30.REMOVE( i); 
        ady = true;
        }
      }//for
    } while( ady);  
    }//try
    catch (Exception e) {
      System.out.println( ERROR + "focusAlternative");
      frame30.exit( 0, e);
    }//catch
    listStat30.KB( xl30);//
    checkList30.CHK( xl30, "focusAlternative");  
    new outputList30( ).escribeKBM2L( xl30, 
      dato30.extFile( dato30.toString( Alt0, "", "")+"-"+l30.Name(),"hkb"));
  }//for-k

  dato30.workspace = new String( prevWorkspace);

  frame30.kbm2lSystem.estatus("delAlternative  l30: " + l30.size());

  working = false;
  return l30;
}//focusAlternative

}//class focuAlternative30
