//INFERENCE30//
package analysis;

//
import java.lang.Object.*;
import java.util.*;
import java.lang.*;
import java.io.*;
import java.math.*;
import java.awt.*;

//
import control.*;
import kernel.*;
import kbm2l.*;
import tables.*;
import analysis.*;

/**
* Clase inference30, XX-XY responses.
* @author Juan A. Fdez del Pozo de Salamanca
* @version 3.0
**/
public class inference30  extends  analisis30  {

  private static final String ERROR = "Error(inference30): ";

/**
* Constructor por defecto
**/
public inference30( ) {

}//proyection30

/**
* La lista l30 tiene p dimensiones parametricas y el resto atributos
* se trata de generar la lista de modelos, proyectando.
* La secuencia del modelo de referencia definido en analisis30.PARAMS se compara
* con las secuencias homologas en otros modelos y se completa la lista h30
* con RRKB (-4) si coincide y RSKB (-3) si es sensible.
* Se podia generalizar la respuesta para almacenar la lista del modelo en el 
* esquema complementario de atributos.
**/
public lista30 inference( lista30 l30, String type) {

  Vector ipd = protocolo30.ipdAccess( "");//filename, dimparam, PARAMS, Decs
  frame30.activel30.dimparam = ((Integer)(ipd.get(1))).intValue();
  frame30.activel30.PARAMS = (Vector)(ipd.get(2));

    if ( listStat30.KB( l30).doubleValue() > 0.0) {
      lista30 i30 = new lista30( l30, l30);
      i30.inference( type);    
      new outputList30( ).escribeKBM2L( i30,
        dato30.workspace + dato30.extFile( dato30.nameFile( i30.Name()), "hkb"));//no filedlg        
      }//if
      else frame30.kbm2lSystem.estatus("inference. Any: " + l30.size());

  return l30;
}//inference

}//class inference30
