//PROYECTION30//
package analysis;

//
import java.lang.Object.*;
import java.util.*;
import java.lang.*;
import java.io.*;
import java.math.*;
import java.awt.*;

//
import kernel.*;
import control.*;
import kbm2l.*;
import tables.*;
import analysis.*;

/**
* Clase proyection30, parametros.
* @author Juan A. Fdez del Pozo de Salamanca
* @version 3.0
**/
public class proyection30  {

  private static final String ERROR = "Error(proyection30): ";
/**
* flag de ejecucion en curso
**/
  public static boolean working = false;//

  protected static int k = -1;//en la lista el primer item de ref
  protected static int l = -1;//en la lista el ultimo item de ref

/**
* Constructor por defecto
**/
public proyection30( ) {

//  System.out.println( "proyection30");
}//proyection30

/**
* Proyection vacia.
* Los parametros estan todos a la izquierda en la base.
* @param l30 Lista con el esquema de parametros.
*/
protected lista30 proyection( lista30 l30) {

  lista30 h30 = new lista30( l30.Esqu);// vacia con n dim 0..(n-1)

  try {
  for( int i = h30.dimension()-1; i > l30.dimparam; i--) {
    h30.Get(0).GetIndice().remove(i);//borra los atributos.
    }//for-i
    frame30.kbm2lSystem.append( "h30.Get(0).GetIndice(): " + h30.Get(0).GetIndice() + ".\n");
  } catch (Exception e) {
    System.out.println( ERROR + "proyection.1");
    frame30.exit( 0, e);
  }//catch

  try {
    for( int i = h30.dimension()-1; i > l30.dimparam; i--) {
      h30.Base.remove(i);//DOM,BAS,ATT,ROL,IMP
      }
    for( int i = 0; i <= l30.dimparam; i++) {
      h30.Base.bas(i,i);//canonica !!!???
      }//for-i
    frame30.kbm2lSystem.append( "h30.Base:\n" + h30.Base.toString( h30) + ".\n");
  } catch (Exception e) {
    System.out.println( ERROR + "proyection.2");
    frame30.exit( 0, e);
  }//catch

  try {
    h30.Esqu.nombre = "h-"+h30.Esqu.nombre;
    h30.Esqu.numAtributos = l30.dimparam+1;//PARAMs.size()=dimparam+1
    for( int i = h30.dimension()-1; i > l30.dimparam; i--) {
      h30.Esqu.remove(i);
      }//for-i  
    h30.Esqu.browser( frame30.kbm2lSystem);   
    h30.ParIndice( l30.dimparam+1); //
    h30.Name( "h-"+l30.Name());
    listStat30.calc( h30);
  } catch (Exception e) {
    System.out.println( ERROR + "proyection.3");
    frame30.exit( 0, e);
  }//catch

  return h30;  
}//proyection

/**
* refModel.
* Los parametros estan todos a la izquierda en la base.
* @param l30 lista con el esquema de parametros.
*/
protected void REFmodel( lista30 l30) {

  try {
  
    Vector firstRef = new Vector();//indice del caso primero del RefModel
    firstRef = index30.cpT( l30.PARAMS, l30.dimparam);
    for( int i =l30.dimparam+1; i < l30.dimension() ; i++)
      firstRef.add( new Integer( 0));
    frame30.kbm2lSystem.append( "firstRef: " + firstRef.toString( ) + ".\n");

    Vector lastRef  = new Vector();//indice del caso ultimo del RefModel
    lastRef = index30.cpT( l30.PARAMS, l30.dimparam);
    for( int i =l30.dimparam+1; i < l30.dimension() ; i++)
      lastRef.add( new Integer(( l30.Base.dom(i)-1)));
    frame30.kbm2lSystem.append( "lastRef: " + lastRef.toString( ) + ".\n");

//k < l
  k = l30.indexOf( l30.GET( firstRef));//en la lista el primer item de ref
  l = l30.indexOf( l30.GET( lastRef));//en la lista el ultimo item de ref
  if (( k == -1) || ( l == -1)) {
    frame30.kbm2lSystem.append( "proyectionPar. REFERENCE MODEL NOT FOUND.Y\n");  
    frame30.kbm2lSystem.append( "fr; " + firstRef + "   k: " + k + "\n");
    frame30.kbm2lSystem.append( "lr; " + lastRef  + "   l: " + l + "\n");
    return;
    }//if

//el RefModel es conocido.
  long KBRef =0;
  for( int i = k; i <= l; i++) {
	 KBRef = KBRef + (l30.GET( l30.GetIndice( i)).getLongitud()).longValue();
    if ( l30.esUNKB( l30.GET( l30.GetIndice( i))))  {
      frame30.kbm2lSystem.append( "proyectionPar_. REFERENCE MODEL NOT FOUND.X\n");  
      frame30.kbm2lSystem.append( "i " + i + "  with unKB response.\n");
      frame30.kbm2lSystem.append( "fr; " + firstRef + "   k: " + k + "\n");
      frame30.kbm2lSystem.append( "lr; " + lastRef  + "   l: " + l + "\n");
      return;
      }//if
    }//for
   
  frame30.kbm2lSystem.append( "refMOD: k: " + k + "  l: " + l + ".\n");
  frame30.kbm2lSystem.append( "projectionPar_.\n");    
  frame30.kbm2lSystem.append( "REF.   k: " + k + "   l: " + l + "   KBRef: " + KBRef + 
    "   KB/KBRef: " + (listStat30.KB( l30)).longValue()/KBRef + "\n");    

 } catch (Exception e) {
    System.out.println( ERROR + "refmodel.");
    frame30.exit( 0, e);
  }//catch

  return;  
}//REFmodel

/**
* REFModel.
* Los parametros estan todos a la izquierda en la base.
* @param l30 lista con el esquema de parametros.
*/
protected void refmodel( lista30 l30, Vector PARAMS) {

  try {
  
    Vector firstRef = new Vector();//indice del caso primero del RefModel
    firstRef = index30.cpT( PARAMS, l30.dimparam);
    for( int i =l30.dimparam+1; i < l30.dimension() ; i++)
      firstRef.add( new Integer( 0));
    frame30.kbm2lSystem.append( "firstRef: " + firstRef.toString( ) + ".\n");

    Vector lastRef  = new Vector();//indice del caso ultimo del RefModel
    lastRef = index30.cpT( PARAMS, l30.dimparam);
    for( int i =l30.dimparam+1; i < l30.dimension() ; i++)
      lastRef.add( new Integer(( l30.Base.dom(i)-1)));
    frame30.kbm2lSystem.append( "lastRef: " + lastRef.toString( ) + ".\n");

//k < l
  k = l30.indexOf( l30.GET( firstRef));//en la lista el primer item de ref
  l = l30.indexOf( l30.GET( lastRef));//en la lista el ultimo item de ref
  if (( k == -1) || ( l == -1)) {
    frame30.kbm2lSystem.append( "proyectionPar. REFERENCE MODEL NOT FOUND.Y\n");  
    frame30.kbm2lSystem.append( "fr; " + firstRef + "   k: " + k + "\n");
    frame30.kbm2lSystem.append( "lr; " + lastRef  + "   l: " + l + "\n");
    return;
    }//if

//el RefModel es conocido.
  long KBRef =0;
  for( int i = k; i <= l; i++) {
	 KBRef = KBRef + (l30.GET( l30.GetIndice( i)).getLongitud()).longValue();
    if ( l30.esUNKB( l30.GET( l30.GetIndice( i))))  {
      frame30.kbm2lSystem.append( "proyectionPar_. REFERENCE MODEL NOT FOUND.X\n");  
      frame30.kbm2lSystem.append( "i " + i + "  with unKB response.\n");
      frame30.kbm2lSystem.append( "fr; " + firstRef + "   k: " + k + "\n");
      frame30.kbm2lSystem.append( "lr; " + lastRef  + "   l: " + l + "\n");
      return;
      }//if
    }//for
   
  frame30.kbm2lSystem.append( "refMOD: k: " + k + "  l: " + l + ".\n");
  frame30.kbm2lSystem.append( "projectionPar_.\n");    
  frame30.kbm2lSystem.append( "REF.   k: " + k + "   l: " + l + "   KBRef: " + KBRef + 
    "   KB/KBRef: " + (listStat30.KB( l30)).longValue()/KBRef + "\n");    

 } catch (Exception e) {
    System.out.println( ERROR + "refmodel.");
    frame30.exit( 0, e);
  }//catch

  return;  
}//refmodel

/**
* Determina si el item es el comienzo de un modelo conocido.
**/
protected boolean beginModel( lista30 l30, int i) {

  try {	

  if ( l30.esUNKB( l30.Get( i))) 
    return false;

  if ( i == 0) 
    return true;

  Vector Inf = l30.Inf( i);
  Vector Sup = l30.Sup( i);
  Vector firstRef = new Vector();//indice del caso primero del Model
  firstRef = index30.cpT( Inf, l30.dimparam);
  for( int j = l30.dimparam+1; j < l30.dimension() ; j++)
    firstRef.add( new Integer( 0));

  if ( index30.myeqT( firstRef, Inf) && index30.myeqT( Sup, firstRef)) { 
    return true;
    }

 } catch (Exception e) {
    System.out.println( ERROR + "beginModel.");
    frame30.exit( 0, e);
  }//catch

  return false;  
}//beginModel

/**
* Determina si el item es el final de un modelo conocido.
**/
protected boolean endModel( lista30 l30, int i) {

  try {

  if ( l30.esUNKB( l30.Get( i))) 
    return true;
	  	
  if ( i ==( l30.size()-1)) 
    return true;

  Vector Inf = l30.Inf( i);
  Vector Sup = l30.Sup( i);
  Vector lastRef = new Vector();//indice del caso primero del Model
  lastRef = index30.cpT( Sup, l30.dimparam);
  for( int j = l30.dimparam+1; j < l30.dimension() ; j++)
    lastRef.add( new Integer( l30.Base.dom( j)-1));

  if ( index30.myeqT( lastRef, Inf) && index30.myeqT( Sup, lastRef)) {
    return true;
    }
	
 } catch (Exception e) {
    System.out.println( ERROR + "endModel.");
    frame30.exit( 0, e);
  }//catch

  return false;  
}//endModel

}//class proyection30
