//PROYECTIONATT30//
package analysis;

//
import java.lang.Object.*;
import java.util.*;
import java.lang.*;
import java.io.*;
import java.math.*;
import java.awt.*;

//
import kernel.*;
import control.*;
import kbm2l.*;
import tables.*;

/**
* Clase proyectionAtt30, atributos.
* @author Juan A. Fdez del Pozo de Salamanca
* @version 3.0
**/
public class proyectionAtt30  implements  Runnable  {

  private static final String ERROR = "Error(proyectionAtt30): ";

/**
* Constructor por defecto
**/
public proyectionAtt30( ) {

}//proyectionAtt30

/**
* proyeccion la lista sobre la respuesta RESP
* @param l30 lista de trabajo
* @param a att's de pliegue  pppppaaa  a=5
* @param RESP respuesta
*/
public lista30 proyectionAtt( lista30 l30, int a, Vector RESP) {
  
  frame30.kbm2lSystem.append( "proyeccionAtt. List R: " + RESP.toString() + ".\n");
  lista30 g30 = new lista30( l30.Esqu);// vacia con 8 dim 0-7
  try {
  for( int i = 0; i < a; i++) {
    g30.Get(0).GetIndice().remove(0);//borra los parametros 0-5.
    }
  } catch (Exception e) {
    System.out.println( ERROR + "proyeccionAtt.0");
    frame30.exit( 0);
  }//catch

  try {
  for( int i = 0; i < a; i++) {
    g30.Base.remove(0);//DOM,BAS,ATT,ROL,IMP 
    }
  for( int i = 0; i < g30.Base.size(); i++) {
    g30.Base.bas(i,i);//canonica
    }
  } catch (Exception e) {
    System.out.println( ERROR + "proyeccionAtt.1");
    e.printStackTrace();    
    frame30.exit( 0);
  }//catch

  try {
  g30.Esqu.nombre = "gsa-"+g30.Esqu.nombre;
  g30.Esqu.numAtributos = l30.dimension()-a;
  for( int i = 0; i < a; i++) {
    g30.Esqu.remove(0);
    }  

  g30.ParIndice( l30.dimension()-a); //quedan 3 att's
  g30.Name( "g-"+l30.Name());

  } catch (Exception e) {
    System.out.println( ERROR + "proyeccionAtt.2");
    frame30.exit( 0);
  }//catch

  frame30.kbm2lBrowser.summaryView( g30);

  item30 item = null;
  Vector INDEX = null; // recorrido de this
  System.out.println( "projectionAtt.");
  try {
  Vector DOMINIO = l30.Base.Dom();
  Vector ULTIMO = index30.ultimoT( DOMINIO);
  long cases = listStat30.KB( l30).longValue(); 
    for( INDEX = index30.primeroT( DOMINIO);
         index30.myeqT( ULTIMO, INDEX);
         INDEX = index30.siguienteT( DOMINIO, INDEX)) {

       item = l30.GET( INDEX);///!!!
       if ( index30.eqS( item.GetRespuesta(), RESP)) {  
          Vector redINDEX = new Vector();
          for( int i = a; i < INDEX.size(); i++)
            redINDEX.add( new Integer(((Integer)INDEX.get(i)).intValue())); 
          Vector RESPUESTA = item.GetRespuesta();
          Vector MEDIDA = item.GetMedida();
          if ( !index30.eqS( g30.GET(redINDEX).GetRespuesta(), RESP))
            g30.Set( new item30( g30, MEDIDA, RESP, redINDEX));// ! - sensible

          }//-if-unKB
          else { frame30.kbm2lSystem.estatus( "proyectionAtt: " + cases--);   
            INDEX = item.GetIndice(); }//salta el item UNKB

         if ( index30.eqT( ULTIMO, INDEX)) { break; }
  
      }//for-INDEX
  } catch (Exception e) {
    System.out.println( ERROR + "proyeccionAtt.3");
    frame30.exit( 0);
  }//catch

  listStat30.calc( g30);
  frame30.kbm2lBrowser.summaryView( g30);

  return g30;  
}//proyectionAtt

/**
*
**/
public void proyectionAtt( lista30 l30) {

  lista30 g30 = null;
  if ( listStat30.KB( l30, l30.RSKB).doubleValue() > 0.0) {
    g30 = proyectionAtt( l30, 10, l30.RSKB);//a==10    
    new outputList30( ).escribeKBM2L( g30,
      dato30.workspace + dato30.extFile( dato30.nameFile( g30.Name()), "hkb"));//no filedlg        
    }//if
    else frame30.kbm2lSystem.estatus("proyection. Any: " + l30.RSKB);

  return;
}//proyectionAtt

/**
* Run.
**/
public void run() {

  try {
    long ts0 = (new Date()).getTime();
    Vector ipd = protocolo30.ipdAccess( "");//filename, dimparam, PARAMS, Decs
    frame30.activel30.dimparam = ((Integer)(ipd.get(1))).intValue();
    frame30.activel30.PARAMS = (Vector)(ipd.get(2));
    proyectionAtt( frame30.activel30);
    frame30.kbm2lTime.append("proyeccion:: " + (new Date().getTime() - ts0) + ".\n");        
 }//try
  catch (Exception e) {
    System.out.println( ERROR + "run().");
    e.printStackTrace();
    System.exit( 0);
  }//catch
  return;
}//run

}//class proyectionAtt30
