//RESPONSE30//
package analysis;

//
import java.lang.Object.*;
import java.util.*;
import java.lang.*;
import java.io.*;
import java.math.*;
import java.awt.*;

//
import control.*;
import kernel.*;
import kbm2l.*;
import tables.*;
import synthesis.*;

/**
* Clase response30,....
* @author Juan A. Fdez del Pozo de Salamanca
* @version 3.0
**/
public class response30  extends  analisis30  {

  private static final String ERROR = "Error(response30): ";

/**
* Constructor por defecto
**/
public response30( ) {

}//response30

/**
* Vacia la lista de valores de respuesta no sensible, RSKB, para el analisis de sensiblidad.
* Genera las r listas eliminando todos los valores de respuesta excepto el i, i=1..r, 
* para analisis semantico y explicaciones focalizadas.
**/
public lista30 response( lista30 l30) {

  Vector ipd = protocolo30.ipdAccess( "");//filename, dimparam, PARAMS, Decs
  frame30.activel30.dimparam = ((Integer)(ipd.get(1))).intValue();
  frame30.activel30.PARAMS = (Vector)(ipd.get(2));

  if ( listStat30.KB( l30, l30.RSKB).doubleValue() > 0.0) {
    l30.response( l30.RSKB);   
    for( int i = 0; i < l30.size(); i++) {
      if (!l30.esUNKB(l30.Get(i)))
      if (l30.Get(i).getLongitud().doubleValue() > 10000)
        frame30.kbm2lSystem.append(i+"  run  "+ l30.Get(i).getLongitud().toString()+"\n");
      }        
    new outputList30( ).escribeKBM2L( l30,
      dato30.workspace + 
      dato30.extFile( 
      dato30.nameFile( "r-"+l30.Name()), "hkb"));//no filedlg        
    }//if  
    else frame30.kbm2lSystem.estatus("response. Any: " + l30.RSKB);

  Vector DS = listStat30.DS( l30);//todos los valores de respuesta de l30
  for(int i = 0; i < DS.size(); i++) {
    lista30 r30 = new lista30( l30, l30);//copia completa
    Vector RESPUESTA = (Vector)(DS.get( i));
    r30.response( RESPUESTA);//focus on RESPUESTA
    for( int j = 0; j < r30.size(); j++) {
      if (!r30.esUNKB(r30.Get(j)))
      if (r30.Get(j).getLongitud().doubleValue() > 10000)    
        frame30.kbm2lSystem.append(i+"  run  "+ r30.Get(j).getLongitud().toString()+"\n");
      }//for-j  
    frame30.kbm2lSystem.append("R:"+i+"  R:"+ RESPUESTA.toString()+"\n");
    new outputList30( ).escribeKBM2L( r30,
      dato30.workspace + 
      dato30.extFile( 
      dato30.nameFile( "r-"+RESPUESTA.toString()+"-"+r30.Name()), "hkb"));//no filedlg        
    }//for-i

  return l30;
}//response 

}//class response30
