//modelo30//
package modelo;

//
import java.util.*;
import java.lang.*;
import java.io.*;
import java.math.*;
import java.awt.*;

//
import kernel.*;
import kbm2l.*;

/**
* Clase modelo30
*
* @author Juan A. Fdez del Pozo de Salamanca
* @version 3.0
**/
public class modelo30  extends  frame30  
{

  private static final String ERROR = "Error(modelo30): ";
  private static Random gr = new Random(1227);
  int NumeroVariables = 0;
  int NumeroRestricciones = 0;
  int MaximoValorVariable = 0;

  public Vector Variables = null;//0--MaxValVar
  Vector CoefObj = null;//int
  double ObjetivoMaximo = 0;// max
  Vector CoefRec = null;//int
  Vector Restricciones = null;// todas <=
  Vector RestriccionValor = null;//int
  Vector RestriccionFactible = null;// Restricciones[i](Variable) <= CoefRec[i]

public modelo30( ) {

//leer modelo

}//modelo30 

public modelo30( int NumeroVariables, 
  int NumeroRestricciones, int MaximoValorVariable) {

  kbm2lSystem.append("Modelo: var-" + NumeroVariables + 
    "  res-" + NumeroRestricciones + ".\n");

  this.NumeroVariables = NumeroVariables;
  this.NumeroRestricciones = NumeroRestricciones;
  this.MaximoValorVariable = MaximoValorVariable;

//Modelo PE
  CoefObj = new Vector();
  for(int i = 0; i < NumeroVariables; i++) 
    CoefObj.add( new Integer( gr.nextInt( 10) - gr.nextInt( 10)));  
  if (NumeroVariables <= 20)
    kbm2lSystem.append("Objetivo: " + CoefObj.toString() + ".\n");
  Restricciones = new Vector();
  CoefRec = new Vector();
  for(int i = 0; i < NumeroRestricciones; i++) {
    Vector restriccion = new Vector();
    for(int j = 0; j < NumeroVariables; j++) 
      restriccion.add( new Integer( gr.nextInt( 10) - gr.nextInt( 10)));
    int cr = gr.nextInt( 10) + 1;  
    if (NumeroRestricciones <= 30)
      kbm2lSystem.append("Restriccion: " + restriccion.toString() + 
        " <= " + cr + ".\n");
    Restricciones.add( restriccion);  
    CoefRec.add( new Integer( cr));
    }

}//modelo30

public boolean leerModelo( String pathModelo) {


  return true;
}//leerModelo

public boolean guardarModelo( ) {


  return true;
}//guardarModelo

public double Objetivo( ) {

  int objetivo = 0;
  for(int i=0;i<NumeroVariables;i++) {
    int c = ((Integer)CoefObj.get( i)).intValue();
    int v = ((Integer)Variables.get( i)).intValue();
    objetivo = objetivo + c*v;
    }//for

  return objetivo;
}//Objetivo

public boolean Restriccion( int restriccion) {
  int valor = 0;
  Vector RESTRICCION = (Vector)(Restricciones.get( restriccion));
  for(int i = 0; i < NumeroVariables; i++) {
    int r = ((Integer)RESTRICCION.get( i)).intValue();
    int v = ((Integer)Variables.get( i)).intValue();
    valor = valor + r*v;
    }//for

  if (restriccion == 0) RestriccionValor = new Vector();
  RestriccionValor.add( new Integer( valor));
  int b = ((Integer)CoefRec.get( restriccion)).intValue();

  return ( valor <= b);//factible
}//Restriccion

public Vector Factible( int RF) {

  Vector factible = new Vector();// restriccion inst-fact
  double objetivo = 0;
  for(int i = 0; i < NumeroRestricciones; i++) {
    if ( Restriccion( i))
      factible.add( new Integer( 1));//es fact
      else factible.add( new Integer( 0));//es infact
    }//for

//simplificacion
  int rf = 0;       
  for(int i = 0; i < NumeroRestricciones; i++) 
    if ( ((Integer)factible.get(i)).intValue() == 0 ) rf++;
          
  if (rf >= RF)
  for(int i = 0; i < NumeroRestricciones; i++) 
    factible.set(i, new Integer( 0));
   
       
  return factible;
}//Factible

public Vector GenerarVariableUniforme( ) {
  Variables = new Vector();
  for(int i = 0; i < NumeroVariables; i++)
    Variables.add( new Integer( gr.nextInt( MaximoValorVariable+1)));
    
  return Variables;
}//GenerarVariableUniforme

public Vector GenerarVariableEntorno( Vector Variables) {
  this.Variables = index30.cpT( Variables);
  int j = gr.nextInt( NumeroVariables);
  this.Variables.set( j, new Integer( gr.nextInt( MaximoValorVariable+1)));
    
  return this.Variables;
}//GenerarVariableEntorno

public void Refinar( double subobj) {

  try {
  NumeroRestricciones++;
  CoefRec.add( new Integer( - (int)subobj));
  Vector restriccion = new Vector();
  for(int j = 0; j < NumeroVariables; j++) 
    restriccion.add( new Integer( - ((Integer)CoefObj.get( j)).intValue()));
  Restricciones.add( restriccion);  
  } catch (Exception e){
      System.out.println("e. Refinar - modelo.");
      e.printStackTrace();
  }

  return;
}//Refinar

}//class modelo30