//rules30//
package cpt;

//
import java.util.*;
import java.lang.*;
import java.io.*;

//
import kernel.*;
import kbm2l.*;

/**
* rules, casos genericos. Preguntas abiertas inversas.
* systematic, domain, constrainst, modulaiting
* @author Juan A. Fdez del Pozo de Salamanca
* @version 3.0
**/
public  class  rules30 extends cpt30  implements  Runnable  {

  private static final String ERROR = "Error(rules30): ";

/**
*
**/
public rules30() {

  System.out.println( "rules.");
}//

//pxy ! Chgb bajo condicionado a una pat es p = random(1.0/3)
private static boolean age( Vector INDEX) {

  int pth = 0;
  if ( ((Integer)INDEX.get( 0)).intValue() != (f30.activel30.Base.dom(0)-1)) 
    return false;//prob == 1.0
  if ( ((Integer)INDEX.get( 1)).intValue() != 1) return false;//Chgb = 1
    //free age.
  for( int i = 3; i < INDEX.size(); i++) {//pth
    if ( ((Integer)INDEX.get( i)).intValue() > 0) pth++;
    }//

  if (pth==0) return true;
  return false;
}

//pxy ! Chgb bajo condicionado a una pat es p = random(1.0/3)
private static boolean pth( Vector INDEX) {

  int pth = 0;
  if ( ((Integer)INDEX.get( 0)).intValue() != (new Random(1492).nextInt(f30.activel30.Base.dom(0)/3))) 
    return false;//prob == 1.0
  if ( ((Integer)INDEX.get( 1)).intValue() != 1) return false;//Chgb = 1
    //free age.
  for( int i = 3; i < INDEX.size(); i++) {//pth
    if ( ((Integer)INDEX.get( i)).intValue() > 0) pth++;
    }//

  if (pth==1) return true;
  return false;
}

//pxy ! Chgb bajo condicionado a dos pats es p = random(1.0/6)
private static boolean pthpth( Vector INDEX) {

  int pth = 0;
  if ( ((Integer)INDEX.get( 0)).intValue() != (new Random(1492).nextInt(f30.activel30.Base.dom(0)/6))) 
    return false;//prob == 1.0
  if ( ((Integer)INDEX.get( 1)).intValue() != 1) return false;//Chgb = 1
    //free age.
  for( int i = 3; i < INDEX.size(); i++) {//pth
    if ( ((Integer)INDEX.get( i)).intValue() > 0) pth++;
    }//

  if (pth==2) return true;
  return false;
}

//pxy ! Chgb bajo condicionado a tres o mas pats es p= 1.0
private static boolean low3mas( Vector INDEX) {

  int pth = 0;
  if ( ((Integer)INDEX.get( 0)).intValue() != (f30.activel30.Base.dom(0)-1)) return false;//prob == 1.0
  if ( ((Integer)INDEX.get( 1)).intValue() != 0) return false;//Chgb = 0
    //free age.
  for( int i = 3; i < INDEX.size(); i++) {//pth
    if ( ((Integer)INDEX.get( i)).intValue() > 0) pth++;
    }//

  if ( pth >= 3) return true;
  return false;
}

//pxy! 
private static boolean normal3mas( Vector INDEX) {

  int pth = 0;
  if ( ((Integer)INDEX.get( 0)).intValue() != 0) return false;//prob == 1.0
  if ( ((Integer)INDEX.get( 1)).intValue() != 1) return false;//Chgb = 1
    //free age.
  for( int i = 3; i < INDEX.size(); i++) {//pth
    if ( ((Integer)INDEX.get( i)).intValue() > 0) pth++;
    }//

  if ( pth >= 3) return true;
  return false;
}

//pxy! 
private static boolean high3mas( Vector INDEX) {

  int pth = 0;
  if ( ((Integer)INDEX.get( 0)).intValue() != 0) return false;//prob == 1.0
  if ( ((Integer)INDEX.get( 1)).intValue() != 2) return false;//Chgb = 2
    //free age.
  for( int i = 3; i < INDEX.size(); i++) {//pth
    if ( ((Integer)INDEX.get( i)).intValue() > 0) pth++;
    }//

  if ( pth >= 3) return true;
  return false;
}

//pxy!
private  static  boolean any4mas( Vector INDEX) {

  int pth = 0;
  //free p
  //freeChgb
  //free age.
  for( int i = 3; i < INDEX.size(); i++) {//pth
    if ( ((Integer)INDEX.get( i)).intValue() > 0) pth++;
    if ( pth > 4) return true;
    }//

  return false;
}

//pxy!
private  static  boolean pth1with8( Vector INDEX) {

    if (( ((Integer)INDEX.get( 3)).intValue() == 1) && // pth1
        ( ((Integer)INDEX.get( 10)).intValue() == 1)) {  //pth8
      return true;
    }//

  return false;
}

//pxy!
private  static  boolean cr_agewithpth( Vector INDEX) {

  if (((Integer)INDEX.get( 2)).intValue() == 0) { //no cr_age
    int pth = 0;
    for( int i = 3; i < INDEX.size(); i++) {//pth
      if ( ((Integer)INDEX.get( i)).intValue() > 0) pth++;
      if (( pth == 1) || ( pth == 2))  return true;
      }//
  }//

  return false;
}

/**
* false a los casos de probabilidad generados por el INDEX variando p distinto de p1
**/
private static void remove( lista30 l30, Vector INDEX, int p1) {

  Vector indice = index30.cpT( INDEX);
  Vector MEDIDA = new Vector();
  MEDIDA.add( new Double( -1.0));
  Vector RESPUESTA = new Vector();
  RESPUESTA.add( new Integer( 0));//false
  for( int p = 0; p < f30.activel30.Base.dom(0); p++) {
    if ( p != p1) {
      indice.set(0, new Integer( p));
      item30 nuevoItem = new item30( l30, MEDIDA, RESPUESTA, indice);
      int regla = l30.Set( nuevoItem);       
      }//if
    }//for
} 

/**
* rules. logical type !
* El orden las reglas ?
**/
public  static  int  rules( lista30 l30) {
//0    1   2    3    4    5    6    7    8    9   10
//P(Chgb|Age,Pth0,Pth1,Pth2,Pth3,Pth4,Pth5,Pth6,Pth7)

  Vector INDEX = null;//contador de indice;
  Vector MEDIDA = null;//
  Vector RESPUESTA = null;//
  Vector INDICE = index30.cpT( index30.ultimoT( l30.Base.Dom()));//limite de copia;
  int regla = -1;//
  
  working  = true;
  kbm2lSystem.append("Rules - Init.\n");
  kbm2lSystem.append("Items: " + l30.size() + "  Cases: " + listStat30.KB( l30) + ".\n");

    for( INDEX = index30.cpT( index30.primeroT( l30.Base.Dom()));
         index30.myeqT( INDICE, INDEX);// (INDICE >= INDEX)
         INDEX = index30.siguienteT( l30.Base.Dom(), INDEX)) { // INDEX++

      if ( !working) { break; }

        MEDIDA = new Vector();
        MEDIDA.add( new Double( -1.0));

//P(-|mas de 4) = false.
//P(-|pth1 & pth8) = false. 
        if ( any4mas( INDEX) || pth1with8( INDEX)) {
          RESPUESTA = new Vector();
          RESPUESTA.add( new Integer( 0));//false
          item30 nuevoItem = new item30( l30, MEDIDA, RESPUESTA, INDEX);
          regla = l30.Set( nuevoItem); 
          }

//r
        if ( l30.esUNKB( l30.GET( INDEX)) && (pth( INDEX) || pthpth( INDEX) || age(INDEX))) {
          RESPUESTA = new Vector();
          RESPUESTA.add( new Integer( 1));//true
          int p1 = ((Integer)INDEX.get(0)).intValue();
          item30 nuevoItem = new item30( l30, MEDIDA, RESPUESTA, INDEX);//p1
          regla = l30.Set( nuevoItem); 
          remove( l30, INDEX, p1);
          Vector indice = index30.cpT( INDEX);
          int p0 = Math.max( 0, f30.activel30.Base.dom(0)-1-p1); 
          indice.set(0, new Integer( p0));
          indice.set( 1, new Integer( 0));
          nuevoItem = new item30( l30, MEDIDA, RESPUESTA, indice);
          regla = l30.Set( nuevoItem); 
          remove( l30, indice, p0);
          int p2 = Math.max( 0, f30.activel30.Base.dom(0)-1-p1-p0); 
          indice.set(0, new Integer( p2));
          indice.set( 1, new Integer( 2));
          nuevoItem = new item30( l30, MEDIDA, RESPUESTA, indice);
          regla = l30.Set( nuevoItem); 
          remove( l30, indice, p2);
          }

//P(low| 3 o mas) = 1.0, true
        if ( l30.esUNKB( l30.GET( INDEX)))
        if ( low3mas( INDEX) || normal3mas( INDEX) || high3mas( INDEX)) {
          RESPUESTA = new Vector();
          RESPUESTA.add( new Integer( 1));//true
          item30 nuevoItem = new item30( l30, MEDIDA, RESPUESTA, INDEX);
          regla = l30.Set( nuevoItem); 
          remove( l30, INDEX, f30.activel30.Base.dom(0)-1);
          }

      f30.kbm2lSystem.estatus( "Rules: " + l30.size() + "  INDEX: " + INDEX.toString());
      if ( index30.eqT( INDICE, INDEX)) { break; }

     }//FOR
  f30.kbm2lSystem.append( "Rules-end.\n");

//R2
//    for( INDEX = index30.cpT( index30.primeroT( l30.Base.Dom()));
//         index30.myeqT( INDICE, INDEX);// (INDICE >= INDEX)
//         INDEX = index30.siguienteT( l30.Base.Dom(), INDEX)) { // INDEX++

//      if ( !working) { break; }

//        MEDIDA = new Vector();
//        MEDIDA.add( new Double( -1.0));

//p(-|age & pthx) = +10%
//        if (cr_agewithpth( INDEX)) {        
//          if ( ((Integer)l30.GET( INDEX).GetRespuesta().get(0)).intValue()==1) {
//          RESPUESTA = new Vector();
//          RESPUESTA.add( new Integer( 1));//true
//          int p10 = Math.min( 1, (int)(((Integer)INDEX.get( 0)).intValue()*1.10));
//          Vector cr_INDEX = index30.cpT( INDEX); 
//          cr_INDEX.set( 0, new Integer( p10));
//          cr_INDEX.set( 2, new Integer( 1));
//          item30 nuevoItem = new item30( l30, MEDIDA, RESPUESTA, cr_INDEX);
//          regla = l30.Set( nuevoItem); 
//          remove( l30, cr_INDEX, p10);
//          Vector indice = index30.cpT( cr_INDEX);
//          int p1 = ((Integer)cr_INDEX.get(0)).intValue();
//          int p0 = Math.max( 0, f30.activel30.Base.dom(0)-1-p1); 
//          indice.set(0, new Integer( p0));
//          indice.set( 1, new Integer( 0));
//          nuevoItem = new item30( l30, MEDIDA, RESPUESTA, indice);
//          regla = l30.Set( nuevoItem); 
//          remove( l30, indice, p0);
//          int p2 = Math.max( 0, f30.activel30.Base.dom(0)-1-p1-p0); 
//          indice.set(0, new Integer( p2));
//          indice.set( 1, new Integer( 2));
//          nuevoItem = new item30( l30, MEDIDA, RESPUESTA, indice);
//          regla = l30.Set( nuevoItem); 
//          remove( l30, indice, p2);
//            }
//          }        
        
//      if ( index30.eqT( INDICE, INDEX)) { break; }
      
//      f30.kbm2lSystem.estatus( "Rules2: " + l30.size());

//     }//for

  kbm2lSystem.append("Items: " + l30.size() + "  Cases: " + listStat30.KB( l30) + ".\n");
  kbm2lSystem.append("Constraint Table - End.\n");
  working  = false;
  return l30.size();  
}//rules

/**
* rule: Systematic. 
**/
private long rule( lista30 l30, Vector Index, boolean r) {

  long cases = 0;

  return cases;  
}//rule

/**
* Run.
**/
public void run() {

  if ( !working) {
  try {
    rules( f30.activel30);
  }//try
  catch (Exception e) {
    System.out.println( ERROR + "run().");
    e.printStackTrace();
    System.exit( 0);
  }//catch
  }
  return;
}//run

}//class main30