//ITEMCOPY30//
package kernel;

//
import java.util.*;
import java.lang.*;
import java.io.*;
import java.math.*;

//
import kbm2l.*;
import control.*;
import target.*;
import synthesis.*;

/**
* Clase itemCopy30. Copia y union de items.
* @author Juan A. Fdez del Pozo de Salamanca
* @version 3.0
**/
public  class  itemCopy30  implements  Runnable  {

  private static final String ERROR = "Error(itemCopy30): ";

  private int l30Switches = 0;//cota
  private int lTargetSwitches = 0;//test

  private lista30 l30 = null; 
  private lista30 lTarget = null;
  private int k = -1;//item number

/**
* Constructor por defecto
**/
public itemCopy30( ) {

}//itemCopy30

/**
* Constructor para Threads
**/
public itemCopy30( lista30 l30, lista30 lTarget, int k) {

  this.l30 = l30;
  this.lTarget = lTarget;
  this.k = k;
}//itemCopy30


/**
* std-cpi item de l30 en lTarget desde INDICE0 hasta INDICE ( de ITEM).
* Si Stop: return null;//incompleta. 
* Si hay OVF de items: return null;//incompleta
* Si falla el test: return null;//incompleta
* @param l30 lista origen
* @param lTarget lista nueva
* @param i ordinal del item
* @return lTarget lista con los nuevos casos.
**/
public synchronized lista30 stdCpi( lista30 l30, lista30 lTarget, int i) {

  if ( l30 == null) {
    System.out.println( ERROR + "stdCpi-0. l30");
    new Exception().printStackTrace();
    frame30.exit( -1);
    }
  if ( lTarget == null) {
    System.out.println( ERROR + "stdCpi-0. lTarget");
    new Exception().printStackTrace();
    frame30.exit( -1);
    }

  Vector INDICE0 = null;
  item30 ITEM = null;
  try {
    if ( i-1>=0)  
      INDICE0 = index30.siguienteT( l30.Base.Dom(), l30.Get( i-1).GetIndice()); 
      else INDICE0 = index30.primeroT( l30.Base.Dom());
    ITEM = l30.Get( i);
  } catch (NullPointerException e) {
    System.out.println( ERROR + "stdCpi-0.");
    e.printStackTrace();
    frame30.exit( -1);
  }//catch

  Vector INDEX = null;//contador de indice;
  Vector MEDIDA = ITEM.GetMedida();//para todos;
  Vector RESPUESTA = ITEM.GetRespuesta();//para todos;
  Vector INDICE = ITEM.GetIndice();//limite de copia;
  Vector indice = null;//contador transformado, en la base lTarget
  int regla = -1;//

  l30.Switches( l30.size());//cota
  Vector ULTIMO = index30.ultimoT( l30.Base.Dom());//indice ultimo

  boolean chk = new controlPrefs30().checkMode();
  boolean threadMode = new controlPrefs30().threadMode();

  try {
    long cases = 0;
    for( INDEX = index30.cpT( INDICE0); // inicial
         index30.myeqT( INDICE, INDEX); // (INDICE >= INDEX)
         INDEX = index30.siguienteT( l30.Base.Dom(), INDEX)) { // INDEX++

      item30 nuevoItem = null; // in ITEM
      try {
        if ( INDEX == null) {
          System.out.println( ERROR + "stdCpi-0. INDEX");
          System.exit( 0);
          }
        // CAMBIO DE BASE de INDEX( l30 ---> lTarget)
        indice = base30.Trnp( l30.Base, INDEX, lTarget.Base); 
      } catch (Exception e) {
        System.out.println( ERROR + "stdCpi-1.");
        e.printStackTrace();
        frame30.exit( -1);
      }//catch

      try {

//// SYNCHRONIZED
  synchronized( lTarget) {

       nuevoItem = new item30( lTarget, MEDIDA, RESPUESTA, indice);
       regla = lTarget.Set( nuevoItem); 

  }//SYNCHRONIZED

      if ( lTarget.size() > lTarget.limitItems) {
        System.out.println( ERROR + " /Items-OVF/ stdCPi.   Rule: " + regla + ".");
        System.out.println( lTarget.size() + " > " + lTarget.limitItems + ".");
        frame30.kbm2lTime.append( ERROR + " /Items-OVF/ stdCPi.   Rule: " + regla + ".\n");
        frame30.kbm2lTime.append( lTarget.size() + " > " + lTarget.limitItems + ".\n");
        return null;//incompleta   
        }//if

      } catch (Exception e) {
        System.out.println( ERROR + "stdCpi-2.");
        e.printStackTrace();
        frame30.exit( -1);
      }//catch
       
      if ( index30.eqT( ULTIMO, INDEX)) {
        if ( listTest30.test( l30, lTarget)) {
          if ( chk) frame30.kbm2lTime.append( "cpi-1-null" + 
            "\n  l30:" + l30.size() + l30.Base.Bas() + 
            "\n   lTarget:" + lTarget.size() + lTarget.Base.Bas() + "\n");
          return null;//incompleta   
          }//if
        return lTarget;//item copiado y lista completa --->>>
        }//if
        
    if ( threadMode)
      if ((( cases++) % 100) == 0) 
        if ( listTest30.test( l30, lTarget)) {//true rechaza el target
          if ( chk) frame30.kbm2lTime.append( "cpi-2-null" + 
            "\n  l30:" + l30.size() + l30.Base.Bas() + 
            "\n   lTarget:" + lTarget.size() + lTarget.Base.Bas() + "\n");
          return null;//incompleta   
          }//if-test

  if ( !sintesis30.working) return l30;
        
    }//for-INDEX
  } catch (Exception e) {
    System.out.println( ERROR + "stdCpi-3.");
    e.printStackTrace();
    frame30.exit( -1);
  }//catch

  if ( threadMode)
    if ( listTest30.test( l30, lTarget)) {//true rechaza el target
      if ( chk) frame30.kbm2lTime.append( "cpi-3-null" + 
        "\n  l30:" + l30.size() + l30.Base.Bas() + 
        "\n   lTarget:" + lTarget.size() + lTarget.Base.Bas() + "\n");
      return null;//incompleta   
      }
    
//  checkList30.CHK( l30, "stdCpi.");
  return lTarget;//item copiado
}//stdCpi

/**
* union: lNew30( INDICE0, INDICE) + l30 -> l30
* Los items unKB (o la MODA) estan filtrados.
* @param l30 target de la union. 
* @param lNew30 estructura de los casos que se trasvasan.
* @param INDICE0 indice primero del ITEM de lNew30.
* @param ITEM contenido a trasvasar y su indice final de lNew30.
* @return l30 lista30 con los casos del ITEM de lNew30.
**/
public lista30 union( lista30 l30, lista30 lNew30, Vector INDICE0, item30 ITEM) {       

  Vector INDEX = null;//Contador de lNew30
  Vector MEDIDA = ITEM.GetMedida();//de lNew30
  Vector RESPUESTA = ITEM.GetRespuesta();//de lNew30
  Vector INDICE = ITEM.GetIndice();//de lNew30
  int regla = -1;
  Vector ULTIMO = index30.ultimoT( lNew30.Base.Dom());//indice ultimo de lNew30

  for( INDEX = index30.cpT( INDICE0); // inicial del ITEM
       index30.myeqT( INDICE, INDEX);// (INDICE >= INDEX)
       INDEX = index30.siguienteT( lNew30.Base.Dom(), INDEX)) {// in ITEM

    regla = l30.Set( new item30( l30, MEDIDA, RESPUESTA, base30.Trnp( lNew30.Base, INDEX, l30.Base)));

    if ( l30.size() > l30.limitItems) {
      System.out.println( ERROR + " /Items-OVF/ stdCPi.  List: " + l30.Name() + "  " + l30.size());
      frame30.kbm2lTime.append( ERROR + " /Items-OVF/ stdCPi.\n");
      frame30.exit( 0);//return l30;
      }//if

    if ( index30.eqT( ULTIMO, INDEX)) 
      return l30;//union completa siempre

    }//FOR-INDEX
        
  checkList30.chk( l30, "union-l30.");
  return l30;//union completa 
}//union

/**
* run()
**/
public void run() {

  try {
    long ts0 = (new Date()).getTime();
    stdCpi( l30, lTarget, k);    
    frame30.kbm2lTime.append("itemCopy30:: " + (new Date().getTime() - ts0) + ".\n");      
  }//try
  catch (Exception e) {
    System.out.println( ERROR + "run().");
    e.printStackTrace();
    frame30.exit( 0, e);
  }//catch

  return;
}//run

}//class itemCopy30
