//LISTPARTIALCOPY30//
package kernel;

//
import java.lang.Object.*;
import java.util.*;
import java.lang.*;
import java.io.*;

//
import control.*;
import synthesis.*;
import target.*;

/**
* Clase listPartialCopy30.
* Procedimiento de transposicion parcial de listas mediante copia de listas.
* @author Juan A. Fdez del Pozo de Salamanca
* @version 3.0
**/
public  class  listPartialCopy30  {

  private static final String ERROR = "Error(listPartialCopy30): ";
/**
* flag de ejecucion en curso
**/
  public static boolean working = false;

///////////////////
/**
* Constructor por defecto
**/
public listPartialCopy30( ) {

}//listPartialCopy30

/**
* Copia de representantes LOW y UPP de items 
* de la lista30 l30 a la lista30 lTarget.
**/
public lista30 cpLOWUPP( lista30 l30, lista30 lTarget) {
//cpLOWUPP ***

  working = true;
  listStat30.moda( l30);

  item30 ITEM = null;
  Vector MEDIDA = null;
  Vector RESPUESTA = null;
  Vector INDICE = null;
  Vector indice = null;
  int regla = -1;
  l30.Switches( l30.size());

//tiempo cp-
 long tcp1 = new Date().getTime();
// k == 0
    try {
      ITEM = l30.Get( 0);//siempre existe.
      RESPUESTA = ITEM.GetRespuesta();

      if ( !index30.eqS( RESPUESTA, l30.MODE)) {// conocimiento
        MEDIDA = ITEM.GetMedida();

        INDICE = index30.primeroT( l30.Base.Dom());// indice LOW
        indice = base30.Trnp( l30.Base, INDICE, lTarget.Base); // CAMBIO DE BASE
        regla = lTarget.Set( new item30( lTarget, MEDIDA, RESPUESTA, indice)); // copy

        INDICE = ITEM.GetIndice();// indice UPP
        indice = base30.Trnp( l30.Base, INDICE, lTarget.Base); // CAMBIO DE BASE
        regla = lTarget.Set( new item30( lTarget, MEDIDA, RESPUESTA, indice)); // copy

      }//if conocimiento
    } catch (Exception e) {
      System.out.println( ERROR  + "cpLOWUPP( lTarget).1");
      e.printStackTrace();
      System.exit( 0);
    }//catch

  for( int k = 1; k < l30.size(); k++) {// in list

    if ( !working) return null;

    try {
      ITEM = l30.Get( k);//siempre existe.
      RESPUESTA = ITEM.GetRespuesta();

      if ( !index30.eqS( RESPUESTA, l30.MODE)) {// conocimiento
        MEDIDA = ITEM.GetMedida();

        INDICE = index30.siguienteT( 
          l30.Base.Dom(), l30.Get( k-1).GetIndice());// indice LOW
        indice = base30.Trnp( l30.Base, INDICE, lTarget.Base); // CAMBIO DE BASE
        regla = lTarget.Set( new item30( lTarget, MEDIDA, RESPUESTA, indice)); // copy

        INDICE = ITEM.GetIndice();// indice UPP
        indice = base30.Trnp( l30.Base, INDICE, lTarget.Base); // CAMBIO DE BASE
        regla = lTarget.Set( new item30( lTarget, MEDIDA, RESPUESTA, indice)); // copy

      }//if conocimiento
    } catch (Exception e) {
      System.out.println( ERROR  + "cpLOWUPP( lTarget).2");
      e.printStackTrace();
      System.exit( 0);
    }//catch

    //tiempo -cp
    if (( new Date().getTime()-tcp1) > fitness30.maxTime) {
      working = false;
      return lTarget;// intenta copia 
      }

    }//for copia extremo inferior de items

  working = false;
  return lTarget;//intentar cpl
}//cpLOWUPP

/**
* Copia de representantes LOW de items.
**/
public lista30 cpLOW( lista30 l30, lista30 lTarget) {
//cpLOW ***

  working = true;
  listStat30.moda( l30);

  item30 ITEM = null;
  Vector MEDIDA = null;
  Vector RESPUESTA = null;
  Vector INDICE = null;
  Vector indice = null;
  int regla = -1;
  l30.Switches( l30.size());

//tiempo cp-
 long tcp1 = new Date().getTime();
// k == 0
    try {
      ITEM = l30.Get( 0);//siempre existe.
      RESPUESTA = ITEM.GetRespuesta();

      if ( !index30.eqS( RESPUESTA, l30.MODE)) {// conocimiento
        MEDIDA = ITEM.GetMedida();
        INDICE = index30.primeroT( l30.Base.Dom());// indice LOW
        indice = base30.Trnp( l30.Base, INDICE, lTarget.Base); // CAMBIO DE BASE
        regla = lTarget.Set( new item30( lTarget, MEDIDA, RESPUESTA, indice)); // copy

      }//if conocimiento
    } catch (Exception e) {
      System.out.println( ERROR  + "cpLOW( lTarget).1");
      e.printStackTrace();
      System.exit( 0);
    }//catch

  for( int k = 1; k < l30.size(); k++) {// in list

    if ( !working) return null;

    try {
      ITEM = l30.Get( k);//siempre existe.
      RESPUESTA = ITEM.GetRespuesta();

      if ( !index30.eqS( RESPUESTA, l30.MODE)) {// conocimiento
        MEDIDA = ITEM.GetMedida();
        INDICE = index30.siguienteT( 
          l30.Base.Dom(), l30.Get( k-1).GetIndice());// indice LOW
        indice = base30.Trnp( l30.Base, INDICE, lTarget.Base); // CAMBIO DE BASE
        regla = lTarget.Set( new item30( lTarget, MEDIDA, RESPUESTA, indice)); // copy

      }//if conocimiento
    } catch (Exception e) {
      System.out.println( ERROR  + "cpLOW( lTarget).2");
      e.printStackTrace();
      System.exit( 0);
    }//catch

    //tiempo -cp
    if (( new Date().getTime()-tcp1) > fitness30.maxTime) {
      working = false;
      return lTarget;// 
      }

    }//for copia extremo inferior de items

  working = false;
  return lTarget;//
}//cpLOW

/**
* Copia de representantes UPP de items.
**/
public lista30 cpUPP( lista30 l30, lista30 lTarget) {
//cpUPP ***

  working = true;
  listStat30.moda( l30);

  item30 ITEM = null;
  Vector MEDIDA = null;
  Vector RESPUESTA = null;
  Vector INDICE = null;
  Vector indice = null;
  int regla = -1;
  l30.Switches( l30.size());

//tiempo cp-
 long tcp1 = new Date().getTime();
// k == 0
  for(int k = 0; k < l30.size(); k++) {// in list

    if ( !working) return null;

    try {
      ITEM = l30.Get( k);// siempre existe.
      RESPUESTA = ITEM.GetRespuesta();

      if ( !index30.eqS( RESPUESTA, l30.MODE)) {// conocimiento
        MEDIDA = ITEM.GetMedida();
        INDICE = ITEM.GetIndice();// indice UPP
        indice = base30.Trnp( l30.Base, INDICE, lTarget.Base); // CAMBIO DE BASE
        regla = lTarget.Set( new item30( lTarget, MEDIDA, RESPUESTA, indice)); // copy

      }// if conocimiento
    } catch (Exception e) {
      System.out.println( ERROR  + "cpUPP( lTarget).1");
      e.printStackTrace();
      System.exit( 0);
    }// catch

    // tiempo -cp
    if (( new Date().getTime()-tcp1) > fitness30.maxTime) {
      working = false;
      return lTarget;// time out 
      }
    
    }// for copia extremo superior de items

  working = false;
  return lTarget;//
}//cpUPP

}//class listPartialCopy30
