//MENUBARCONTROL30//
package menu;

//
import java.awt.*;
import java.awt.event.*;
import java.io.*;

//
import kbm2l.*;

/**
* Clase menuBarControl30
* Declaracin de las entradas del menu la aplicacin
* @author Juan A. Fdez del Pozo de Salamanca
* @version 3.0
**/
public class menuBarControl30  extends  menuControl30  {

  private static final String ERROR = "Error(menuBarControl30): ";
  public MenuBar mainMenu = null;
  private MenuItem menuItemSalir = null;

/**
* Constructor por defecto.
* Llama a los procedimientos que configuran las
* entradas del menu: Ver y Control.
* @param f30 entorno de la aplicacion
**/
public menuBarControl30( frame30 f30) {

//MenuApp
  mainMenu = new MenuBar();

  Control( f30);  
  Preferences( f30);
  Ver( f30);

  return;  
}//menuBarControl30

/**
* Configura la entrada Control del menu con los items:
* Stop, Borrar, Zoom y Salir.
* Pone los items en la lista de escucha de menuListener
* e indica el entorno para pasar parametros a los metodos del menu.
* @param f30 entorno de la aplicacion
* @return void
**/
private void Control( frame30 f30) {

  menuControl = new Menu( strMenuControl);
  mainMenu.add( menuControl);
    menuItemProcs = new MenuItem( strMenuItemProcs);
    menuControl.add(menuItemProcs);
    menuControl.addSeparator();//--------------------
    menuControl.addSeparator();//--------------------
    menuItemBorrar = new MenuItem( strMenuItemBorrar);
    menuControl.add(menuItemBorrar);
    menuControl.addSeparator();//--------------------
    menuControl.addSeparator();//--------------------
    menuItemStop = new MenuItem( strMenuItemStop);
    menuControl.add(menuItemStop);
    menuControl.addSeparator();//--------------------
    menuControl.addSeparator();//--------------------
    menuItemSalir =          new MenuItem( menuSystem30.strMenuItemSalir);
    menuControl.add( menuItemSalir);////

//eventos del menu Control
  menuItemProcs.addActionListener(      new menuListenerControl( f30));
  menuItemBorrar.addActionListener(     new menuListenerControl( f30));
  menuItemStop.addActionListener(       new menuListenerControl( f30));
  menuItemSalir.addActionListener(      new menuListenerControl( f30));////
  
  return;
}//Control() 

/**
* Configura la entrada Preferences del menu con los items:
* Load y Save.
* Pone los items en la lista de escucha de menuListener
* e indica el entorno para pasar parametros a los metodos del menu.
* @param f30 entorno de la aplicacion
* @return void
**/
private void Preferences( frame30 f30) {

  menuPreferences = new Menu( strMenuPreferences);
  mainMenu.add( menuPreferences);
    menuItemLoad =  new MenuItem( strMenuItemLoad);
    menuPreferences.add(menuItemLoad);
    menuItemSave =  new MenuItem( strMenuItemSave);
    menuPreferences.add(menuItemSave);
    menuPreferences.addSeparator();//--------------------
    menuItemReset = new MenuItem( strMenuItemReset);
    menuPreferences.add( menuItemReset);
    menuItemRandomSeed = new MenuItem( strMenuItemRandomSeed);
    menuPreferences.add( menuItemRandomSeed);

  menuItemLoad.addActionListener(        new menuListenerControl( f30));
  menuItemSave.addActionListener(        new menuListenerControl( f30));
  menuItemReset.addActionListener(       new menuListenerControl( f30));
  menuItemRandomSeed.addActionListener(  new menuListenerControl( f30));

  return;
}//Control() 

/**
* Configura la entrada Ver del menu con los items:
* Procesos, Trazas,....
* Pone los items en la lista de escucha de menuListener
* e indica el entorno para pasar parametros a los metodos del menu.
* @param f30 entorno de la aplicacion
* @return void
**/
private void Ver( frame30 f30) {

  menuVer = new Menu( strMenuVer);
  mainMenu.add( menuVer);
    menuItemSynthesisTrace =  new MenuItem( strMenuItemSynthesisTrace);
    menuVer.add(menuItemSynthesisTrace);

  menuItemSynthesisTrace.addActionListener(  new menuListenerControl( f30));
    
//eventos del menu Ver

  return;
}//Ver

}//class menuBarControl30