//menuListenerControl
package menu;

//
import java.awt.*;
import java.awt.event.*;
import java.io.*;

//
import kbm2l.*;
import synthesis.*;
import learning.*;

/**
* Clase menuListenerControl
* SERVIDOR DE ESCUCHA DEL MENU y CONTROLES DE frame
* Las llamadas  los servicios estan agrupadas igual que el menu.
* @author Juan A. Fdez del Pozo de Salamanca
* @version 3.0
**/
class  menuListenerControl  extends  menuControl30  implements ActionListener {

  private static final String ERROR = "Error(menuListenerControl): ";
  private static frame30 f30 = null;//!!!

/**
* Constructor por defecto.
* @param f30 entorno de la aplicacin.
* @return NO
**/
public menuListenerControl( frame30 f30) {

  this.f30 = f30;
}//menuListenerControl

/**
* Alternativas de la barra del menu.
* @param e mensaje de texto que se equipara para seleccionar la accin.
* @return void
**/
public void actionPerformed( ActionEvent e) {

  if ( menuListenerBarControl.Control(  e)) return;

  if ( e.getActionCommand().equals( menuSystem30.strMenuItemSalir)) 
    exit( exitCodeOK);

  if ( menuListenerBarControl.Preferences( e)) return;

  if ( menuListenerBarControl.Ver( e)) return;

  return;
}//actionPerformed

}//class menuListenerControl