//MENUSYSTEM30//
package menu;

//
import java.awt.*;
import java.awt.event.*;
import java.io.*;

//
import kbm2l.*;

/**
* Clase menuSystem30
* Declaracin de las entradas del menu la aplicacin
* @author Juan A. Fdez del Pozo de Salamanca
* @version 3.0
**/
public class menuSystem30  extends  frame30  {

  private static final String ERROR = "Error(menuSystem30): ";

/**
* KBM2L
**/
protected static Menu menuKBM2L; 
protected static final String strMenuKBM2L = "KBM2L"; 
protected static MenuItem menuItemLeerTabla;//listas y tablas
protected static final String strMenuItemLeerTabla = "open kbm2l -*-";
protected static MenuItem menuItemProtocolo;//protocolo de decisiones secuenciales instanciadas
protected static final String strMenuItemProtocolo = "load protocol -*-";
protected static MenuItem menuItemPrincipal;
protected static final String strMenuItemPrincipal = "main";
//---------------------------------
protected static MenuItem menuItemCheck;//CheckList
protected static final String strMenuItemCheck = "check";
protected static MenuItem menuItemVerSummary;//
protected static final String strMenuItemVerSummary = "summary";
protected static MenuItem menuItemVerBrowser;
protected static final String strMenuItemVerBrowser = "browser";
//--------------------------------------
protected static MenuItem menuItemVerSpectrum;
protected static final String strMenuItemVerSpectrum = "spectrum";
protected static MenuItem menuItemZoomMas;
protected static final String strMenuItemZoomMas = "size +++";
protected static MenuItem menuItemZoomMenos;
protected static final String strMenuItemZoomMenos = "size ---";
protected static MenuItem menuItemShiftLeft;
protected static final String strMenuItemShiftLeft = "scroll <<<";
protected static MenuItem menuItemShiftRigth;
protected static final String strMenuItemShiftRigth = "scroll >>>";
//--------------------------------------
protected static MenuItem menuItemGuardarLista;//formato lista texto
protected static final String strMenuItemGuardarLista = "save kbm2l";
protected static MenuItem menuItemGuardarTabla;//formato tabla texto
protected static final String strMenuItemGuardarTabla = "save Table";
protected static MenuItem menuItemGuardarDataFrame;//formato tabla texto
protected static final String strMenuItemGuardarDataFrame = "save Data";
//---------------------------------
public static final String strMenuItemSalir = "Exit !";

/**
* Schema:  
**/
protected static Menu menuSchema; 
protected static final String strMenuSchema = "Schema"; 
protected static MenuItem menuItemEqHkbKBM2L;//esquema ---> cabecera
protected static final String strMenuItemEqHkbKBM2L = "eq -> hkb";
protected static MenuItem menuItemHkbEqKBM2L;//cabecera ---> esquema
protected static final String strMenuItemHkbEqKBM2L = "hkb ->  eq";
//--------------------------------
protected static MenuItem menuItemExtensionAtt;//aade un atributo nuevo con peso maximo.
protected static final String strMenuItemExtensionAtt = "extend Att";
protected static MenuItem menuItemContraccionAtt;//elimina los atributos irrelevantes
protected static final String strMenuItemContraccionAtt = "contract Att";
protected static MenuItem menuItemBreakAtt;//rompe el atributo de mayor peso Att0
protected static final String strMenuItemBreakAtt = "break Att";

protected static MenuItem menuItemSwapAtt;//permuta el atributo Att_i con Att_j
protected static final String strMenuItemSwapAtt = "swap Att";

protected static MenuItem menuItemOnTopAtt;//permuta el atributo de mayor peso Att0 con Atti
protected static final String strMenuItemOnTopAtt = "on top Att";
protected static MenuItem menuItemLShiftAtt;//permuta el atributo de mayor peso Atti-1 con Atti
protected static final String strMenuItemLShiftAtt = "left shift Att";
protected static MenuItem menuItemLTable2D;//deriva una tabla 2D de la lista
protected static final String strMenuItemTable2D = "Table 2D";
//--------------------------------

/**
* Tools:  
**/
protected static Menu menuTools; 
protected static final String strMenuTools = "Tools"; 
protected static MenuItem menuItemEmptyList;//n-atributos binarios ---> 1-item vacio
protected static final String strMenuItemEmptyList = "empty list";

protected static MenuItem menuItemRulesList;//rules-explanation ---> items
protected static final String strMenuItemRulesList = "ruleslist";

protected static MenuItem menuItemRandomList;//n-atributos binarios ---> n-items
protected static final String strMenuItemRandomList = "random list";
protected static MenuItem menuItemRandomDel;//elimina aleatoriamente n casos de la lista ---> unKB
protected static final String strMenuItemRandomDel = "random del";
//--------------------------------
protected static MenuItem menuItemSimetricaBase;//cambia a la base palindroma ^(-1)
protected static final String strMenuItemSimetricaBase = "simetric base";
protected static MenuItem menuItemRandomBase;//cambia a una base al azar 
protected static final String strMenuItemRandomBase = "random base";
protected static MenuItem menuItemSetBase;//cambia a una base especifica 
protected static final String strMenuItemSetBase = "set base";
//--------------------------------
protected static MenuItem menuItemNeighDistance;//analisis de la distancia en H(r)
protected static final String strMenuItemNeighDistance = "distance-neighb";
protected static MenuItem menuItemNeighbourdhood;//H2
protected static final String strMenuItemNeighbourdhood = "neighbourdhood";
protected static MenuItem menuItemFitness2;//Switches
protected static final String strMenuItemFitness2 = "fitness2";
//--------------------------------
protected static MenuItem menuItemCmpList;//compatibles
protected static final String strMenuItemCmpList = "cmpList";//incompatibles,compatibles
protected static MenuItem menuItemEqvList;//eqKBM2L
protected static final String strMenuItemEqvList = "eqvList";//menor,igual,mayor
protected static MenuItem menuItemDifList;//differences
protected static final String strMenuItemDifList = "difList";//diferencias:......

/**
* Queries 
**/
protected static Menu menuConsulta; 
protected static final String strMenuConsulta = "Query"; 
protected static MenuItem menuItemCerrada;
protected static final String strMenuItemCerrada = "closed";
protected static MenuItem menuItemAbierta;
protected static final String strMenuItemAbierta = "open";
protected static MenuItem menuItemBayes;
protected static final String strMenuItemBayes = "bayes";
protected static MenuItem menuItemGuardarLDS;//formato tabla texto para Learning Data Set
protected static final String strMenuItemGuardarLDS = "save LDS";
//--------------------------------
protected static MenuItem menuItemEdit;
protected static final String strMenuItemEdit = "edit";

/**
* Analysis
**/
protected static Menu menuAnalisis; 
protected static final String strMenuAnalisis = "Analysis";
protected static MenuItem menuItemSintactico;
protected static final String strMenuItemSintactico = "syntactic";
protected static MenuItem menuItemSemantico;
protected static final String strMenuItemSemantico = "semantic (explanation)";
protected static MenuItem menuItemFocusAlternative;//elimina los casos salvo una politica
protected static final String strMenuItemFocusAlternative = "focus policy";
//--------------------------------
protected static MenuItem menuItemSensitivity;
protected static final String strMenuItemSensitivity = "sensitivity -*-";
protected static MenuItem menuItemFullScanner;
protected static final String strMenuItemFullScanner = "full scanner (Dmax,RSKB/KBx)";
protected static MenuItem menuItemRandomScanner;
protected static final String strMenuItemRandomScanner = "random scanner (Dmax,RSKB/KBx)";
//--------------------------------
protected static MenuItem menuItemProyectionAtt;//atributos
protected static final String strMenuItemProyectionAtt = "projectionAttributes (r,r)";//de los att's de mayor peso:......
protected static MenuItem menuItemProyectionPar;//parametros
protected static final String strMenuItemProyectionPar = "projectionParameters (R,R)";//de los att's de menor peso:......
protected static MenuItem menuItemProyectionParX;//parametros
protected static final String strMenuItemProyectionParX = "projectionParameters Extended (R,S0...)";//de los att's de menor peso:......
//--------------------------------
protected static MenuItem menuItemInferenceXX;//
protected static final String strMenuItemInferenceXX = "Inference XX";//
protected static MenuItem menuItemInferenceXY;//
protected static final String strMenuItemInferenceXY = "Inference XY";//
protected static MenuItem menuItemResponse;//
protected static final String strMenuItemResponse = "response";//Respuesta R y set resto a (-1):......

/**
* Hamming Synthesis 
**/
protected static Menu menuSintesisLocal; 
protected static final String strMenuSintesisLocal = "SynthesisL";
protected static MenuItem menuItemHamming2;
protected static final String strMenuItemHamming2 = "hamming-2";
protected static MenuItem menuItemHammingCd;
protected static final String strMenuItemHammingCd = "hamming-Cd";
protected static MenuItem menuItemHammingCi;
protected static final String strMenuItemHammingCi = "hamming-Ci";
protected static MenuItem menuItemHammingV;
protected static final String strMenuItemHammingV = "hamming-V";
//---------------------------
protected static MenuItem menuItemDirecta;
protected static final String strMenuItemDirecta = "direct";

/**
* Global Synthesis 
**/
protected static Menu menuSintesisGlobal; 
protected static final String strMenuSintesisGlobal = "SynthesisG";
protected static MenuItem menuItemRandom2;
protected static final String strMenuItemRandom2 = "hamming-R";
protected static MenuItem menuItem2Opt;
protected static final String strMenuItem2Opt = "hamming-2Opt";
//---------------------------
protected static MenuItem menuItemGeneticoJAF;
protected static final String strMenuItemGeneticoJAF = "genetic-1 JAF";
protected static MenuItem menuItemGeneticoMGO;
protected static final String strMenuItemGeneticoMGO = "genetic-2 MGO";
protected static MenuItem menuItemEntVarMGO;
protected static final String strMenuItemEntVarMGO = "genetic-3 VNA";

/**
* Learning
**/
protected static Menu menuAprendizaje; 
protected static final String strMenuAprendizaje = "Learning";
protected static MenuItem menuItemSimple;
protected static final String strMenuItemSimple = "simple";
protected static MenuItem menuItemOptimo;
protected static final String strMenuItemOptimo = "optimum";
//--------------------------------------
protected static MenuItem menuItemBayesianNetwork;
protected static final String strMenuItemBayesianNetwork = "bayesian network (K2) -*-";
protected static MenuItem menuItemBBNConvertor;
protected static final String strMenuItemBBNConvertor = "bayesian network convertor)";
protected static MenuItem menuItemXBNEditor;
protected static final String strMenuItemXBNEditor = "bayesian network editortor)";

/**
* MathProg
**/
protected static Menu menuMP;
protected static final String strMenuMP = "MP";
protected static MenuItem menuItemLeerModelo;
protected static final String strMenuItemLeerModelo = "open Model";
protected static MenuItem menuItemGuardarModelo;
protected static final String strMenuItemGuardarModelo = "save Model";
//--------------------------------------
protected static MenuItem menuItemProgEntera;
protected static final String strMenuItemProgEntera = "IntegerProgramming";
protected static MenuItem menuItemProgContinua;
protected static final String strMenuItemProgContinua = "ContinousProgramming";
protected static MenuItem menuItemProgMixta;
protected static final String strMenuItemProgMixta = "MixProgramming";
//------------------------------
protected static MenuItem menuItemRefinar;
protected static final String strMenuItemRefinar = "Refine";

/**
* ProbDistr
**/
protected static Menu menuCPT;
protected static final String strMenuCPT = "CPT";
protected static MenuItem menuItemDistrCondicionada;//generador
protected static final String strMenuItemDistrCondicionada = "conditional Table";
//---------------------------
protected static MenuItem menuItemDistrCheck;//check
protected static final String strMenuItemDistrCheck = "check CPT";
protected static MenuItem menuItemConstrCheck;//constraint
protected static final String strMenuItemConstrCheck = "constraint CPT";
//---------------------------
protected static MenuItem menuItemLeerDistribucion;
protected static final String strMenuItemLeerDistribucion = "open Table";
protected static MenuItem menuItemGuardarDistribucion;
protected static final String strMenuItemGuardarDistribucion = "save Table";
//---------------------------
protected static MenuItem menuItemRules;//rules
protected static final String strMenuItemRules = "rules";

/**
* Clasical-Combinatorial-Optimisation
**/
protected static Menu menuC2Opt;//ClasicalCombinatorialOptimisation
protected static final String strMenuC2Opt = "C2Opt";
protected static MenuItem menuItemTSP;
protected static final String strMenuItemTSP = "TSP";
protected static MenuItem menuItemBAGP;
protected static final String strMenuItemBAGP = "BAGP";
protected static MenuItem menuItemKNN;
protected static final String strMenuItemKNN = "KNN";

/**
* Constructor por defecto.
* Sin Parametros.
**/
public menuSystem30( ) {

}//menuSystem30

}//class menuSystem30