//DLGQUERY30//
package query;

//
import java.util.*;
import java.lang.*;
import java.io.*;
import java.awt.*;
import javax.swing.JDialog;

//
import kbm2l.*;
import control.*;

/**
* Clase dlgQuery30.
*
* @author Juan A. Fdez del Pozo de Salamanca
* @version 3.0
**/
public  class  dlgQuery30  extends  consulta30  {

  private static final String ERROR = "Error(dlgQuery30): ";

/**
* 
**/
public dlgQuery30( String title) {

  boolean modal = controlPrefs30.modalCriterion( );
//
  queryDialog = new JDialog( kbm2lControl.frame, 
    "KBM2L30 = " + "CONTROL - " + title + " QUERY - [", false);//modal

//Layout
  GridBagConstraints C = new GridBagConstraints();
  GridBagLayout gbl = new GridBagLayout();
//queryFrame
  queryDialog.getContentPane().setLayout( gbl); 

  C.gridx = 0; C.gridy = 0;
  C.gridwidth = 4; C.gridheight = 1;
  C.fill = GridBagConstraints.BOTH;
  C.ipadx = 0; C.ipady = 0;
  C.insets = new Insets(5,5,5,5);
  C.anchor = GridBagConstraints.CENTER;
  C.weightx = 1; C.weighty = 1;
  taQuery = new TextArea();
  gbl.setConstraints( taQuery, C);
  queryDialog.getContentPane().add( taQuery);//+++

  C.gridx = 0; C.gridy = 1;
  C.gridwidth = 1; C.gridheight = 1;
  C.fill = GridBagConstraints.BOTH;
  C.ipadx = 0; C.ipady = 0;
  C.insets = new Insets(5,5,5,5);
  C.anchor = GridBagConstraints.CENTER;
  C.weightx = 1; C.weighty = 1;
  bExitQuery = new Button( strBExitQuery);
  gbl.setConstraints( bExitQuery, C);
  queryDialog.getContentPane().add( bExitQuery);//+++
  bExitQuery.addActionListener( new dlgQueryListener( ));//!!!

  C.gridx = 1; C.gridy = 1;
  C.gridwidth = 1; C.gridheight = 1;
  C.fill = GridBagConstraints.BOTH;
  C.ipadx = 0; C.ipady = 0;
  C.insets = new Insets(5,5,5,5);
  C.anchor = GridBagConstraints.CENTER;
  C.weightx = 1; C.weighty = 1;
  bQuery = new Button( strBQuery);
  gbl.setConstraints( bQuery, C);
  queryDialog.getContentPane().add( bQuery);//+++
  bQuery.addActionListener( new dlgQueryListener( ));//!!!

  C.gridx = 2; C.gridy = 1;
  C.gridwidth = 1; C.gridheight = 1;
  C.fill = GridBagConstraints.BOTH;
  C.ipadx = 0; C.ipady = 0;
  C.insets = new Insets(5,5,5,5);
  C.anchor = GridBagConstraints.CENTER;
  C.weightx = 1; C.weighty = 1;
  bAttrib = new Button( strBAttrib);
  gbl.setConstraints( bAttrib, C);
  queryDialog.getContentPane().add( bAttrib);//+++
  bAttrib.addActionListener( new dlgQueryListener( ));//!!!

  C.gridx = 3; C.gridy = 1;
  C.gridwidth = 1; C.gridheight = 1;
  C.fill = GridBagConstraints.BOTH;
  C.ipadx = 0; C.ipady = 0;
  C.insets = new Insets(5,5,5,5);
  C.anchor = GridBagConstraints.CENTER;
  C.weightx = 1; C.weighty = 1;
  bValues = new Button( strBValues);
  gbl.setConstraints( bValues, C);
  queryDialog.getContentPane().add( bValues);//+++
  bValues.addActionListener( new dlgQueryListener( ));//!!!

  queryDialog.setSize( dlgW, dlgH);
  queryDialog.setLocation( dlgX, dlgY);

}//dlgOpenQuery30

}//class dlgOpenQuery30

