//LSHIFTATT30//
package schema;

//
import java.util.*;
import java.lang.*;
import java.io.*;
import java.math.*;

//
import kernel.*;
import kbm2l.*;
import target.*;
import control.*;
import tables.*;

/**
* Clase lshiftAtt30: lista en una base nueva permutando el att i y la posicion i-1. 
**/
public class lshiftAtt30  extends  frame30  {

//
  private static final String ERROR = "Error(lshiftAtt30): ";
/**
* flag de ejecucion en curso
**/  
  public static boolean working = false;

/**
* Constructor por defecto
**/
public lshiftAtt30( ) {

}//lshiftAttl30

/**
* @return la lista con la base att <-> att-1
**/
public lista30 lshiftAtt( lista30 l30) {

  working = true;

  //Att-Control
  int onTopAtt1 = new controlPrefs30().onTopAttribute( );
  if (( onTopAtt1 <= 0) || ( onTopAtt1 >= l30.dimension())) {
    f30.kbm2lSystem.estatus("lshiftAtt. " + l30.size() + "  att: " + onTopAtt1 );
    working = false;  
    return l30;//OK
    }

  int onTopAtt2 = onTopAtt1-1;

  lista30 lTarget = null;
  lTarget = targetStd30.Target2( l30, onTopAtt1, onTopAtt2);//std    

  int pg = l30.Name().indexOf('-');
  if ( pg == -1) pg = l30.Name().length();
  lTarget.Name( new String( l30.Name().substring( 0, pg) + "-" +  
    "lshiftAtt-" + onTopAtt2 + "-to-" + onTopAtt1));
    
  l30 = new listUnion30().union_lr( l30, lTarget); 
  if ( l30 == null) {
    System.out.println( ERROR + "lshiftAtt.");
    }//if

  listStat30.KB( l30);//
  f30.kbm2lSystem.estatus("lshiftAtt. " + l30.size() + 
    "  gapsXY: " + l30.gapsXY() + "  atts: " + onTopAtt2 + " <<< " + onTopAtt1);

  working = false;
  return l30;
}//lshiftAtt

/**
* run()
**/
public void run() {

  if ( !working) {
  try {
    long ts0 = (new Date()).getTime();
    f30.activel30 = lshiftAtt( f30.activel30);
    frame30.kbm2lTime.append("lshiftAtt:: " + (new Date().getTime() - ts0) + ".\n");      
  }//try
  catch (Exception e) {
    System.out.println( ERROR + "run().");
    e.printStackTrace();
  }//catch
  }

  return;
}//run

}//class lshiftAtt30
