//SWAPATT30//
package schema;

//
import java.util.*;
import java.lang.*;
import java.io.*;
import java.math.*;

//
import kernel.*;
import kbm2l.*;
import target.*;
import tables.*;
import control.*;

/**
* Clase swapAtt30: lista en una base nueva permutando el att i y el att j. 
**/
public class swapAtt30  extends  frame30  implements  Runnable  {

//
  private static final String ERROR = "Error(swapAtt30): ";
/**
* flag de ejecucion en curso
**/  
  public static boolean working = false;

/**
* Constructor por defecto
**/
public swapAtt30( ) {

}//swapAttl30

/**
* @return la lista con la base 0 <-> att
**/
public lista30 swapAtt( lista30 l30) {

  working = true;
//Att-Control
  int att_i = new controlPrefs30().onTopAttribute( );
  if (( att_i < 0) || ( att_i >= l30.dimension())) {
    f30.kbm2lSystem.estatus("onTopAtt. " + l30.size() + "  att_i: " + att_i);
    working = false;  
    return l30;//OK
    }

  int att_j = new controlPrefs30().onBotAttribute( );
  if (( att_j < 0) || ( att_j >= l30.dimension())) {
    f30.kbm2lSystem.estatus("onTopAtt. " + l30.size() + "  att_j: " + att_j);
    working = false;  
    return l30;//OK
    }

  lista30 lTarget = null;
  if ( att_i != att_j)
    lTarget = targetStd30.Target2( l30, att_i, att_j);//std    
    else {
      f30.kbm2lSystem.estatus("onTopAtt. " + l30.size() + "  att_i: " + att_i + "  att_j: " + att_j);
      working = false;
      return l30;    
      }//

  int pg = l30.Name().indexOf('-');
  if (pg == -1) pg = l30.Name().length();
  lTarget.Name( new String( l30.Name().substring( 0, pg) + "-" +  "onTopAtt-" + att_i + "-" + att_j));
    
  l30 = new listUnion30().union_lr( l30, lTarget); 
  if ( lTarget == null) {
    System.out.println( ERROR + "onTopAtt.");
    }//if

  l30 = new lista30( lTarget, lTarget);//std
  listStat30.KB( l30);//
  f30.kbm2lSystem.estatus("onTopAtt. " + l30.size() + "  att_i: " + att_i + "  att_j: " + att_j);

  working = false;
  return l30;
}//swapAtt

/**
* run()
**/
public void run() {

  if ( !working) {
  try {
    long ts0 = (new Date()).getTime();
    f30.activel30 = swapAtt( f30.activel30);
    f30.kbm2lTime.append("swapAtt:: " + (new Date().getTime() - ts0) + ".\n");      
  }//try
  catch (Exception e) {
    System.out.println( ERROR + "run().");
    e.printStackTrace();
  }//catch
  }

  return;
}//run

}//class swapAtt30
