//SPECTRUM30.
package spectrum;

//
import java.util.*;
import java.lang.*;
import java.io.*;
import java.math.*;
import java.awt.*;
import java.awt.event.*;

//
import kernel.*;
import kbm2l.*;
import target.*;
import control.*;

/**
* Clase spectrum30, grafica de listas y descripcin de items.
**/
public  class  spectrum30  extends Canvas   implements  MouseListener  {

  private static final String ERROR = "Error(spectrum30): ";
/**
* flag de ejecucion en curso
**/
  public static boolean working = false;//

  public static Frame frame = null;
  public static Graphics graph = null;

  protected static frame30 f30 = null;//enlace a la aplicacion
  protected static Vector COLOR = null;//Vectores de politica y color paralelos.
  protected static Vector POLITICA = null;

  protected static int wCanvas = -1;
  protected static int hCanvas = -1;
  protected static boolean prefSpectrum = false;//Case/Item
  protected static int prefLines = -1;//1,2,3,...50,...
  protected static boolean prefItemsVBars = false;//No/Yes
  protected static double prefResolution = -1.0;//
  protected static int level = -1;//base del corener de los rectangulosde los items

////
  public static int firstItem = 0;
  public static int lastItem = 0;
  protected static BigInteger firstOffset = null;
  protected static BigInteger MaxwItem = null;//

/**
* Constructor por defecto. 
**/
public spectrum30( ) {

  this.graph = getGraphics( );
  addMouseListener( this);
  System.out.println( "spectrum30");  
}//spectrum30

/**
* El offset del Item <-> offset X del Canvas. (referencia: escala y origen)
* @param item item30
* @param X mousePosX es.
* @param Y mousePosY es.
* return (-1,0,1) segun X (menor,entre,mayor) que los extremos del item i
**/
private int offsetSpectrum( int i, int X, int Y) {

  BigInteger Z = new BigInteger( String.valueOf( X));

  try {

  firstOffset = f30.activel30.Get( new controlPrefs30().firstItemBrowser()).getOffsetInf(); 

  if ( prefResolution < 1.0) {
    Z = Z.multiply( 
      new BigInteger( String.valueOf( (int)( 1.0 / prefResolution))));
    Z = Z.add( firstOffset);  
    }  

  if ( prefResolution == 1.0) {
    Z = Z.add( firstOffset);  
      }

  if ( prefResolution > 1.0) {
    Z = Z.divide( 
      new BigInteger( String.valueOf( (int)( prefResolution))));
    Z = Z.add( firstOffset);  
      }
 
  } catch (Exception e) { 
    System.out.println( ERROR + "offsetSpectrum.0");  
    e.printStackTrace();
    System.exit( 0);
  }//catch

  BigInteger OffsetSUP = f30.activel30.Get( f30.activel30.size() - 1 ).getOffsetSup();

  if ( ( Z.compareTo( BigInteger.ZERO) == -1) || ( Z.compareTo( OffsetSUP) == 1 ))
    return -2;// no es valida       
  
  try {
  item30 item = f30.activel30.Get( i);
  BigInteger OffsetInf = item.getOffsetInf();
  BigInteger OffsetSup = item.getOffsetSup();

  if ((( Z.compareTo( OffsetInf) ==  1)  || ( Z.compareTo( OffsetInf) == 0)) && 
      (( Z.compareTo( OffsetSup) == -1 ) || ( Z.compareTo( OffsetSup) == 0))) {
      // OF mayor que el menor y menor que el mayor
    return 0;//    
    }
    else if ( Z.compareTo( OffsetSup) ==  1) return  1; 
    else if ( Z.compareTo( OffsetInf) == -1) return -1; 

  } catch (Exception e) { 
    System.out.println( ERROR + "offsetSpectrum.1");  
    e.printStackTrace();
    System.exit( 0);
  }//catch

  return -2;// ? no es valida
}//offsetSpectrum

/**
* Busqueda binaria del item i que corresponde a X, Y, cambio de referencia.
* @return i item number
**/
private int itemBB( MouseEvent e) {
  
  int i = -1;
  int inf = 0, sup = f30.activel30.size();
  int offCan = -1;

  try  {
  
  while (true) {
      i = inf + (int)( sup - inf) / 2;
//offCan: GetX() es (-1,0,1) == (menor,entre,mayor) que los extremos del item i
      offCan = offsetSpectrum( i, e.getX(), e.getY());

//      System.out.println( "i: " + i + " X: " + X + "  offCan: " + offCan);

      if ( offCan == 0) { 
        return i;// encontrado
        } else {
          if ( offCan == 1) inf = i; // 
          else 
          if ( offCan ==  -1) sup = i; //
          else {
            return -1; // X no es valida y no se informa nada
            }
        }
      }//while

  } catch (Exception ex) { 
    System.out.println( ERROR + "itemBB.");  
    ex.printStackTrace();
    System.exit( 0);
  }//catch

  return -1; // X no es valida y no se informa nada
}//itemBB

/**
* Busqueda binaria del item i que corresponde a X, Y, cambio de referencia.
* @return i item number
**/
private int itemXY( MouseEvent e) {

  int X = e.getX(), Y = e.getY();
 
  for( int i = 0; i < f30.activel30.size(); i++) {
    if ( X >= f30.activel30.Get( i).getX0())
      if ( X <= f30.activel30.Get( i).getX1())
        if ( Y >= f30.activel30.Get( i).getY0())
          if ( Y <= f30.activel30.Get( i).getY1())
            return i;  
  }//for-i
 
  return -1; // X no es valida y no se informa nada
}//itemXY

/**
* Informacion que se envia al browser cuando se ha 
* recibido un evento mousePressed.
* @param f30 entorno
* @param i el numero de item en la lista ordenada
* @param e el evento asociado. 
**/
public void infoMousePressed( frame30 f30, int i, MouseEvent e) {

  if (( i < 0) || ( f30.activel30.size() <= i)) {
    System.out.println( ERROR + "infoMousePressed ovf-ITEM. " + f30.activel30.size() + " -- "+i); 
    System.exit(0); 
    }//

  try {
    
  f30.kbm2lBrowser.setText( "Lista30: " + f30.activel30.Name() + 
    ",  size: " + f30.activel30.size() + 
    "\n  Base:       \n" + f30.activel30.Base.toString( f30.activel30)); 

   if ( e.getButton() == e.BUTTON1)
     infoMousePressed1( f30, i, e); // else no info
   if ( e.getButton() != e.BUTTON1)
     infoMousePressed2( f30, i, e); // else no info

  } catch (Exception ex) { 
    System.out.println( ERROR + "infoMousePressed.");
    ex.printStackTrace();
    System.exit( 0);
  }//catch

  f30.kbm2lBrowser.frame.toFront();
  
  return;
}//infoMousePressed

/**
* Informacion que se envia al browser cuando se ha 
* recibido un evento mousePressed del boton 1.
* @param f30 entorno
* @param i el numero de item en la lista ordenada
* @param e el evento asociado. 
**/
public void infoMousePressed1( frame30 f30, int i, MouseEvent e) {

  int  k =  POLITICA.indexOf( f30.activel30.Get( i).GetRespuesta());
  if ( k == -1) {
    System.out.println( ERROR + "infoMousePressed. indexOf. \nRespuesta: " + 
      f30.activel30.Get( i).GetRespuesta() + " -- \nPOLITICA: " + POLITICA.toString()); 
    System.exit(0); 
    }//
  int r0 = ((Color)COLOR.get( k)).getRed(); 
  int g0 = ((Color)COLOR.get( k)).getGreen(); 
  int b0 = ((Color)COLOR.get( k)).getBlue();

  if ( i > 0) {
    int j = i-1;
    f30.kbm2lBrowser.append( "\n\nItem: " + j + 
    "\n  Index: " + f30.activel30.Get( j).GetIndice() + 
    "  Respuesta: " + f30.activel30.Get( j).GetRespuesta() + 
    ",  Medida: " + f30.activel30.Get( j).GetMedida() + 
    "\n  IdFij: " + f30.activel30.Fij( j) +
    ",   IdVar: " + f30.activel30.Var( j) +        
    "\n  Offset(Inf,Sup): (" + f30.activel30.Get( j).getOffsetInf() + "," + 
                               f30.activel30.Get( j).getOffsetSup() + ")" +
    ",  Length: " + f30.activel30.Get( j).getLongitud() +
    "\n  X0: " + f30.activel30.Get( j).getX0() + 
    "  Y0: " + f30.activel30.Get( j).getY0() + 
    "  X1: " + f30.activel30.Get( j).getX1() + 
    "  Y1: " + f30.activel30.Get( j).getY1());//alcance
    }//if
  
  f30.kbm2lBrowser.append( "\n\n <<<###***###|||  Item: " + i + "  <<<###***###|||" +
    "\n  Index: " + f30.activel30.Get( i).GetIndice() + 
    "  Respuesta: " + f30.activel30.Get( i).GetRespuesta() + 
    ",  Medida: " + f30.activel30.Get( i).GetMedida() + 
    "\n  IdFij: " + f30.activel30.Fij( i) +
    ",   IdVar: " + f30.activel30.Var( i) +        
    "\n  Offset(Inf,Sup): (" + f30.activel30.Get( i).getOffsetInf() + "," + 
                               f30.activel30.Get( i).getOffsetSup() + ")" +
    ",  Length: " + f30.activel30.Get( i).getLongitud() + 
    "\n  X0: " + f30.activel30.Get( i).getX0() + 
    "  Y0: " + f30.activel30.Get( i).getY0() + 
    "  X1: " + f30.activel30.Get( i).getX1() + 
    "  Y1: " + f30.activel30.Get( i).getY1() +     
    "  Offset(X): " + (long)( 1 + e.getX()) + 
    ",  Spectrum(X,Y): (" + e.getX()+ "," + + e.getY() + ")" +
    ",  Spectrum(rgb): (" + r0 + ", " + g0 + ", " + b0 + ")");//alcance

  if ( i < f30.activel30.size()-1) {
    int j = i+1;
    f30.kbm2lBrowser.append( "\n\nItem: " + j + 
    "\n  Index: " + f30.activel30.Get( j).GetIndice() + 
    "  Respuesta: " + f30.activel30.Get( j).GetRespuesta() + 
    ",  Medida: " + f30.activel30.Get( j).GetMedida() + 
    "\n  IdFij: " + f30.activel30.Fij( j) +
    ",   IdVar: " + f30.activel30.Var( j) +        
    "\n  Offset(Inf,Sup): (" + f30.activel30.Get( j).getOffsetInf() + "," + 
                               f30.activel30.Get( j).getOffsetSup() + ")" +
    ",  Length: " + f30.activel30.Get( j).getLongitud() +
    "\n  X0: " + f30.activel30.Get( j).getX0() + 
    "  Y0: " + f30.activel30.Get( j).getY0() + 
    "  X1: " + f30.activel30.Get( j).getX1() + 
    "  Y1: " + f30.activel30.Get( j).getY1());//alcance
    }//if

    f30.kbm2lBrowser.append(
    "\n\n  FirstItem: " + new controlPrefs30().firstItemBrowser() + 
    ",  Resolution: " + prefResolution +
    ",  Type: " + prefSpectrum );//

  return;
}//infoMousePressed1


/**
* Informacion que se envia al browser cuando se ha 
* recibido un evento mousePressed del boton 2.
* @param f30 entorno
* @param i el numero de item en la lista ordenada
* @param e el evento asociado. 
**/
public void infoMousePressed2( frame30 f30, int i, MouseEvent e) {


  f30.kbm2lBrowser.append( "\n\n <<<###***###|||  Item: " + i + "  <<<###***###|||" +
    "\n  Index: " + f30.activel30.Get( i).GetIndice() + 
    "  Respuesta: " + f30.activel30.Get( i).GetRespuesta() + 
    ",  Medida: " + f30.activel30.Get( i).GetMedida() + 
    "\n  IdFij: " + f30.activel30.Fij( i) +
    ",   IdVar: " + f30.activel30.Var( i) +        
    "\n  Offset(Inf,Sup): (" + f30.activel30.Get( i).getOffsetInf() + "," + 
                               f30.activel30.Get( i).getOffsetSup() + ")" +
    ",  Length: " + f30.activel30.Get( i).getLongitud());//alcance

  f30.kbm2lBrowser.append( "\n\n" +
    f30.activel30.Esqu.consultaEqIndice( base30.Trnp( f30.activel30.Base, 
      f30.activel30.Get( i).GetIndice(), null)) + "\n" +
    f30.activel30.Esqu.consultaEqRespuesta( f30.activel30.Get( i).GetRespuesta())
    );
  
  
    f30.kbm2lBrowser.append(
    "\n\n  FirstItem: " + new controlPrefs30().firstItemBrowser() + 
    ",  Resolution: " + prefResolution +
    ",  Type: " + prefSpectrum );//

  return;
}//infoMousePressed2

// Event handling methods.

/**
* No action.
**/
public void mouseClicked( MouseEvent e) {
//  System.out.println("MousePressed");
  if ( f30.activel30 != null) {
  }
  return;
}//mouseClicked

/**
* Muestra la informacion del item donde est el mouse. 
* tiene en cuenta el primer item (origen) y la resolucion (escala).
* revisar algoritmo con busqbin.
* revisar caso lkbm.size() > w.
**/
public void mousePressed( MouseEvent e) { 

  try {
  if ( f30.activel30 != null) {

    int w = getSize().width;
    int h = getSize().height;
//    int  i = itemBB( e);
    int i = itemXY( e);

  working = true;

  prefSpectrum = new controlPrefs30().spectrumChart();  // Case/Item // true/false
  prefResolution = new controlPrefs30().spectrumResolution();// 0.25, 0.5, 1.0, 2.0, 4.0, 8.0
  prefItemsVBars = new controlPrefs30().spectrumItemsVBars();//Yes/No
  firstItem = new controlPrefs30().firstItemBrowser();//

  if ( firstItem >= f30.activel30.size()) firstItem = f30.activel30.size()-1;
  firstOffset = f30.activel30.Get( firstItem).getOffsetInf(); 
  
  MaxwItem = listStat30.MaximoItem( f30.activel30);

  if ( prefSpectrum) { //Case

    f30.kbm2lBrowser.setText( "");//

      if (( i >= 0) && ( i < f30.activel30.size())) {
        infoMousePressed( f30, i, e); }// else no info
      }//if

      else { //Item

        //cada j es un item, la lista solo muestra los primeros j, y hay mas
        if (( i >= 0) && ( i < f30.activel30.size())) {
          infoMousePressed( f30, i, e); }// else no info
        if (i+1 < f30.activel30.size())
        if ( listStat30.esUNKB( f30.activel30, f30.activel30.Get( i)))
          new controlPrefs30().firstItemBrowser( i+1);

        }//else error preferences

    working = false;
    return;
    }//if
  } catch (Exception ex) { 
    System.out.println( ERROR + "mousePressed.");  
    ex.printStackTrace();
    System.exit( 0);
  }//catch

  return;
}//mousePressed

/**
* No action.
**/
public void mouseReleased( MouseEvent e) {
//  System.out.println("MouseReleased");
  if ( f30.activel30!=null) {
  }
  return;
}//mouseReleased

/**
* RePaint.
**/
public void mouseEntered( MouseEvent e) {
//  System.out.println("MouseEntered");

  if ( f30.activel30 != null) {
    try {
      f30.kbm2lBrowser.spectrumView( f30.activel30);
    } catch (Exception ex) { 
      System.out.println( ERROR + "mouseEntered(): ");  
      ex.printStackTrace();
      System.exit( 0);
    }//catch
  }
  return;
}//mouseEntered

/**
* No action.
**/
public void mouseExited( MouseEvent e) {
//  System.out.println("MouseExited");
  if ( f30.activel30!=null) {
  }
  return;
}//mouseExited

}//class spectrum30
