//sintesisHammingR30//
package synthesis;

//
import java.util.*;
import java.lang.*;
import java.io.*;
import java.math.*;
import java.awt.*;

//
import kbm2l.*;
import tables.*;
import control.*;
import kernel.*;
import tools.*;
import target.*;

/**
* 
**/
public class sintesisHammingR30  extends  sintesisHamming30  {

/**
*
**/
  private static final String ERROR = "Error(sintesisHammingR30): ";
  private lista30 l30 = null;

/**
* Constructor por defecto 
**/
public sintesisHammingR30( ) {

  this.l30 = f30.activel30;
  System.out.println( "sintesisHammingR30a");
}//sintesisHammingR30

/**
* Constructor para optimizar una lista especifica.
**/
public sintesisHammingR30( lista30 l30) {

  this.l30 = l30;
  System.out.println( "sintesisHammingR30b");
}//sintesisHammingR30

/**
* Permutaciones Aleatorias de la base extendida
* @parma l30 lista30
* @param limit maximo numero de iteraciones, -1 == ilimitado
* @return l30 lista30
**/
public  lista30  HammingR( lista30 l30, long limit) {

  working = true;
  kbm2lSystem.setText("Sintesis HammingR.  C: " + 
    l30.Base.complex( ) + "  xC: " + l30.Base.xComplex( ) + "\n");
  long seed = new controlPrefs30().randomSeed();
  control30.gr.setSeed( seed);
  kbm2lSystem.append("control30.gr.seed: " + seed + ".\n");
  
//random numSimu
  try {//  R2
  if ( inikbs( l30) == null) return l30;// minkbm, minKBM, attTop, attBot
  for( ; working && (( limit--) != 0) && ( l30.size() != listStat30.DS( l30).size( )); ) {

    System.gc( );

    aux1 = kbsR( l30);//copia l30 en aux1
    if ( aux1 != null) { // cp - completa

      if ( new controlPrefs30().verboseSystem()) { 
        kbm2lSystem.append("+BASE: " + aux1.Base.toString() + "\n");
        kbm2lSystem.append( "HR:   " + metrica30.H( l30.Base, aux1.Base) + "  ");
        kbm2lSystem.append( "G[H]: " + metrica30.G( l30.Base, aux1.Base) + "\n");
      }

      if (( minkbm > aux1.optSize())) {
        l30 = kbs( l30, aux1, "HR" );
        listStat30.calc( l30);
        new outputList30( ).escribeKBM2L( l30, dato30.workspace+File.separator+l30.Name()+"-"+l30.size());
        if ( !new controlPrefs30().threadMode()) working = false;//
        }//if - opt
        
     }//if - cp - incompleta
   }//for-n

  }//try
  catch (Exception e) {
    kbm2lSystem.append( ERROR + "HammingR-2.\n");
    frame30.exit( 0, e);
  }//catch

//  listStat30.importanceAtt( l30);//

  if ( minkbm < minKBM) {
    listStat30.calc( l30);
    new outputList30( ).escribeKBM2L( l30, dato30.workspace+File.separator+"HammingR");
    kbm2lBrowser.listView( l30);//destino optimizado copiado
    }
    else kbm2lSystem.append("sintesis: no hay base mejor.\n");

  kbm2lSystem.append("sintesis: " + minKBM + "  ---> " + minkbm + "\n");//msgfin
  kbm2lSystem.append( "HG0 is true " + 
    heuristics30.HG0TRUE + " and HG0 is false " + heuristics30.HG0FALSE + " times.\n");
  kbm2lSystem.append( "BasesList: " + l30.BasesList.size() + ". OK.\n");

  working = false;
  return l30;
}//HammingR

/**
* run process: f30.activel30 = HammingR( l30, -1);//-1 == for( ever)
**/
public void run() {

  if ( l30.dimension() > 1)
  if ( !working) {
  try {
    long ts0 = (new Date()).getTime();
    f30.activel30 = HammingR( l30, -1);//-1 == for( ever)
    f30.kbm2lTime.append("Sintesis HammingR:: " + (new Date().getTime() - ts0) + ".\n");        
  }//try
  catch (Exception e) {
    kbm2lSystem.append( ERROR + "run().\n");
    frame30.exit( 0, e);
  }//catch
  }

  return;
}//run

}//class sintesisHammingR30
