//join30//
package tables;

//
import java.util.*;
import java.lang.*;
import java.io.*;
import java.math.*;
import java.awt.*;

//
import control.*;
import kernel.*;
import kbm2l.*;
import schema.*;
import target.*;
import synthesis.*;

/**
* Clase join30,  
* @author Juan A. Fdez del Pozo de Salamanca
* @version 3.0
**/
public class join30  extends  tabla30  {

  private static final String ERROR = "Error(join30): ";

/**
* Constructor por defecto
**/  
public join30( ) {

}//join30

/**
* join de listas. Dos listas que son tablas de decision consecutivas.
**/
public lista30 join( lista30 prev, lista30 l30) {

  kbm2lSystem.append( "join: " + prev.Name()+ "  " + l30.Name() + "\n");
//el esquema de la lista join
  esquema30 eq30 = null;
  try {
    eq30 = new esquema30( l30.Esqu);
    eq30.nombre = prev.Esqu.nombre + "_#_" + l30.Esqu.nombre;
  }//try    
  catch (Exception e) {
    System.out.println( ERROR + "join-schema");
    e.printStackTrace();
    System.exit( 0);
  }//catch

  try {
  for(int i = prev.Esqu.Decisiones.size()-1; i >=0 ; i--) {

    Integer codDecision = (Integer)(prev.Esqu.CodigosDecisiones.get( i));
    int posDecision = l30.Esqu.CodigosAtributos.indexOf( codDecision);//unicos-clave
    if (posDecision == -1) {
      System.out.println( ERROR + "join: " + eq30.nombre); 
      System.out.println("codDecision: " + codDecision + "  i: " + i + ".\n");
      System.out.println("posDecision: " + posDecision); 
      systemVer30.ver( prev.Esqu);
      systemVer30.ver( l30.Esqu);
      System.exit( 0);
    }
//    eq30.CodigosAtributos.remove( posDecision);//el atributo se convierte en decision
    eq30.CodigosAtributos.set( posDecision, new Integer( -1));
    eq30.CodigosDecisiones.add( 0, codDecision);//codigo

    String litDecision = (String)(prev.Esqu.Decisiones.get( i));
    if (posDecision != l30.Esqu.Atributos.indexOf( litDecision)) {
      System.out.println( ERROR + "join: " + eq30.nombre); 
      System.out.println("litDecision: " + litDecision + "  i: " + i + ".\n");
      System.out.println("posDecision: " + posDecision); 
      systemVer30.ver( prev.Esqu);
      systemVer30.ver( l30.Esqu);
      System.exit( 0);
    }
//    eq30.Atributos.remove( posDecision);//el atributo se convierte en decision
    eq30.Decisiones.add( 0, litDecision);//literal
    
    Integer carDecision = (Integer)(prev.Esqu.CDDecisiones.get( i));
    if ( !carDecision.equals( l30.Esqu.CDAtributos.get(posDecision))) {
      System.out.println( ERROR + "join: " + eq30.nombre);
      System.out.println("carDecision: " + carDecision + "  i: " + i + ".\n");
      System.out.println("posDecision: " + posDecision);       
      systemVer30.ver( prev.Esqu);
      systemVer30.ver( l30.Esqu);
      System.exit( 0);
    }
//    eq30.CDAtributos.remove( posDecision);//el atributo se convierte en decision
    eq30.CDDecisiones.add( 0, carDecision);//cardinales

    Vector valDecision = (Vector)(prev.Esqu.ValoresDecisiones.get( i));
    if ( !valDecision.equals( l30.Esqu.ValoresAtributos.get(posDecision))) {
      System.out.println( ERROR + "join: " + eq30.nombre);
      System.out.println("valDecision: " + valDecision + "  i: " + i + ".\n");
      System.out.println("posDecision: " + posDecision);
      systemVer30.ver( prev.Esqu);
      systemVer30.ver( l30.Esqu);
      System.exit( 0);
    }
//    eq30.ValoresAtributos.remove( posDecision);//el atributo se convierte en decision
    eq30.ValoresDecisiones.add( 0, valDecision);//valores

    }//for-i

    }//try    
    catch (Exception e) {
      System.out.println( ERROR + "join-for");
      e.printStackTrace();
      System.exit( 0);
    }//catch

  try {
/*
    System.out.println(eq30.CodigosAtributos.toString());
    System.out.println(eq30.Atributos.toString());
    System.out.println(eq30.CDAtributos.toString());
    System.out.println(eq30.ValoresAtributos.toString());
*/
    for(int i = 0; i < eq30.CodigosAtributos.size(); i++) {
      if (((Integer)eq30.CodigosAtributos.get(i)).intValue() == -1) {
        eq30.CodigosAtributos.remove( i);//el atributo se convierte en decision
        eq30.Atributos.remove( i);//el atributo se convierte en decision
        eq30.CDAtributos.remove( i);//el atributo se convierte en decision
        eq30.ValoresAtributos.remove( i);//el atributo se convierte en decision
        i--;
      }
    }
/*
    System.out.println(eq30.CodigosAtributos.toString());
    System.out.println(eq30.Atributos.toString());
    System.out.println(eq30.CDAtributos.toString());
    System.out.println(eq30.ValoresAtributos.toString());
*/
    eq30.numDecisiones = eq30.numDecisiones + prev.Esqu.Decisiones.size();
    if ( eq30.Decisiones.size() != eq30.numDecisiones) {
      System.out.println( ERROR + "eq30.numDecisiones: " + eq30.numDecisiones);
      System.out.println(eq30.Decisiones.toString());
      System.exit( 0);
    }
    eq30.numAtributos = eq30.numAtributos - prev.Esqu.Decisiones.size();
    if ( eq30.Atributos.size() != eq30.numAtributos) {
      System.out.println( ERROR + "eq30.numAtributos: " + eq30.numAtributos);
      System.out.println(eq30.Atributos.toString());
      System.exit( 0);
    }

    }//try    
    catch (Exception e) {
      System.out.println( ERROR + "join");
      e.printStackTrace();
      System.exit( 0);
    }//catch

//  systemVer30.ver( eq30);

//el contenido de la lista join, propaga prev sobre el recorrido de l30.
  kbm2lSystem.append( "join-------\n");
  lista30 join = new lista30( eq30);
  try {
  Vector INDEX = null; // recorrido de l30
  Vector DOMINIO = l30.Base.Dom();
  Vector ULTIMO = index30.ultimoT( DOMINIO);
  long i = 0;
  for( INDEX = index30.primeroT( DOMINIO);
       index30.myeqT( ULTIMO, INDEX);
       INDEX = index30.siguienteT( DOMINIO, INDEX)) {

     if ( i == 0) { 
       kbm2lSystem.estatus( "listJoin: " + join.size() + " l30: " + INDEX.toString()); i++; } 
       else { i++; if ( i == 1000) i = 0; }
    
     item30 item = l30.GET( INDEX);
     Vector RESPUESTA = item.GetRespuesta();
     if ( !index30.eqS( RESPUESTA, l30.UNKB)) {
       item30 nuevo = optimo( join, prev, l30, INDEX, RESPUESTA, item.GetMedida());
       int regla = -1;
       if ( nuevo != null)
         regla = join.Set( nuevo);
       }//if-UNKB
       else { 
         INDEX = l30.GET( INDEX).GetIndice(); 
       }//salta el item UNKB
     
     if ( index30.eqT( ULTIMO, INDEX)) { break; }
        
    }//for-INDEX
    }//try    
    catch (Exception e) {
      System.out.println( ERROR + "join-FOR");
      e.printStackTrace();
      System.exit( 0);
    }//catch

//  systemVer30.ver( eq30);
//  systemVer30.ver( join);

  kbm2lSystem.append( "-------join\n");
  return join;
}//join

/**
* item30, en INDEX hay un caso de prev, si es optimo, se construye para hacer join.
* Los esquemas de atributos homologos son compatibles. join <= (prev -> l30).
**/
public item30  optimo( lista30 join, lista30 prev, lista30 l30, 
  Vector INDEX, Vector RESPUESTA, Vector MEDIDA) {

  Vector prevINDEX = new Vector();//parte del INDEX relativa a la lista prev
  for( int i = 0; i < prev.ParIndice(); i++) {
    prevINDEX.add( new Integer( -1));
    }//
  
  for( int i = 0; i < prev.dimension(); i++) {
    String prevAtt = (String)(prev.Esqu.Atributos.get( prev.Base.bas( i)));
    for( int j = 0; j < l30.dimension(); j++) {
      String Att = (String)(l30.Esqu.Atributos.get( l30.Base.bas( j)));
      if ( prevAtt.equals( Att)) {
        prevINDEX.set( i, (Integer)(INDEX.get( j)));//base principal.
        break;
        }//if 
      }//for-j
    }//for-i
    
  int ppi = 0;  // algun att de prev no esta en l30
  if ( (ppi=prevINDEX.indexOf( new Integer( -1))) != -1) {
    //System.out.println( ERROR + "optimo. INDEX:     " + INDEX + ".");
    //System.out.println( ERROR + "optimo. prevINDEX: " + prevINDEX + ".");
    //System.out.println( prev.Esqu.Atributos);
    //System.out.println( l30.Esqu.Atributos);
    prevINDEX.set( ppi, new Integer( 0));//    System.exit( 0);
    }

  if ( index30.eqS( prev.GET( prevINDEX).GetRespuesta(), prev.UNKB)) {
    return null;//item30
    }//if-UNKB
    
  Vector postRESPUESTA = new Vector();//atributos respuesta del INDEX  
  for( int i = 0; i < prev.ParRespuesta(); i++) {
    postRESPUESTA.add( new Integer( -1));
    }//

  for( int i = 0; i < prev.ParRespuesta(); i++) {
    String prevDec = (String)(prev.Esqu.Decisiones.get( i));
    for( int j = 0; j < l30.ParIndice(); j++) {
      String Dec = (String)(l30.Esqu.Atributos.get( j));     
      if ( prevDec.equals( Dec)) {
        postRESPUESTA.set( i, (Integer)(INDEX.get( j)));
        break;
        }//if 
      }//for-j
    }//for-i
    
  if ( postRESPUESTA.indexOf( new Integer( -1)) != -1) {
    System.out.println( ERROR + "optimo. INDEX:     " + INDEX + ".");
    System.out.println( ERROR + "optimo. postRESPUESTA: " + postRESPUESTA + ".");
    System.out.println( prev.Esqu.Decisiones);
    System.out.println( l30.Esqu.Atributos);
    System.exit( 0);
    }

  if ( index30.eqS( postRESPUESTA, prev.GET( prevINDEX).GetRespuesta())) {
    //l30 es de respuesta unidimmensional y se aade al final, cronologicamente.
    postRESPUESTA.add( (Integer)RESPUESTA.get( 0));

     Vector postMEDIDA = index30.cpR(prev.GET( prevINDEX).GetMedida()); 
     postMEDIDA.add( (Double)MEDIDA.get( 0));

    Vector postINDEX = new Vector();//parte del INDEX relativa a la lista join
    for( int i = 0; i < join.ParIndice(); i++) {
      postINDEX.add( new Integer( -1));
      }//

    for( int i = 0; i < join.dimension(); i++) {
      String joinAtt = (String)(join.Esqu.Atributos.get( join.Base.bas( i)));
      for( int j = 0; j < l30.dimension(); j++) {
        String Att = (String)(l30.Esqu.Atributos.get( l30.Base.bas( j)));
        if ( joinAtt.equals( Att)) {
          postINDEX.set( i, (Integer)(INDEX.get( j)));//base principal.
          break;
          }//if 
        }//for-j
      }//for-i

    if ( postINDEX.indexOf( new Integer( -1)) != -1) {
      System.out.println( ERROR + "optimo. INDEX:     " + INDEX + ".");
      System.out.println( ERROR + "optimo. postINDEX: " + postINDEX + ".");
      System.out.println( join.Esqu.Atributos);
      System.out.println( l30.Esqu.Atributos);
      System.exit( 0);
      }

//    if ( !checkIndex30.INDX( join, postINDEX)) System.out.println( ERROR);

    return new item30( join, postMEDIDA, postRESPUESTA, postINDEX);//medida de l30

    }//if

  return null;
}//optimo

}//class join30
