//utilidad30//
package tables;

//
import java.util.*;
import java.lang.*;
import java.io.*;

//
import control.*;
import kernel.*;
import kbm2l.*;
import target.*;
import schema.*;
import synthesis.*;

/**
* Clase utilidad30 acceso a tablas de utilidad, Tabla -> lista30
* RESPUESTA escalar
**/
public  class  utilidad30  extends  protocolo30  {

  private static final String ERROR = "Error(utilidad30): ";
  
/**
* Constructor por defecto
**/  
public utilidad30( ) {

}//utilidad30

////
  private int ALTERNATIVAS = -1;//las fija el esquema
  private double maxima = -1.0;//max utilidad
  private double suboptima = -1.0;//utilidad suboptima
  private int decision = -10;//opt decision

/**
* Maxima utilidad (double)
**/
private Vector alternativaOptima( String linea) { 

  Vector Utilidad = new Vector();
  double utilidad = 0.0;
  maxima = (double)( dato30.param( linea.trim()));// el i == 0
  linea = new String( dato30.nextParam( linea.trim(), ' '));
  decision = 0;// el i == 0
  Utilidad.add( new Double( maxima));
  for( int i = 1; i < ALTERNATIVAS-1; i++) {
    utilidad = (double)( dato30.param( linea.trim()));
    Utilidad.add( new Double( utilidad));
    linea = new String( dato30.nextParam( linea.trim(), ' '));
    if ( utilidad > maxima) { maxima = utilidad; decision = i; } 
    }//for
  utilidad = (double)( dato30.param( linea.trim() + ";"));//!!!
  Utilidad.add( new Double( utilidad));
  if ( utilidad > maxima) { maxima = utilidad; decision = ALTERNATIVAS - 1;}

  suboptima = -1.0;
  for( int i = 0; i < Utilidad.size(); i++) {
	 utilidad = ((Double)Utilidad.get( i)).doubleValue();
	 if (( utilidad > suboptima) && (utilidad < maxima)) 
	   suboptima = utilidad;
    }
  if ( suboptima == -1.0)
    suboptima = maxima;
    
  return Utilidad;
}//alternativaOptima

/**
* Lee lineas de n numeros reales positivos, maximiza y escribe el indice-posicion del maximo
* y el valor maximo en una lista KBM2L con el indice como respuesta y el maximo de la utilidad
* como como medida. 
* Una parte puede estar instanciada que se debe reflejar en la cabecera.
* scanner de tokens en las lineas del tabla.[tdu]
* @param eq30 esquema de la tabla de decision (semantica)
* @param tabla fichero de utilidades de las alternativas de la decision, 
* @param instancia del indice asocioado al esquema.
* @return lista
**/
public lista30 Tabla( esquema30 eq30, String tabla, Vector instancia) {

  long entradas = 0, t_old = 0, t_new = 0, hit = 0;//!!!!
  String linea = null; // linea del fichero
  boolean chk = new controlPrefs30().checkMode();
  boolean synthesis = true;
 
  if ( chk) kbm2lSystem.append( "Access table: " + dato30.extFile( tabla, "tdu") + "\n");
  BufferedReader in = dato30.openFile( tabla, "tdu");//!!!
  if ( in == null) {
    kbm2lSystem.append( "utilidad30 Tabla tdu?  \n");
    return null;    
   }

//prepara la estructura KBM30 con el esquema para una TDU, instancia.
//TABLAsDECISION ---> LISTA-KBM2L
  lista30 l30 = new lista30( eq30);//  l30.Esqu = eq30;//!!!    
  checkList30.chk( l30, ERROR + "Tabla-l30.");

  Vector Ix = new Vector();//contador para generar el indice en una tabla implicita
  Ix = index30.primeroT( l30.Base.Dom(), instancia);

  ALTERNATIVAS = ((Integer)eq30.CDDecisiones.get( 0)).intValue();
  
  try {
  linea = in.readLine();//rem
  if ( chk) kbm2lSystem.append( "remark0:   " + linea + ".\n");
  linea = in.readLine();//rem
  if ( chk) kbm2lSystem.append( "remark1:   " + linea + ".\n");
  //leer la tabla .tdu
  while (( linea = in.readLine()) != null) {

    linea = new String( linea.trim());
    if ( linea.charAt( 0) != ';') {//no es comentario

      Vector MEDIDA = new Vector();
      Vector RESPUESTA = new Vector();
      Vector INDICE = new Vector();

////// INDICE
      INDICE = index30.cpT( Ix);//Tabla-implicita 

      alternativaOptima( linea);//decision, maxima

//// MEDIDA, utilidad
       MEDIDA.add( new Double( maxima));//
//       MEDIDA.add( new Double( suboptima));//

//// RESPUESTA
       RESPUESTA.add( new Integer( decision));//decisiones del INDICE a RESPUESTA

    try {//Set
      Vector indice = base30.Trnp( null, INDICE, l30.Base);
      if ( chk) kbm2lSystem.append( "indice:    " + indice.toString() + ".\n");
      if ( chk) kbm2lSystem.append( "respuesta: " + RESPUESTA.toString() + ".\n");
      item30 item = new item30( l30, MEDIDA, RESPUESTA, indice);//!!! 

      t_old = l30.size();
      l30.Set( item);//!!! TABLA
      if ( chk) kbm2lSystem.append( "l30, KB: " + listStat30.KB( l30) + ".\n");
      t_new = l30.size();
      if (t_old == t_new) hit++;

      }//try
      catch (Exception e) {
        kbm2lSystem.append( ERROR + "Set. " + e + ", " +  
                            "\nMEASURE:" + MEDIDA.toString() + 
                            "\nRESPONSE:" + RESPUESTA.toString() + 
                            "\nINDEX:" + INDICE.toString()+"\n");
        for( int i = 0; i < l30.size(); i++) {
          kbm2lSystem.append( l30.GetIndice( i).toString()+"  ");
          kbm2lSystem.append( l30.GetRespuesta( i).toString()+"  ");
          kbm2lSystem.append( l30.GetMedida( i).toString()+"\n");
        }//for
        exit( 0, e);
       }//catch

    if (( entradas%10000) == 0) {
      kbm2lSystem.estatus(("INPUTS:" + entradas + "  List Length:" + l30.size()));
      
      }//if-entradas
      
    entradas++;

    if ( chk) {
      kbm2lSystem.estatus( "<" + entradas + ">");
      }

    if ( index30.eqT( Ix, index30.ultimoT( l30.Base.Dom(), instancia))) { break; }//while

   //nextIndice-Tabla implicita instanciada
    Ix = index30.siguienteT( l30.Base.Dom(), instancia, Ix);

      }//if - comentario en la tabla de utilidades
      else {
        if ( new controlPrefs30().verboseSystem()) {
          kbm2lSystem.append( "remark:   " + linea + ".\n");
          }
        }   
 }//while
  in.close(); 
  }//try
  catch (Exception e) {
    System.out.println( ERROR + "Table. " + "Line:" + entradas);
    System.out.println( "File: " + dato30.extFile( tabla, "tdu"));
    e.printStackTrace(); 
    System.exit(0);
  }//catch

  if ( new controlPrefs30().verboseSystem())
    kbm2lSystem.append( "Summary. Entries: " + entradas + 
      "  hits: " + hit + "  InstanciaDecision OK. items: " + l30.size() + ".\n");

  kbm2lControl.setText( kbm2lControl.ListName, l30.Name());
  kbm2lControl.setText( kbm2lControl.ListSize, String.valueOf( l30.size()));

  checkList30.chk( l30, ERROR + "utilidad30-Table");
  return l30;
}//Tabla

}//class utilidad30
