//EMPTYKBM2L30//
package tools;

//
import java.lang.Object.*;
import java.util.*;
import java.lang.*;
import java.io.*;
import java.math.*;
import java.awt.*;

//
import control.*;
import kernel.*;
import kbm2l.*;
import schema.*;

/**
* Clase emptykbm2l30, listas vacias.
* @author Juan A. Fdez del Pozo de Salamanca
* @version 3.0
**/
public class emptykbm2l30  extends  frame30  {

  private static final String ERROR = "Error(emptykbm2l30): ";

/**
* Constructor por defecto
**/
public emptykbm2l30( ) {

}//emptykbm2l30

/**
* Lista vacia. R=1, S=1, T, maxD
* @param T numero de atributos
* @param ds dominio de los atributos
* @return l30 lista30 vacia 
**/
public lista30  emptyList( int T, int ds) {

  lista30 l30 = null;
  f30.kbm2lTime.append( "empty list::  \n");

  if ( T <  2) T = 2;
  if ( ds < 2) ds = 2;

    try {//lista vacia de dimension T y ds modalidades de respuesta
      l30 = new lista30( "emptykbm2l-"+"base30-" + T, 1, 1, T, ds);//for T ?
    }//try
    catch (Exception e) {
      f30.kbm2lSystem.append( ERROR + "emptyList -- default.\n");
      frame30.exit( 0, e);
    }//catch
  f30.kbm2lTime.append( "KBM2L: " + l30.Name() + "  Size: " + listStat30.KB( l30).toString() + "\n");

  new controlPrefs30().onTopAttribute( 0);
  new controlPrefs30().onBotAttribute( l30.dimension()-1);

  return l30;
}//emptyList

/**
* Lista vacia.
* @param eq30 esquema30 para la lista vacia
* @return l30 lista30 vacia 
**/
public  lista30  emptyList( esquema30 eq30 ) {

  if ( eq30 == null) {
	 eq30 = new inputEsquema30( null).leerEq( "");
    if ( eq30 == null) {	  
//      f30.kbm2lSystem.append( ERROR + "emptyList -- schema eq30==null.\n");
  //    frame30.exit( 0);	  
      return emptyList( new controlPrefs30().onTopAttribute(), new controlPrefs30().onBotAttribute());
      }
	 }

  lista30 l30 = null;  
  try {//lista vacia de esquema eq30
    f30.kbm2lTime.append( "empty list::  " + eq30.nombre + "\n");
    l30 = new lista30( eq30);// 
    }//try
      catch (Exception e) {
        f30.kbm2lSystem.append( ERROR + "emptyList -- schema.\n");
        frame30.exit( 0, e);
    }//catch
  f30.kbm2lTime.append( "KBM2L: " + l30.Name() + "  Size: " + listStat30.KB( l30).toString() +"\n");

  new controlPrefs30().onTopAttribute( 0);
  new controlPrefs30().onBotAttribute( l30.dimension()-1);

  return l30;
}//emptyList

}//class emptykbm2l30
