//NEIGHBORHOOD30//
package tools;

//
import java.lang.Object.*;
import java.util.*;
import java.lang.*;
import java.io.*;
import java.math.*;
import java.awt.*;

//
import control.*;
import kernel.*;
import kbm2l.*;
import target.*;

/**
* Clase neighborhood30, analisis del vecindario de las bases.
* @author Juan A. Fdez del Pozo de Salamanca
* @version 3.0
**/
public class neighborhood30  extends  metrica30  {

  private static final String ERROR = "Error(neighborhood30): ";
  private static int r = -1;//radio del entorno

/**
* Constructor por defecto
**/
public neighborhood30( ) {

}//neigborhood30

/**
* 
**/
private boolean esta( Vector Entorno, base30 B) {

  for( int i = 0; i < Entorno.size(); i++) {
    if ( base30.eqB((base30)( Entorno.get( i)), B)) {
      return true;
      }//if
    }//for  
  
  return false;
}//esta

/**
* Todas(?) las bases a distancia Hamming igual a r (nRadius) de la base de l30.
* El entorno de radio r de la base de l30.
* El rango de distancias, minG y maxG.
* @see kbm2l30#dimension()
* @see base30#Bas()
* @see target30#swap2(base30,int,int)
* @see metrica30#H(base30,base30)
* @return Entorno vector de bases30 en el entorno r
**/
public  Vector neighborhood( lista30 l30) {
  
  long ts0 = (new Date()).getTime();

  r = new controlPrefs30().nRadius();

  f30.kbm2lSystem.append( "  >>> G[Hr]("+ l30.Base.Bas().toString() + "),  r: " + r + " \n");
  Vector Entorno = new Vector(); 
  int max_SZ_Entorno = l30.dimension()*(l30.Base.dom(0)+l30.Base.dom(1));
  Entorno.add( l30.Base);//add B0

  try { 
    lista30 aux = new lista30( l30);//cpy configuracion   
  for( int n = 0; n < Entorno.size(); n++) {

  if (!chk) if ( Entorno.size() > max_SZ_Entorno) break;
  
  try { 
    for( int i = 0; i < l30.dimension()-1; i++) {
      for( int j = i + 1; j < l30.dimension(); j++) {//  Hamming-2 de la base n del entorno
      aux.Base = new base30((base30)( Entorno.get( n)));//
      base30 B = target30.swap2( aux.Base, i, j);//
      if ( metrica30.H( l30.Base, B) <= r) {
        if ( !esta( Entorno, B)) {
	       double g = metrica30.G( l30.Base, B); 
          Entorno.add( new base30( B));
          f30.kbm2lSystem.estatus( "neighborhood: " + (Entorno.size()));
          }//if indexOf
        }//if H 
      }//for j
    }//for i
  }//try
  catch (Exception e) {
    kbm2lSystem.append( ERROR + "Neighborhood.for-ij\n");
    frame30.exit( 0);
  }//catch
   
   if ( new controlPrefs30().nBase()) {//extended base?
   try {
    for( int k = 0; k < l30.dimension(); k++) {
      
    for( int k_i = 0; k_i < (l30.Base.dom( k) - 1); k_i++) {
      for( int k_j = 1; k_j < (l30.Base.dom( k) - k_i); k_j++) {//  Hamming2
        aux.Base = new base30((base30)( Entorno.get( n)));//
        int a1 = aux.Base.bas( k);
        a1 = aux.Base.indexOfbas( a1);
        base30 B = target30.xswap2( aux.Base, a1, k_i, k_j);//
        if ( metrica30.H( l30.Base, B) <= r) {
          if ( !esta( Entorno, B)) {
   	      double g = metrica30.G( l30.Base, B); 
            Entorno.add( new base30( B));
            f30.kbm2lSystem.estatus( "X neighborhood: " + (Entorno.size() + "  k_i: " + k_i + "  k_j: " + k_j));
            }//if indexOf
          }//if H 
         if (!chk) if ( Entorno.size() > max_SZ_Entorno) break; 
         }//for-k_j
       }//for-k_i
     }//for-k
   }//try
  catch (Exception e) {
    kbm2lSystem.append( ERROR + "Neighborhood.for-k\n");
    frame30.exit( 0);
  }//catch
  }//if
   
  f30.kbm2lSystem.estatus( "Y neighborhood: " + (Entorno.size() + "  n: " + n));
  if ( r==2) break;//
  }//for n 

  }//try
  catch (Exception e) {
    kbm2lSystem.append( ERROR + "Neighborhood.for-k\n");
    frame30.exit( 0);
  }//catch

  if ( Entorno.size() < 100) {
    f30.kbm2lSystem.append( " <<<  neighborhood:\n"); 
    for( int i = 0; i < Entorno.size(); i++) {
	   base30 b30 = ((base30)Entorno.get( i));
      f30.kbm2lSystem.append( b30.Bas() + "\n");
      for( int j = 0; j < b30.size(); j++)
        f30.kbm2lSystem.append( b30.att( j) + ".\n");
      }
    }
  f30.kbm2lSystem.append( " <<<  neighborhood: " + (Entorno.size()) + ".\n");

  f30.kbm2lTime.append("Neighborhood:: " + (new Date().getTime() - ts0) + ".\n");      

  return Entorno;
}//neighborhood

/**
* Estudio del vecidario de radio Hamming r (nRadius) de la distancia G:
* rango de distancias G y test de axionmas metricos.
* @see emptykbm2l30#emptyList(esquema30) 
* @see control30#NRadius
* @see neighborhood30#neighborhood(lista30)
* @see metrica30#rango(Vector)
* @see metrica30#esDistancia(Vector)
* @return Vector de bases a distancia Hamming r 
**/
public  Vector NeighborhoodDistance( lista30 l30) {

  f30.kbm2lSystem.append( "NeighborhoodDistance: >>>  G[H2](B0)\n");

  r = new controlPrefs30().nRadius(); 

  f30.kbm2lSystem.append( "Radius: " + r + ".\n");

  if ( l30.Esqu == null)
    l30 = new emptykbm2l30().emptyList( 
      new controlPrefs30().randomDimension(), 
      new controlPrefs30().randomDomain());
    else l30 = new emptykbm2l30().emptyList( l30.Esqu);
    
  Vector E = neighborhood( l30);  
  Vector R = neighborhood30.rango( E);

  f30.kbm2lBrowser.setText("|E|: " + E.size() + ",  |R|: " +  R.size() + "\n");
  f30.kbm2lBrowser.append("|Neigh|/|Range|: " + (double)E.size() / (double)R.size()+ "\n");
  f30.kbm2lBrowser.append("Range(G): " + R.toString()+ "\n");
  f30.kbm2lBrowser.append("NeighDimension: " + l30.Base.size() + "\n");
  f30.kbm2lBrowser.append("B0: " + l30.Base.Bas().toString() + "\n");

  if ( metrica30.esDistancia( E)) 
    f30.kbm2lBrowser.append("G distancia OK.\n" );
    else f30.kbm2lBrowser.append("G NO NeighborhoodDistance.\n" );

  for( int i = 0; i < E.size(); i++) {
    base30 Bi = (base30)(E.get(i));
    f30.kbm2lBrowser.append( Bi.Bas().toString() + 
      ",  H:  " + metrica30.H( Bi, l30.Base) +
      ",  G:  " + metrica30.G( Bi, l30.Base) +
      ",  L1: " + metrica30.L1( Bi, l30.Base) +
      ",  L2: " + metrica30.L2( Bi, l30.Base) + "\n");
    }//for
  
  f30.kbm2lSystem.append( "  <<<  NeighborhoodDistance.\n");

  return E;
}//NeighborhoodDistance

/**
* Conjunto de distancias que se presentan en dos elementos del entorno de bases.
* @param Entorno vector de objetos bases30
* @return Rango vector de enteros ordenado, valor de distancia entre todas las bases del entorno.
**/
public  static  Vector rango( Vector Entorno) {
//distancias

  int Esz = Entorno.size();
  if ( Esz > 30) Esz = 30;
  Vector Rango = new Vector();  
  try {
  for( int i = 0; i < Esz-1; i++) {// o(n^2)
    base30 Bi = (base30)(Entorno.get(i));
    f30.kbm2lSystem.estatus( "rango: " + i);
    for( int j = i+1; j < Esz; j++) {//  Hamming2
      base30 Bj = (base30)(Entorno.get(j));      
      Double g = new Double( G( Bi, Bj));
      if ( Rango.indexOf( g) == -1) {
        int k = 0;
        for( k = 0; k < Rango.size(); k++) 
          if (((Double)Rango.get( k)).doubleValue() < g.doubleValue()) break;
        Rango.add( k, g);
        }        
    }//for
  }//for
  }//try
  catch (Exception e) {
    kbm2lSystem.append( ERROR + "rango.\n");
    frame30.exit( 0);
  }//catch

  int r = new controlPrefs30().range();
  if (( r == 0)||( r > Rango.size()))
    return Rango;
     else {
     Vector sRango = new Vector();
     for( int i = 0; i < Rango.size()-1; i++)
       if (( i % r) == 0) sRango.add( ((Double)Rango.get( i)));
     sRango.add( (Double)Rango.get( Rango.size()-1));  
     return sRango;  
   }
}//rango

}//class neighborhood30
