//RANDOMKBM2L30//
package tools;

//
import java.util.*;
import java.lang.*;
import java.io.*;
import java.math.*;

//
import control.*;
import kernel.*;
import kbm2l.*;
import target.*;

/**
* Clase radomkbm2l30, lista de contenido aleatorio
* @author Juan A. Fdez del Pozo de Salamanca
* @version 3.0
**/
public class randomkbm2l30  implements  Runnable  {

  private static final String ERROR = "Error(randomkbm2l30): ";
/**
* flag de ejecucion en curso
**/
  public static boolean working = false;

  private static int ds = 2;

/**
* constructor por defecto
**/
public randomkbm2l30( ) {

}//randomkbm2l30

/**
* 
**/
public Vector randomINDICE( lista30 l30) {

  Vector INDICE = null;
  INDICE = new Vector();// indice RANDOM
  try {
    for( int j = 0; j < l30.dimension(); j++) {  
      INDICE.add( new Integer( Math.abs( control30.gr.nextInt( l30.Base.dom( j)))));
      }//for
    }//try
    catch (Exception e) {
      System.out.println( ERROR + "rI");
      System.out.println( l30.Base.Dom().toString());
      frame30.exit( 0, e);
    }//catch

  return INDICE;
}//randomINDICE

public Vector randomINDICE( Vector INDICE, int a, lista30 l30) {

  try {
    for( int j = a; j < l30.dimension(); j++) {  
      INDICE.set( j, new Integer( Math.abs( control30.gr.nextInt( l30.Base.dom( j)))));
      }//for
    }//try
    catch (Exception e) {
      System.out.println( ERROR + "rI");
      System.out.println( l30.Base.Dom().toString());
      frame30.exit( 0, e);
    }//catch

  return INDICE;
}//randomINDICE

public Vector randomRESPUESTA( lista30 l30, int ds) {

  Vector RESPUESTA0 = null;
  if ( l30.size() > 0)
    RESPUESTA0 = l30.Get( l30.size()-1).GetRespuesta();
    else RESPUESTA0 = index30.unRespuesta( l30.ParRespuesta());
  Vector RESPUESTA = null;
  try {
    do {
      int s = 0;
      RESPUESTA = new Vector();// respuesta RANDOM
      for( int j = 0; j < l30.ParRespuesta(); j++) {  
          s = (new Integer( Math.abs( control30.gr.nextInt( ds+2)))).intValue() - 1;
          }
      RESPUESTA.add( new Integer( s));
      }//for
    while ( index30.eqS( RESPUESTA, RESPUESTA0));      
    }//try
    catch (Exception e) {
      System.out.println( ERROR + "rR");
      frame30.exit( 0, e);// salir
    }//catch

  return RESPUESTA;
}//randomRESPUESTA

public Vector randomMEDIDA( lista30 l30) {

  Vector MEDIDA = null;
  try {
    MEDIDA = new Vector();// medida RANDOM
    for( int j = 0; j < l30.ParMedida(); j++) {  
      int m = Math.abs( control30.gr.nextInt( 1 + l30.size()));
      MEDIDA.add( new Double( m));
      }//for
    }//try
    catch (Exception e) {
      System.out.println( ERROR + "rM");
      frame30.exit( 0, e);// salir
    }//catch

  return MEDIDA;
}//randomMEDIDA

/**
* kbm2l aleatoria.
**/
public lista30 random( ) {

  int numItemsVer = 0;
  int t = new controlPrefs30().randomDimension();
  int nItems = new controlPrefs30().randomnItems();
  ds = new controlPrefs30().randomDomain();
  control30.gr = new Random( new controlPrefs30().randomSeed());
  lista30 l30 = null;

  try {

    l30 = new lista30( new String( "RxKBM2Lx"+(t)), 
      1,//R-4
      1,//S-4
      t,//T, 8-40320
      ds) ;//MaxD

    }//try
    catch (Exception e) {
      System.out.println( ERROR + "f30.l30.");
      frame30.exit( 0, e);
    }//catch

  Vector WEIGHTS = listStat30.getWeights( l30);    
  BigInteger MAXOFFSET = 
    new offset30().offset( l30.Base.Dom(), index30.ultimoT( l30.Base.Dom()));

  working = true;
  l30.ini_();//SET <----
  while ( working && ( l30.size() < nItems)) {//SET

    Vector INDICE = null;
    try {
    if ( l30.size() == 0) {
      do {
        INDICE = offset30.index( l30, WEIGHTS, 
          new BigInteger((new Integer( 1 + Math.abs( control30.gr.nextInt( t*t)))).toString()));
      } while ( MAXOFFSET.compareTo( new offset30().offset( l30.Base.Dom(), INDICE)) == -1);  
      } else {
        INDICE = l30.Get( l30.size()-1).GetIndice();//
        BigInteger dif = null;
        int ctl = 0;
        do {
          dif = new BigInteger((new Integer( 1+Math.abs( control30.gr.nextInt(t*t)))).toString());
          if ( ctl++ > t) break;
        } while ( MAXOFFSET.compareTo( 
                    (new offset30().offset( l30.Base.Dom(), INDICE)).add( dif)) == -1 );
        if ( ctl++ > t) break;
        INDICE = offset30.index( l30, WEIGHTS, 
          (new offset30().offset( l30.Base.Dom(), INDICE)).add( dif));
       }//else
    }//try
    catch (Exception e) {
      System.out.println( ERROR + "r.1.1");
      frame30.exit( 0, e);
    }//catch

   if ( index30.eqT( index30.ultimoT( l30.Base.Dom()), INDICE)) { 
     working = false; break;}

    try {
      l30.SET( new item30( l30, randomMEDIDA( l30), randomRESPUESTA( l30, ds), INDICE)); //
      frame30.kbm2lSystem.estatus( 
        "SET: " + ( listStat30.KB( l30).toString()) + " | " + (l30.size()));//
    }//try
    catch (Exception e) {
      System.out.println( ERROR + "r.1");
      frame30.exit( 0, e);
    }//catch

    }//while

  l30.SET( new item30( l30, randomMEDIDA( l30), randomRESPUESTA( l30, ds), 
                           index30.ultimoT( l30.Base.Dom()))); //ULTIMO-INDICE

  long nKBCases = new controlPrefs30().KBCasesLengthOVF();
//unKB ---> huge items 
  for( int i = 0; i < l30.size(); i++) {
    if( !l30.esUNKB( l30.Get(i))) {
      if ( l30.Get(i).getLongitud().doubleValue() > (double)(nKBCases / l30.size())) {
        l30.REMOVE(i); i=0;
        }//if
      }//if  
    frame30.kbm2lSystem.estatus( "RandomKBM2L REMOVE huge items: " + 
      ( listStat30.KB( l30).toString()) + " | " + (l30.size()));//
    }//for 

  while ( working && ( l30.size() < 2 * nItems)) {//Set

    try {
      l30.Set( new item30( l30, 
                          randomMEDIDA( l30), randomRESPUESTA( l30, ds), randomINDICE( l30))); //
      frame30.kbm2lSystem.estatus( 
        "Set: " + ( listStat30.KB( l30).toString()) + " | " + (l30.size()));//
    }//try
    catch (Exception e) {
      System.out.println( ERROR + "r.2");
      frame30.exit( 0, e);
    }//catch

    }//while
    
  checkList30.chk( l30, "random.");//checks
//  listStat30.importanceAtt( l30);//
  frame30.kbm2lSystem.estatus( "RandomKBM2L: " + 
    ( listStat30.KB( l30).toString()) + " | " + (l30.size()));//

  working = false;
  return l30; 
}//random

/**
* run process: frame30.activel30 = random( );
**/
public void run() {

  if ( !working) {
  try {
    frame30.activel30 = random( );
  }//try
  catch (Exception e) {
    System.out.println( ERROR + "run().");
    frame30.exit( 0, e);
  }//catch
  }

  return;
}//run

}//class randomkbbm2l30
