//RULESKBM2L30//
package tools;

//
import java.lang.Object.*;
import java.util.*;
import java.lang.*;
import java.io.*;
import java.math.*;
import java.awt.*;

//
import control.*;
import kernel.*;
import kbm2l.*;
import schema.*;
import tables.*;

/**
* Clase ruleskbm2l30, listas vacias.
* @author Juan A. Fdez del Pozo de Salamanca
* @version 3.0
**/
public class ruleskbm2l30  extends  frame30  {

  private static final String ERROR = "Error(ruleskbm2l30): ";

/**
* Constructor por defecto
**/
public ruleskbm2l30( ) {

}//ruleskbm2l30

/**
* Lista vacia.
* @return l30 lista30 vacia 
**/
public  lista30  rulesList( esquema30 eq30 ) {

  lista30 l30 = new emptykbm2l30().emptyList( eq30);
  f30.kbm2lTime.append( "rules list::  " + eq30.nombre);
    
  f30.kbm2lTime.append( "KBM2L: " + l30.Name() + "  Size: " + listStat30.KB( l30).toString() + "\n");

  //res: att val att val....; rules file
  //leer la regla, construir un item e insertarlo.
  //base operativa de la regla.

  String rulesFile = null;
  BufferedReader in = null; // reglas
  String linea = null; // linea del fichero

  kbm2lSystem.append( "Rules. Select list: *.rls - .\n");
  String filename = dato30.selectFile( f30.kbm2lSystem.frame, FileDialog.LOAD, "*.ipd");
  if ( filename == null) {
      kbm2lSystem.append("Rules list not readed.\n");
      return null;
      }
    rulesFile = new String( filename);
    kbm2lSystem.append( "Rules. Listx: - " + rulesFile + ".\n");
    
  if (( rulesFile == "")||( rulesFile == null)) {
    kbm2lSystem.append("Potocolo Index no readed.\n");
    return null;
    } else
      kbm2lSystem.append( "\nProtocol. Index: - " + rulesFile + ".\n");

  in = dato30.openFile( dato30.nameFile( rulesFile), "rls");

  try {//

    Vector INDICE = new Vector();
    Vector RESPUESTA  = new Vector();
    Vector MEDIDA = new Vector();

  while (( linea = in.readLine()) != null) {
    linea = new String( linea.trim());
    if ( linea.charAt( 0) == ';') {//es comentario
      if ( new controlPrefs30().verboseSystem()) {
        kbm2lSystem.append( "remark:   " + linea + ".\n");
        }//if
      }//if  
      else {//int,,int int int ({res}* {att val}*); posible respuesta multiple	      
        linea = linea.substring( 0,linea.indexOf(';')).trim();//comentario
        
        for( int i = 0; i < l30.ParRespuesta(); i++) {
          int vr = -1;
          
          }
        Integer DimParam = new Integer( linea.trim());
        kbm2lSystem.append( ": " + ".\n");
        }//if
  }//while
  in.close(); 

  }//try
  catch (Exception e) {
    System.out.println( ERROR + "rulesList: " + linea + ".");
    e.printStackTrace(); 
    frame30.exit( 0, e);
  }//catch

  return l30;
}//rulesList

}//class ruleskbm2l30
