//SETBASE30//
package tools;

//
import java.util.*;
import java.lang.*;
import java.io.*;
import java.math.*;

//
import control.*;
import kernel.*;
import kbm2l.*;
import target.*;
import tables.*;

/**
* Clase setBase30: lista en una base nueva. 
**/
public class setBase30  implements  Runnable  {

  private static final String ERROR = "Error(setBase30): ";
/**
* flag de ejecucion en curso
**/
  public static boolean working = false;

/**
* Constructor por defecto
**/
public setBase30( ) {

}//setBasel30

/**
* @return la lista con la base especificada
**/
public lista30 set( lista30 l30) {

  working = true;
  BigInteger KBl30 = listStat30.KB( l30);
  BigInteger KBlTarget = null;
  lista30 lTarget = null;
  lTarget = new lista30( l30);// copia

  Vector Orden = new Vector();
  for( int i = 0; i < l30.dimension(); i++) Orden.add( new Integer( i));

  if ( l30.dimension() >  0) Orden.set(  0, new Integer(  0));   
  if ( l30.dimension() >  1) Orden.set(  1, new Integer(  1));     
  if ( l30.dimension() >  2) Orden.set(  2, new Integer(  2));   
  if ( l30.dimension() >  3) Orden.set(  3, new Integer(  3));   
  if ( l30.dimension() >  4) Orden.set(  4, new Integer(  4));   
  if ( l30.dimension() >  5) Orden.set(  5, new Integer(  5));   
  if ( l30.dimension() >  6) Orden.set(  6, new Integer(  6));   
  if ( l30.dimension() >  7) Orden.set(  7, new Integer(  7));   
  if ( l30.dimension() >  8) Orden.set(  8, new Integer(  8));   
  if ( l30.dimension() >  9) Orden.set(  9, new Integer(  9));   
  if ( l30.dimension() > 10) Orden.set( 10, new Integer( 10));   
  if ( l30.dimension() > 11) Orden.set( 11, new Integer( 11));   
  if ( l30.dimension() > 12) Orden.set( 12, new Integer( 12));   
  if ( l30.dimension() > 13) Orden.set( 13, new Integer( 13));   
  if ( l30.dimension() > 14) Orden.set( 14, new Integer( 14));   
  if ( l30.dimension() > 15) Orden.set( 15, new Integer( 15));   
  if ( l30.dimension() > 16) Orden.set( 16, new Integer( 16));   
  if ( l30.dimension() > 17) Orden.set( 17, new Integer( 17));   
  if ( l30.dimension() > 18) Orden.set( 18, new Integer( 18));   
  if ( l30.dimension() > 19) Orden.set( 19, new Integer( 25));//   
  if ( l30.dimension() > 20) Orden.set( 20, new Integer( 23));//   
  if ( l30.dimension() > 21) Orden.set( 21, new Integer( 22));//   
  if ( l30.dimension() > 22) Orden.set( 22, new Integer( 24));//   
  if ( l30.dimension() > 23) Orden.set( 23, new Integer( 26));//   
  if ( l30.dimension() > 24) Orden.set( 24, new Integer( 21));//   
  if ( l30.dimension() > 25) Orden.set( 25, new Integer( 19));//   
  if ( l30.dimension() > 26) Orden.set( 26, new Integer( 20));//   
  if ( l30.dimension() > 27) Orden.set( 27, new Integer( 27));   
  if ( l30.dimension() > 28) Orden.set( 28, new Integer( 28));   
  if ( l30.dimension() > 29) Orden.set( 29, new Integer( 29));   
  if ( l30.dimension() > 30) Orden.set( 30, new Integer( 30));   
  if ( l30.dimension() > 31) Orden.set( 31, new Integer( 31));   
  if ( l30.dimension() > 32) Orden.set( 32, new Integer( 32));   
  if ( l30.dimension() > 33) Orden.set( 23, new Integer( 33));   
  if ( l30.dimension() > 34) Orden.set( 24, new Integer( 34));   
  if ( l30.dimension() > 35) Orden.set( 25, new Integer( 35));   
  if ( l30.dimension() > 36) Orden.set( 26, new Integer( 36));   
  if ( l30.dimension() > 37) Orden.set( 27, new Integer( 37));   
  if ( l30.dimension() > 38) Orden.set( 28, new Integer( 38));   
  if ( l30.dimension() > 39) Orden.set( 29, new Integer( 39));   
  if ( l30.dimension() > 40) Orden.set( 30, new Integer( 40));   
  if ( l30.dimension() > 41) Orden.set( 31, new Integer( 41));   
  if ( l30.dimension() > 42) Orden.set( 32, new Integer( 42));   
  if ( l30.dimension() > 43) Orden.set( 23, new Integer( 43));   
  if ( l30.dimension() > 44) Orden.set( 24, new Integer( 44));   
  if ( l30.dimension() > 45) Orden.set( 25, new Integer( 45));   
  if ( l30.dimension() > 46) Orden.set( 26, new Integer( 46));   
  if ( l30.dimension() > 47) Orden.set( 27, new Integer( 47));   
  if ( l30.dimension() > 48) Orden.set( 28, new Integer( 48));   
  if ( l30.dimension() > 49) Orden.set( 29, new Integer( 49));   
  if ( l30.dimension() > 50) Orden.set( 30, new Integer( 50));   
  if ( l30.dimension() > 51) Orden.set( 31, new Integer( 51));   
  if ( l30.dimension() > 52) Orden.set( 32, new Integer( 52));   
  if ( l30.dimension() > 53) Orden.set( 23, new Integer( 53));   
  if ( l30.dimension() > 54) Orden.set( 24, new Integer( 54));   
  if ( l30.dimension() > 55) Orden.set( 25, new Integer( 55));   
  if ( l30.dimension() > 56) Orden.set( 26, new Integer( 56));   
  if ( l30.dimension() > 57) Orden.set( 27, new Integer( 57));   
  if ( l30.dimension() > 58) Orden.set( 28, new Integer( 58));   
  if ( l30.dimension() > 59) Orden.set( 29, new Integer( 59));   
  if ( l30.dimension() > 60) Orden.set( 30, new Integer( 60));   
  if ( l30.dimension() > 61) Orden.set( 31, new Integer( 61));   
  if ( l30.dimension() > 62) Orden.set( 32, new Integer( 62));   
  if ( l30.dimension() > 63) Orden.set( 23, new Integer( 63));   
  if ( l30.dimension() > 64) Orden.set( 24, new Integer( 44));   
  if ( l30.dimension() > 65) Orden.set( 25, new Integer( 65));   
  if ( l30.dimension() > 66) Orden.set( 26, new Integer( 66));   
  if ( l30.dimension() > 67) Orden.set( 27, new Integer( 67));   
  if ( l30.dimension() > 68) Orden.set( 28, new Integer( 68));   
  if ( l30.dimension() > 69) Orden.set( 29, new Integer( 69));   
  if ( l30.dimension() > 70) Orden.set( 30, new Integer( 70));   
  if ( l30.dimension() > 71) Orden.set( 31, new Integer( 71));   
  if ( l30.dimension() > 72) Orden.set( 32, new Integer( 72));   
  if ( l30.dimension() > 73) Orden.set( 23, new Integer( 73));   
  if ( l30.dimension() > 74) Orden.set( 24, new Integer( 74));   
  if ( l30.dimension() > 75) Orden.set( 25, new Integer( 75));   
  if ( l30.dimension() > 76) Orden.set( 26, new Integer( 76));   
  if ( l30.dimension() > 77) Orden.set( 27, new Integer( 77));   
  if ( l30.dimension() > 78) Orden.set( 28, new Integer( 78));   
  if ( l30.dimension() > 79) Orden.set( 29, new Integer( 79));   
  if ( l30.dimension() > 80) Orden.set( 30, new Integer( 80));   
  if ( l30.dimension() > 81) Orden.set( 31, new Integer( 81));   
  if ( l30.dimension() > 82) Orden.set( 32, new Integer( 82));   
  if ( l30.dimension() > 83) Orden.set( 23, new Integer( 83));   
  if ( l30.dimension() > 84) Orden.set( 24, new Integer( 84));   
  if ( l30.dimension() > 85) Orden.set( 25, new Integer( 85));   
  if ( l30.dimension() > 86) Orden.set( 26, new Integer( 86));   
  if ( l30.dimension() > 87) Orden.set( 27, new Integer( 87));   
  if ( l30.dimension() > 88) Orden.set( 28, new Integer( 88));   
  if ( l30.dimension() > 89) Orden.set( 29, new Integer( 89));   
  if ( l30.dimension() > 90) Orden.set( 30, new Integer( 90));   
  if ( l30.dimension() > 91) Orden.set( 31, new Integer( 91));   
  if ( l30.dimension() > 92) Orden.set( 32, new Integer( 92));   
  if ( l30.dimension() > 93) Orden.set( 23, new Integer( 93));   
  if ( l30.dimension() > 94) Orden.set( 24, new Integer( 94));   
  if ( l30.dimension() > 95) Orden.set( 25, new Integer( 95));   
  if ( l30.dimension() > 96) Orden.set( 26, new Integer( 96));   
  if ( l30.dimension() > 97) Orden.set( 27, new Integer( 97));   
  if ( l30.dimension() > 98) Orden.set( 28, new Integer( 98));   
  if ( l30.dimension() > 99) Orden.set( 29, new Integer( 99));   
  
  lTarget.Base = target30.swap( lTarget.Base, Orden);
  lTarget.ini();

  lTarget.Name( new String( "s-" + l30.Name()));

  System.out.println( "set: " + lTarget.Base.Bas());
    
  l30.union( lTarget);  
  if ( lTarget == null) {
    System.out.println( ERROR + "set.1");
    System.exit( 0);
    }//if

  KBlTarget = listStat30.KB( lTarget);
  if ( KBlTarget.compareTo( KBl30) != 0) {
    System.out.println( ERROR + "set.2 " + KBlTarget+ " = KBTarget!=KBl30 = " + KBl30);
    return l30;
    //System.exit( 0);
    }//if

  l30 = lTarget;  
  checkList30.chk( l30, "set.");//checks
//  listStat30.importanceAtt( l30);//
  frame30.kbm2lSystem.estatus("set. size: " + 
    listStat30.KB( l30).toString() + " | "+ l30.size());
  working = false;
  return l30;
}//set

/**
* run process: frame30.activel30 = set( frame30.activel30);
**/
public void run() {

  if ( !working) {
  try {
    long ts0 = (new Date()).getTime();
    frame30.activel30 = set( frame30.activel30);
    frame30.kbm2lTime.append("set:: " + (new Date().getTime() - ts0) + ".\n");      
  }//try
  catch (Exception e) {
    System.out.println( ERROR + "run().");
    e.printStackTrace();
    System.exit( 0);
  }//catch
  }

  return;
}//run

}//class setBasel30
